// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/AccelerationCartesian.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ACCELERATION_CARTESIAN__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ACCELERATION_CARTESIAN__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'x_acceleration'
// Member 'y_acceleration'
// Member 'z_acceleration'
#include "etsi_its_cpm_ts_msgs/msg/detail/acceleration_component__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__AccelerationCartesian __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__AccelerationCartesian __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AccelerationCartesian_
{
  using Type = AccelerationCartesian_<ContainerAllocator>;

  explicit AccelerationCartesian_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : x_acceleration(_init),
    y_acceleration(_init),
    z_acceleration(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->z_acceleration_is_present = false;
    }
  }

  explicit AccelerationCartesian_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : x_acceleration(_alloc, _init),
    y_acceleration(_alloc, _init),
    z_acceleration(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->z_acceleration_is_present = false;
    }
  }

  // field types and members
  using _x_acceleration_type =
    etsi_its_cpm_ts_msgs::msg::AccelerationComponent_<ContainerAllocator>;
  _x_acceleration_type x_acceleration;
  using _y_acceleration_type =
    etsi_its_cpm_ts_msgs::msg::AccelerationComponent_<ContainerAllocator>;
  _y_acceleration_type y_acceleration;
  using _z_acceleration_type =
    etsi_its_cpm_ts_msgs::msg::AccelerationComponent_<ContainerAllocator>;
  _z_acceleration_type z_acceleration;
  using _z_acceleration_is_present_type =
    bool;
  _z_acceleration_is_present_type z_acceleration_is_present;

  // setters for named parameter idiom
  Type & set__x_acceleration(
    const etsi_its_cpm_ts_msgs::msg::AccelerationComponent_<ContainerAllocator> & _arg)
  {
    this->x_acceleration = _arg;
    return *this;
  }
  Type & set__y_acceleration(
    const etsi_its_cpm_ts_msgs::msg::AccelerationComponent_<ContainerAllocator> & _arg)
  {
    this->y_acceleration = _arg;
    return *this;
  }
  Type & set__z_acceleration(
    const etsi_its_cpm_ts_msgs::msg::AccelerationComponent_<ContainerAllocator> & _arg)
  {
    this->z_acceleration = _arg;
    return *this;
  }
  Type & set__z_acceleration_is_present(
    const bool & _arg)
  {
    this->z_acceleration_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::AccelerationCartesian_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::AccelerationCartesian_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationCartesian_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationCartesian_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::AccelerationCartesian_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationCartesian_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::AccelerationCartesian_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationCartesian_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationCartesian_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationCartesian_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__AccelerationCartesian
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationCartesian_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__AccelerationCartesian
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationCartesian_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AccelerationCartesian_ & other) const
  {
    if (this->x_acceleration != other.x_acceleration) {
      return false;
    }
    if (this->y_acceleration != other.y_acceleration) {
      return false;
    }
    if (this->z_acceleration != other.z_acceleration) {
      return false;
    }
    if (this->z_acceleration_is_present != other.z_acceleration_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const AccelerationCartesian_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AccelerationCartesian_

// alias to use template instance with default allocator
using AccelerationCartesian =
  etsi_its_cpm_ts_msgs::msg::AccelerationCartesian_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ACCELERATION_CARTESIAN__STRUCT_HPP_
