// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/AccelerationMagnitude.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ACCELERATION_MAGNITUDE__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ACCELERATION_MAGNITUDE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'acceleration_magnitude_value'
#include "etsi_its_cpm_ts_msgs/msg/detail/acceleration_magnitude_value__struct.hpp"
// Member 'acceleration_confidence'
#include "etsi_its_cpm_ts_msgs/msg/detail/acceleration_confidence__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__AccelerationMagnitude __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__AccelerationMagnitude __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AccelerationMagnitude_
{
  using Type = AccelerationMagnitude_<ContainerAllocator>;

  explicit AccelerationMagnitude_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : acceleration_magnitude_value(_init),
    acceleration_confidence(_init)
  {
    (void)_init;
  }

  explicit AccelerationMagnitude_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : acceleration_magnitude_value(_alloc, _init),
    acceleration_confidence(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _acceleration_magnitude_value_type =
    etsi_its_cpm_ts_msgs::msg::AccelerationMagnitudeValue_<ContainerAllocator>;
  _acceleration_magnitude_value_type acceleration_magnitude_value;
  using _acceleration_confidence_type =
    etsi_its_cpm_ts_msgs::msg::AccelerationConfidence_<ContainerAllocator>;
  _acceleration_confidence_type acceleration_confidence;

  // setters for named parameter idiom
  Type & set__acceleration_magnitude_value(
    const etsi_its_cpm_ts_msgs::msg::AccelerationMagnitudeValue_<ContainerAllocator> & _arg)
  {
    this->acceleration_magnitude_value = _arg;
    return *this;
  }
  Type & set__acceleration_confidence(
    const etsi_its_cpm_ts_msgs::msg::AccelerationConfidence_<ContainerAllocator> & _arg)
  {
    this->acceleration_confidence = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__AccelerationMagnitude
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__AccelerationMagnitude
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AccelerationMagnitude_ & other) const
  {
    if (this->acceleration_magnitude_value != other.acceleration_magnitude_value) {
      return false;
    }
    if (this->acceleration_confidence != other.acceleration_confidence) {
      return false;
    }
    return true;
  }
  bool operator!=(const AccelerationMagnitude_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AccelerationMagnitude_

// alias to use template instance with default allocator
using AccelerationMagnitude =
  etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ACCELERATION_MAGNITUDE__STRUCT_HPP_
