// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/AccelerationPolarWithZ.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/acceleration_polar_with_z__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `acceleration_magnitude`
#include "etsi_its_cpm_ts_msgs/msg/detail/acceleration_magnitude__functions.h"
// Member `acceleration_direction`
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__functions.h"
// Member `z_acceleration`
#include "etsi_its_cpm_ts_msgs/msg/detail/acceleration_component__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__init(etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ * msg)
{
  if (!msg) {
    return false;
  }
  // acceleration_magnitude
  if (!etsi_its_cpm_ts_msgs__msg__AccelerationMagnitude__init(&msg->acceleration_magnitude)) {
    etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__fini(msg);
    return false;
  }
  // acceleration_direction
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__init(&msg->acceleration_direction)) {
    etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__fini(msg);
    return false;
  }
  // z_acceleration
  if (!etsi_its_cpm_ts_msgs__msg__AccelerationComponent__init(&msg->z_acceleration)) {
    etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__fini(msg);
    return false;
  }
  // z_acceleration_is_present
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__fini(etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ * msg)
{
  if (!msg) {
    return;
  }
  // acceleration_magnitude
  etsi_its_cpm_ts_msgs__msg__AccelerationMagnitude__fini(&msg->acceleration_magnitude);
  // acceleration_direction
  etsi_its_cpm_ts_msgs__msg__CartesianAngle__fini(&msg->acceleration_direction);
  // z_acceleration
  etsi_its_cpm_ts_msgs__msg__AccelerationComponent__fini(&msg->z_acceleration);
  // z_acceleration_is_present
}

bool
etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__are_equal(const etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ * lhs, const etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // acceleration_magnitude
  if (!etsi_its_cpm_ts_msgs__msg__AccelerationMagnitude__are_equal(
      &(lhs->acceleration_magnitude), &(rhs->acceleration_magnitude)))
  {
    return false;
  }
  // acceleration_direction
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__are_equal(
      &(lhs->acceleration_direction), &(rhs->acceleration_direction)))
  {
    return false;
  }
  // z_acceleration
  if (!etsi_its_cpm_ts_msgs__msg__AccelerationComponent__are_equal(
      &(lhs->z_acceleration), &(rhs->z_acceleration)))
  {
    return false;
  }
  // z_acceleration_is_present
  if (lhs->z_acceleration_is_present != rhs->z_acceleration_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__copy(
  const etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ * input,
  etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ * output)
{
  if (!input || !output) {
    return false;
  }
  // acceleration_magnitude
  if (!etsi_its_cpm_ts_msgs__msg__AccelerationMagnitude__copy(
      &(input->acceleration_magnitude), &(output->acceleration_magnitude)))
  {
    return false;
  }
  // acceleration_direction
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__copy(
      &(input->acceleration_direction), &(output->acceleration_direction)))
  {
    return false;
  }
  // z_acceleration
  if (!etsi_its_cpm_ts_msgs__msg__AccelerationComponent__copy(
      &(input->z_acceleration), &(output->z_acceleration)))
  {
    return false;
  }
  // z_acceleration_is_present
  output->z_acceleration_is_present = input->z_acceleration_is_present;
  return true;
}

etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ *
etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ * msg = (etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ));
  bool success = etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__destroy(etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence__init(etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence__fini(etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence *
etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence * array = (etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ * data =
      (etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
