// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from etsi_its_cpm_ts_msgs:msg/AccelerationPolarWithZ.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "etsi_its_cpm_ts_msgs/msg/detail/acceleration_polar_with_z__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void AccelerationPolarWithZ_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ(_init);
}

void AccelerationPolarWithZ_fini_function(void * message_memory)
{
  auto typed_message = static_cast<etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ *>(message_memory);
  typed_message->~AccelerationPolarWithZ();
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember AccelerationPolarWithZ_message_member_array[4] = {
  {
    "acceleration_magnitude",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ, acceleration_magnitude),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "acceleration_direction",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<etsi_its_cpm_ts_msgs::msg::CartesianAngle>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ, acceleration_direction),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "z_acceleration",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<etsi_its_cpm_ts_msgs::msg::AccelerationComponent>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ, z_acceleration),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "z_acceleration_is_present",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_BOOLEAN,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ, z_acceleration_is_present),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers AccelerationPolarWithZ_message_members = {
  "etsi_its_cpm_ts_msgs::msg",  // message namespace
  "AccelerationPolarWithZ",  // message name
  4,  // number of fields
  sizeof(etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ),
  AccelerationPolarWithZ_message_member_array,  // message members
  AccelerationPolarWithZ_init_function,  // function to initialize message memory (memory has to be allocated)
  AccelerationPolarWithZ_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t AccelerationPolarWithZ_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &AccelerationPolarWithZ_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ>()
{
  return &::etsi_its_cpm_ts_msgs::msg::rosidl_typesupport_introspection_cpp::AccelerationPolarWithZ_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, etsi_its_cpm_ts_msgs, msg, AccelerationPolarWithZ)() {
  return &::etsi_its_cpm_ts_msgs::msg::rosidl_typesupport_introspection_cpp::AccelerationPolarWithZ_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
