// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/Altitude.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ALTITUDE__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ALTITUDE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'altitude_value'
#include "etsi_its_cpm_ts_msgs/msg/detail/altitude_value__struct.hpp"
// Member 'altitude_confidence'
#include "etsi_its_cpm_ts_msgs/msg/detail/altitude_confidence__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__Altitude __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__Altitude __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Altitude_
{
  using Type = Altitude_<ContainerAllocator>;

  explicit Altitude_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : altitude_value(_init),
    altitude_confidence(_init)
  {
    (void)_init;
  }

  explicit Altitude_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : altitude_value(_alloc, _init),
    altitude_confidence(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _altitude_value_type =
    etsi_its_cpm_ts_msgs::msg::AltitudeValue_<ContainerAllocator>;
  _altitude_value_type altitude_value;
  using _altitude_confidence_type =
    etsi_its_cpm_ts_msgs::msg::AltitudeConfidence_<ContainerAllocator>;
  _altitude_confidence_type altitude_confidence;

  // setters for named parameter idiom
  Type & set__altitude_value(
    const etsi_its_cpm_ts_msgs::msg::AltitudeValue_<ContainerAllocator> & _arg)
  {
    this->altitude_value = _arg;
    return *this;
  }
  Type & set__altitude_confidence(
    const etsi_its_cpm_ts_msgs::msg::AltitudeConfidence_<ContainerAllocator> & _arg)
  {
    this->altitude_confidence = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::Altitude_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::Altitude_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::Altitude_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::Altitude_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::Altitude_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::Altitude_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::Altitude_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::Altitude_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::Altitude_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::Altitude_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__Altitude
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::Altitude_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__Altitude
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::Altitude_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Altitude_ & other) const
  {
    if (this->altitude_value != other.altitude_value) {
      return false;
    }
    if (this->altitude_confidence != other.altitude_confidence) {
      return false;
    }
    return true;
  }
  bool operator!=(const Altitude_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Altitude_

// alias to use template instance with default allocator
using Altitude =
  etsi_its_cpm_ts_msgs::msg::Altitude_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ALTITUDE__STRUCT_HPP_
