// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/AltitudeConfidence.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ALTITUDE_CONFIDENCE__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ALTITUDE_CONFIDENCE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'ALT_000_01'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__ALT_000_01 = 0
};

/// Constant 'ALT_000_02'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__ALT_000_02 = 1
};

/// Constant 'ALT_000_05'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__ALT_000_05 = 2
};

/// Constant 'ALT_000_10'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__ALT_000_10 = 3
};

/// Constant 'ALT_000_20'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__ALT_000_20 = 4
};

/// Constant 'ALT_000_50'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__ALT_000_50 = 5
};

/// Constant 'ALT_001_00'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__ALT_001_00 = 6
};

/// Constant 'ALT_002_00'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__ALT_002_00 = 7
};

/// Constant 'ALT_005_00'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__ALT_005_00 = 8
};

/// Constant 'ALT_010_00'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__ALT_010_00 = 9
};

/// Constant 'ALT_020_00'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__ALT_020_00 = 10
};

/// Constant 'ALT_050_00'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__ALT_050_00 = 11
};

/// Constant 'ALT_100_00'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__ALT_100_00 = 12
};

/// Constant 'ALT_200_00'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__ALT_200_00 = 13
};

/// Constant 'OUT_OF_RANGE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__OUT_OF_RANGE = 14
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__UNAVAILABLE = 15
};

/// Struct defined in msg/AltitudeConfidence in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__AltitudeConfidence
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the altitude confidence value which represents the estimated absolute accuracy of an altitude value of a geographical point with a default confidence level of 95 %.
  ///  * If required, the confidence level can be defined by the corresponding standards applying this DE.
  ///  *
  ///  * The value shall be set to:
  ///  *   - 0  - `alt-000-01`   - if the confidence value is equal to or less than 0,01 metre,
  ///  *   - 1  - `alt-000-02`   - if the confidence value is equal to or less than 0,02 metre and greater than 0,01 metre,
  ///  *   - 2  - `alt-000-05`   - if the confidence value is equal to or less than 0,05 metre and greater than 0,02 metre,
  ///  *   - 3  - `alt-000-10`   - if the confidence value is equal to or less than 0,1 metre and greater than 0,05 metre,
  ///  *   - 4  - `alt-000-20`   - if the confidence value is equal to or less than 0,2 metre and greater than 0,1 metre,
  ///  *   - 5  - `alt-000-50`   - if the confidence value is equal to or less than 0,5 metre and greater than 0,2 metre,
  ///  *   - 6  - `alt-001-00`   - if the confidence value is equal to or less than 1 metre and greater than 0,5 metre,
  ///  *   - 7  - `alt-002-00`   - if the confidence value is equal to or less than 2 metres and greater than 1 metre,
  ///  *   - 8  - `alt-005-00`   - if the confidence value is equal to or less than 5 metres and greater than 2 metres,
  ///  *   - 9  - `alt-010-00`   - if the confidence value is equal to or less than 10 metres and greater than 5 metres,
  ///  *   - 10 - `alt-020-00`   - if the confidence value is equal to or less than 20 metres and greater than 10 metres,
  ///  *   - 11 - `alt-050-00`   - if the confidence value is equal to or less than 50 metres and greater than 20 metres,
  ///  *   - 12 - `alt-100-00`   - if the confidence value is equal to or less than 100 metres and greater than 50 metres,
  ///  *   - 13 - `alt-200-00`   - if the confidence value is equal to or less than 200 metres and greater than 100 metres,
  ///  *   - 14 - `outOfRange`   - if the confidence value is out of range, i.e. greater than 200 metres,
  ///  *   - 15 - `unavailable`  - if the confidence value is unavailable.
  ///  *
  ///  * @note: The fact that an altitude value is received with confidence value set to `unavailable(15)` can be caused
  ///  * by several reasons, such as:
  ///  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
  ///  * - the sensor cannot calculate the accuracy due to lack of variables, or
  ///  * - there has been a vehicle bus (e.g. CAN bus) error.
  ///  * In all 3 cases above, the altitude value may be valid and used by the application.
  ///  *
  ///  * @note: If an altitude value is received and its confidence value is set to `outOfRange(14)`, it means that the
  ///  * altitude value is not valid and therefore cannot be trusted. Such value is not useful for the application.
  ///  *
  ///  * @category: GeoReference information
  ///  * @revision: Description revised in V2.1.1
  ///  */
  /// AltitudeConfidence ::= ENUMERATED {
  ///     alt-000-01  (0),
  ///     alt-000-02  (1),
  ///     alt-000-05  (2),
  ///     alt-000-10  (3),
  ///     alt-000-20  (4),
  ///     alt-000-50  (5),
  ///     alt-001-00  (6),
  ///     alt-002-00  (7),
  ///     alt-005-00  (8),
  ///     alt-010-00  (9),
  ///     alt-020-00  (10),
  ///     alt-050-00  (11),
  ///     alt-100-00  (12),
  ///     alt-200-00  (13),
  ///     outOfRange  (14),
  ///     unavailable (15)
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cpm_ts_msgs__msg__AltitudeConfidence;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__AltitudeConfidence.
typedef struct etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__Sequence
{
  etsi_its_cpm_ts_msgs__msg__AltitudeConfidence * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__AltitudeConfidence__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ALTITUDE_CONFIDENCE__STRUCT_H_
