// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/CartesianPosition3dWithConfidence.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CARTESIAN_POSITION3D_WITH_CONFIDENCE__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CARTESIAN_POSITION3D_WITH_CONFIDENCE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'x_coordinate'
// Member 'y_coordinate'
// Member 'z_coordinate'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_coordinate_with_confidence__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__CartesianPosition3dWithConfidence __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__CartesianPosition3dWithConfidence __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CartesianPosition3dWithConfidence_
{
  using Type = CartesianPosition3dWithConfidence_<ContainerAllocator>;

  explicit CartesianPosition3dWithConfidence_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : x_coordinate(_init),
    y_coordinate(_init),
    z_coordinate(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->z_coordinate_is_present = false;
    }
  }

  explicit CartesianPosition3dWithConfidence_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : x_coordinate(_alloc, _init),
    y_coordinate(_alloc, _init),
    z_coordinate(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->z_coordinate_is_present = false;
    }
  }

  // field types and members
  using _x_coordinate_type =
    etsi_its_cpm_ts_msgs::msg::CartesianCoordinateWithConfidence_<ContainerAllocator>;
  _x_coordinate_type x_coordinate;
  using _y_coordinate_type =
    etsi_its_cpm_ts_msgs::msg::CartesianCoordinateWithConfidence_<ContainerAllocator>;
  _y_coordinate_type y_coordinate;
  using _z_coordinate_type =
    etsi_its_cpm_ts_msgs::msg::CartesianCoordinateWithConfidence_<ContainerAllocator>;
  _z_coordinate_type z_coordinate;
  using _z_coordinate_is_present_type =
    bool;
  _z_coordinate_is_present_type z_coordinate_is_present;

  // setters for named parameter idiom
  Type & set__x_coordinate(
    const etsi_its_cpm_ts_msgs::msg::CartesianCoordinateWithConfidence_<ContainerAllocator> & _arg)
  {
    this->x_coordinate = _arg;
    return *this;
  }
  Type & set__y_coordinate(
    const etsi_its_cpm_ts_msgs::msg::CartesianCoordinateWithConfidence_<ContainerAllocator> & _arg)
  {
    this->y_coordinate = _arg;
    return *this;
  }
  Type & set__z_coordinate(
    const etsi_its_cpm_ts_msgs::msg::CartesianCoordinateWithConfidence_<ContainerAllocator> & _arg)
  {
    this->z_coordinate = _arg;
    return *this;
  }
  Type & set__z_coordinate_is_present(
    const bool & _arg)
  {
    this->z_coordinate_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::CartesianPosition3dWithConfidence_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::CartesianPosition3dWithConfidence_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::CartesianPosition3dWithConfidence_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::CartesianPosition3dWithConfidence_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::CartesianPosition3dWithConfidence_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::CartesianPosition3dWithConfidence_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::CartesianPosition3dWithConfidence_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::CartesianPosition3dWithConfidence_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::CartesianPosition3dWithConfidence_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::CartesianPosition3dWithConfidence_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__CartesianPosition3dWithConfidence
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::CartesianPosition3dWithConfidence_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__CartesianPosition3dWithConfidence
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::CartesianPosition3dWithConfidence_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CartesianPosition3dWithConfidence_ & other) const
  {
    if (this->x_coordinate != other.x_coordinate) {
      return false;
    }
    if (this->y_coordinate != other.y_coordinate) {
      return false;
    }
    if (this->z_coordinate != other.z_coordinate) {
      return false;
    }
    if (this->z_coordinate_is_present != other.z_coordinate_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const CartesianPosition3dWithConfidence_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CartesianPosition3dWithConfidence_

// alias to use template instance with default allocator
using CartesianPosition3dWithConfidence =
  etsi_its_cpm_ts_msgs::msg::CartesianPosition3dWithConfidence_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CARTESIAN_POSITION3D_WITH_CONFIDENCE__STRUCT_HPP_
