// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/CircularShape.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CIRCULAR_SHAPE__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CIRCULAR_SHAPE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/circular_shape__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'shape_reference_point'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_position3d__traits.hpp"
// Member 'radius'
// Member 'height'
#include "etsi_its_cpm_ts_msgs/msg/detail/standard_length12b__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const CircularShape & msg,
  std::ostream & out)
{
  out << "{";
  // member: shape_reference_point
  {
    out << "shape_reference_point: ";
    to_flow_style_yaml(msg.shape_reference_point, out);
    out << ", ";
  }

  // member: shape_reference_point_is_present
  {
    out << "shape_reference_point_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.shape_reference_point_is_present, out);
    out << ", ";
  }

  // member: radius
  {
    out << "radius: ";
    to_flow_style_yaml(msg.radius, out);
    out << ", ";
  }

  // member: height
  {
    out << "height: ";
    to_flow_style_yaml(msg.height, out);
    out << ", ";
  }

  // member: height_is_present
  {
    out << "height_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.height_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CircularShape & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: shape_reference_point
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "shape_reference_point:\n";
    to_block_style_yaml(msg.shape_reference_point, out, indentation + 2);
  }

  // member: shape_reference_point_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "shape_reference_point_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.shape_reference_point_is_present, out);
    out << "\n";
  }

  // member: radius
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "radius:\n";
    to_block_style_yaml(msg.radius, out, indentation + 2);
  }

  // member: height
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "height:\n";
    to_block_style_yaml(msg.height, out, indentation + 2);
  }

  // member: height_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "height_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.height_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CircularShape & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::CircularShape & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::CircularShape & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::CircularShape>()
{
  return "etsi_its_cpm_ts_msgs::msg::CircularShape";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::CircularShape>()
{
  return "etsi_its_cpm_ts_msgs/msg/CircularShape";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::CircularShape>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::CartesianPosition3d>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::StandardLength12b>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::CircularShape>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::CartesianPosition3d>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::StandardLength12b>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::CircularShape>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CIRCULAR_SHAPE__TRAITS_HPP_
