// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/CollectivePerceptionMessage.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__COLLECTIVE_PERCEPTION_MESSAGE__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__COLLECTIVE_PERCEPTION_MESSAGE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "etsi_its_cpm_ts_msgs/msg/detail/its_pdu_header__struct.hpp"
// Member 'payload'
#include "etsi_its_cpm_ts_msgs/msg/detail/cpm_payload__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__CollectivePerceptionMessage __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__CollectivePerceptionMessage __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CollectivePerceptionMessage_
{
  using Type = CollectivePerceptionMessage_<ContainerAllocator>;

  explicit CollectivePerceptionMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    payload(_init)
  {
    (void)_init;
  }

  explicit CollectivePerceptionMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    payload(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    etsi_its_cpm_ts_msgs::msg::ItsPduHeader_<ContainerAllocator>;
  _header_type header;
  using _payload_type =
    etsi_its_cpm_ts_msgs::msg::CpmPayload_<ContainerAllocator>;
  _payload_type payload;

  // setters for named parameter idiom
  Type & set__header(
    const etsi_its_cpm_ts_msgs::msg::ItsPduHeader_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__payload(
    const etsi_its_cpm_ts_msgs::msg::CpmPayload_<ContainerAllocator> & _arg)
  {
    this->payload = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::CollectivePerceptionMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::CollectivePerceptionMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::CollectivePerceptionMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::CollectivePerceptionMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::CollectivePerceptionMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::CollectivePerceptionMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::CollectivePerceptionMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::CollectivePerceptionMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::CollectivePerceptionMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::CollectivePerceptionMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__CollectivePerceptionMessage
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::CollectivePerceptionMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__CollectivePerceptionMessage
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::CollectivePerceptionMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CollectivePerceptionMessage_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->payload != other.payload) {
      return false;
    }
    return true;
  }
  bool operator!=(const CollectivePerceptionMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CollectivePerceptionMessage_

// alias to use template instance with default allocator
using CollectivePerceptionMessage =
  etsi_its_cpm_ts_msgs::msg::CollectivePerceptionMessage_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__COLLECTIVE_PERCEPTION_MESSAGE__STRUCT_HPP_
