// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/EulerAnglesWithConfidence.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/euler_angles_with_confidence__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `z_angle`
// Member `y_angle`
// Member `x_angle`
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__init(etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence * msg)
{
  if (!msg) {
    return false;
  }
  // z_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__init(&msg->z_angle)) {
    etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__fini(msg);
    return false;
  }
  // y_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__init(&msg->y_angle)) {
    etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__fini(msg);
    return false;
  }
  // y_angle_is_present
  // x_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__init(&msg->x_angle)) {
    etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__fini(msg);
    return false;
  }
  // x_angle_is_present
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__fini(etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence * msg)
{
  if (!msg) {
    return;
  }
  // z_angle
  etsi_its_cpm_ts_msgs__msg__CartesianAngle__fini(&msg->z_angle);
  // y_angle
  etsi_its_cpm_ts_msgs__msg__CartesianAngle__fini(&msg->y_angle);
  // y_angle_is_present
  // x_angle
  etsi_its_cpm_ts_msgs__msg__CartesianAngle__fini(&msg->x_angle);
  // x_angle_is_present
}

bool
etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__are_equal(const etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence * lhs, const etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // z_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__are_equal(
      &(lhs->z_angle), &(rhs->z_angle)))
  {
    return false;
  }
  // y_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__are_equal(
      &(lhs->y_angle), &(rhs->y_angle)))
  {
    return false;
  }
  // y_angle_is_present
  if (lhs->y_angle_is_present != rhs->y_angle_is_present) {
    return false;
  }
  // x_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__are_equal(
      &(lhs->x_angle), &(rhs->x_angle)))
  {
    return false;
  }
  // x_angle_is_present
  if (lhs->x_angle_is_present != rhs->x_angle_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__copy(
  const etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence * input,
  etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence * output)
{
  if (!input || !output) {
    return false;
  }
  // z_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__copy(
      &(input->z_angle), &(output->z_angle)))
  {
    return false;
  }
  // y_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__copy(
      &(input->y_angle), &(output->y_angle)))
  {
    return false;
  }
  // y_angle_is_present
  output->y_angle_is_present = input->y_angle_is_present;
  // x_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__copy(
      &(input->x_angle), &(output->x_angle)))
  {
    return false;
  }
  // x_angle_is_present
  output->x_angle_is_present = input->x_angle_is_present;
  return true;
}

etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence *
etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence * msg = (etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence));
  bool success = etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__destroy(etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence__init(etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence__fini(etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence *
etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence * array = (etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence * data =
      (etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
