// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/EulerAnglesWithConfidence.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__EULER_ANGLES_WITH_CONFIDENCE__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__EULER_ANGLES_WITH_CONFIDENCE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'z_angle'
// Member 'y_angle'
// Member 'x_angle'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct EulerAnglesWithConfidence_
{
  using Type = EulerAnglesWithConfidence_<ContainerAllocator>;

  explicit EulerAnglesWithConfidence_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : z_angle(_init),
    y_angle(_init),
    x_angle(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->y_angle_is_present = false;
      this->x_angle_is_present = false;
    }
  }

  explicit EulerAnglesWithConfidence_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : z_angle(_alloc, _init),
    y_angle(_alloc, _init),
    x_angle(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->y_angle_is_present = false;
      this->x_angle_is_present = false;
    }
  }

  // field types and members
  using _z_angle_type =
    etsi_its_cpm_ts_msgs::msg::CartesianAngle_<ContainerAllocator>;
  _z_angle_type z_angle;
  using _y_angle_type =
    etsi_its_cpm_ts_msgs::msg::CartesianAngle_<ContainerAllocator>;
  _y_angle_type y_angle;
  using _y_angle_is_present_type =
    bool;
  _y_angle_is_present_type y_angle_is_present;
  using _x_angle_type =
    etsi_its_cpm_ts_msgs::msg::CartesianAngle_<ContainerAllocator>;
  _x_angle_type x_angle;
  using _x_angle_is_present_type =
    bool;
  _x_angle_is_present_type x_angle_is_present;

  // setters for named parameter idiom
  Type & set__z_angle(
    const etsi_its_cpm_ts_msgs::msg::CartesianAngle_<ContainerAllocator> & _arg)
  {
    this->z_angle = _arg;
    return *this;
  }
  Type & set__y_angle(
    const etsi_its_cpm_ts_msgs::msg::CartesianAngle_<ContainerAllocator> & _arg)
  {
    this->y_angle = _arg;
    return *this;
  }
  Type & set__y_angle_is_present(
    const bool & _arg)
  {
    this->y_angle_is_present = _arg;
    return *this;
  }
  Type & set__x_angle(
    const etsi_its_cpm_ts_msgs::msg::CartesianAngle_<ContainerAllocator> & _arg)
  {
    this->x_angle = _arg;
    return *this;
  }
  Type & set__x_angle_is_present(
    const bool & _arg)
  {
    this->x_angle_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EulerAnglesWithConfidence_ & other) const
  {
    if (this->z_angle != other.z_angle) {
      return false;
    }
    if (this->y_angle != other.y_angle) {
      return false;
    }
    if (this->y_angle_is_present != other.y_angle_is_present) {
      return false;
    }
    if (this->x_angle != other.x_angle) {
      return false;
    }
    if (this->x_angle_is_present != other.x_angle_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const EulerAnglesWithConfidence_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EulerAnglesWithConfidence_

// alias to use template instance with default allocator
using EulerAnglesWithConfidence =
  etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__EULER_ANGLES_WITH_CONFIDENCE__STRUCT_HPP_
