// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/EulerAnglesWithConfidence.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__EULER_ANGLES_WITH_CONFIDENCE__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__EULER_ANGLES_WITH_CONFIDENCE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/euler_angles_with_confidence__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'z_angle'
// Member 'y_angle'
// Member 'x_angle'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const EulerAnglesWithConfidence & msg,
  std::ostream & out)
{
  out << "{";
  // member: z_angle
  {
    out << "z_angle: ";
    to_flow_style_yaml(msg.z_angle, out);
    out << ", ";
  }

  // member: y_angle
  {
    out << "y_angle: ";
    to_flow_style_yaml(msg.y_angle, out);
    out << ", ";
  }

  // member: y_angle_is_present
  {
    out << "y_angle_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.y_angle_is_present, out);
    out << ", ";
  }

  // member: x_angle
  {
    out << "x_angle: ";
    to_flow_style_yaml(msg.x_angle, out);
    out << ", ";
  }

  // member: x_angle_is_present
  {
    out << "x_angle_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.x_angle_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const EulerAnglesWithConfidence & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: z_angle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "z_angle:\n";
    to_block_style_yaml(msg.z_angle, out, indentation + 2);
  }

  // member: y_angle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "y_angle:\n";
    to_block_style_yaml(msg.y_angle, out, indentation + 2);
  }

  // member: y_angle_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "y_angle_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.y_angle_is_present, out);
    out << "\n";
  }

  // member: x_angle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "x_angle:\n";
    to_block_style_yaml(msg.x_angle, out, indentation + 2);
  }

  // member: x_angle_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "x_angle_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.x_angle_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const EulerAnglesWithConfidence & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence>()
{
  return "etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence>()
{
  return "etsi_its_cpm_ts_msgs/msg/EulerAnglesWithConfidence";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::CartesianAngle>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::CartesianAngle>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__EULER_ANGLES_WITH_CONFIDENCE__TRAITS_HPP_
