// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/ItsPduHeader.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ITS_PDU_HEADER__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ITS_PDU_HEADER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'protocol_version'
#include "etsi_its_cpm_ts_msgs/msg/detail/ordinal_number1_b__struct.hpp"
// Member 'message_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/message_id__struct.hpp"
// Member 'station_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/station_id__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__ItsPduHeader __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__ItsPduHeader __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ItsPduHeader_
{
  using Type = ItsPduHeader_<ContainerAllocator>;

  explicit ItsPduHeader_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : protocol_version(_init),
    message_id(_init),
    station_id(_init)
  {
    (void)_init;
  }

  explicit ItsPduHeader_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : protocol_version(_alloc, _init),
    message_id(_alloc, _init),
    station_id(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _protocol_version_type =
    etsi_its_cpm_ts_msgs::msg::OrdinalNumber1B_<ContainerAllocator>;
  _protocol_version_type protocol_version;
  using _message_id_type =
    etsi_its_cpm_ts_msgs::msg::MessageId_<ContainerAllocator>;
  _message_id_type message_id;
  using _station_id_type =
    etsi_its_cpm_ts_msgs::msg::StationId_<ContainerAllocator>;
  _station_id_type station_id;

  // setters for named parameter idiom
  Type & set__protocol_version(
    const etsi_its_cpm_ts_msgs::msg::OrdinalNumber1B_<ContainerAllocator> & _arg)
  {
    this->protocol_version = _arg;
    return *this;
  }
  Type & set__message_id(
    const etsi_its_cpm_ts_msgs::msg::MessageId_<ContainerAllocator> & _arg)
  {
    this->message_id = _arg;
    return *this;
  }
  Type & set__station_id(
    const etsi_its_cpm_ts_msgs::msg::StationId_<ContainerAllocator> & _arg)
  {
    this->station_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::ItsPduHeader_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::ItsPduHeader_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ItsPduHeader_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ItsPduHeader_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::ItsPduHeader_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::ItsPduHeader_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::ItsPduHeader_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::ItsPduHeader_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::ItsPduHeader_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::ItsPduHeader_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__ItsPduHeader
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ItsPduHeader_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__ItsPduHeader
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ItsPduHeader_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ItsPduHeader_ & other) const
  {
    if (this->protocol_version != other.protocol_version) {
      return false;
    }
    if (this->message_id != other.message_id) {
      return false;
    }
    if (this->station_id != other.station_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const ItsPduHeader_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ItsPduHeader_

// alias to use template instance with default allocator
using ItsPduHeader =
  etsi_its_cpm_ts_msgs::msg::ItsPduHeader_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ITS_PDU_HEADER__STRUCT_HPP_
