// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/LowerTriangularPositiveSemidefiniteMatrix.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__LOWER_TRIANGULAR_POSITIVE_SEMIDEFINITE_MATRIX__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__LOWER_TRIANGULAR_POSITIVE_SEMIDEFINITE_MATRIX__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'components_included_inthe_matrix'
#include "etsi_its_cpm_ts_msgs/msg/detail/matrix_included_components__struct.hpp"
// Member 'matrix'
#include "etsi_its_cpm_ts_msgs/msg/detail/lower_triangular_positive_semidefinite_matrix_columns__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__LowerTriangularPositiveSemidefiniteMatrix __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__LowerTriangularPositiveSemidefiniteMatrix __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LowerTriangularPositiveSemidefiniteMatrix_
{
  using Type = LowerTriangularPositiveSemidefiniteMatrix_<ContainerAllocator>;

  explicit LowerTriangularPositiveSemidefiniteMatrix_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : components_included_inthe_matrix(_init),
    matrix(_init)
  {
    (void)_init;
  }

  explicit LowerTriangularPositiveSemidefiniteMatrix_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : components_included_inthe_matrix(_alloc, _init),
    matrix(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _components_included_inthe_matrix_type =
    etsi_its_cpm_ts_msgs::msg::MatrixIncludedComponents_<ContainerAllocator>;
  _components_included_inthe_matrix_type components_included_inthe_matrix;
  using _matrix_type =
    etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrixColumns_<ContainerAllocator>;
  _matrix_type matrix;

  // setters for named parameter idiom
  Type & set__components_included_inthe_matrix(
    const etsi_its_cpm_ts_msgs::msg::MatrixIncludedComponents_<ContainerAllocator> & _arg)
  {
    this->components_included_inthe_matrix = _arg;
    return *this;
  }
  Type & set__matrix(
    const etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrixColumns_<ContainerAllocator> & _arg)
  {
    this->matrix = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrix_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrix_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrix_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrix_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrix_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrix_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrix_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrix_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrix_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrix_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__LowerTriangularPositiveSemidefiniteMatrix
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrix_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__LowerTriangularPositiveSemidefiniteMatrix
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrix_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LowerTriangularPositiveSemidefiniteMatrix_ & other) const
  {
    if (this->components_included_inthe_matrix != other.components_included_inthe_matrix) {
      return false;
    }
    if (this->matrix != other.matrix) {
      return false;
    }
    return true;
  }
  bool operator!=(const LowerTriangularPositiveSemidefiniteMatrix_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LowerTriangularPositiveSemidefiniteMatrix_

// alias to use template instance with default allocator
using LowerTriangularPositiveSemidefiniteMatrix =
  etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrix_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__LOWER_TRIANGULAR_POSITIVE_SEMIDEFINITE_MATRIX__STRUCT_HPP_
