// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/ManagementContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'reference_time'
#include "etsi_its_cpm_ts_msgs/msg/detail/timestamp_its__struct.hpp"
// Member 'reference_position'
#include "etsi_its_cpm_ts_msgs/msg/detail/reference_position__struct.hpp"
// Member 'segmentation_info'
#include "etsi_its_cpm_ts_msgs/msg/detail/message_segmentation_info__struct.hpp"
// Member 'message_rate_range'
#include "etsi_its_cpm_ts_msgs/msg/detail/message_rate_range__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__ManagementContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__ManagementContainer __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ManagementContainer_
{
  using Type = ManagementContainer_<ContainerAllocator>;

  explicit ManagementContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : reference_time(_init),
    reference_position(_init),
    segmentation_info(_init),
    message_rate_range(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->segmentation_info_is_present = false;
      this->message_rate_range_is_present = false;
    }
  }

  explicit ManagementContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : reference_time(_alloc, _init),
    reference_position(_alloc, _init),
    segmentation_info(_alloc, _init),
    message_rate_range(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->segmentation_info_is_present = false;
      this->message_rate_range_is_present = false;
    }
  }

  // field types and members
  using _reference_time_type =
    etsi_its_cpm_ts_msgs::msg::TimestampIts_<ContainerAllocator>;
  _reference_time_type reference_time;
  using _reference_position_type =
    etsi_its_cpm_ts_msgs::msg::ReferencePosition_<ContainerAllocator>;
  _reference_position_type reference_position;
  using _segmentation_info_type =
    etsi_its_cpm_ts_msgs::msg::MessageSegmentationInfo_<ContainerAllocator>;
  _segmentation_info_type segmentation_info;
  using _segmentation_info_is_present_type =
    bool;
  _segmentation_info_is_present_type segmentation_info_is_present;
  using _message_rate_range_type =
    etsi_its_cpm_ts_msgs::msg::MessageRateRange_<ContainerAllocator>;
  _message_rate_range_type message_rate_range;
  using _message_rate_range_is_present_type =
    bool;
  _message_rate_range_is_present_type message_rate_range_is_present;

  // setters for named parameter idiom
  Type & set__reference_time(
    const etsi_its_cpm_ts_msgs::msg::TimestampIts_<ContainerAllocator> & _arg)
  {
    this->reference_time = _arg;
    return *this;
  }
  Type & set__reference_position(
    const etsi_its_cpm_ts_msgs::msg::ReferencePosition_<ContainerAllocator> & _arg)
  {
    this->reference_position = _arg;
    return *this;
  }
  Type & set__segmentation_info(
    const etsi_its_cpm_ts_msgs::msg::MessageSegmentationInfo_<ContainerAllocator> & _arg)
  {
    this->segmentation_info = _arg;
    return *this;
  }
  Type & set__segmentation_info_is_present(
    const bool & _arg)
  {
    this->segmentation_info_is_present = _arg;
    return *this;
  }
  Type & set__message_rate_range(
    const etsi_its_cpm_ts_msgs::msg::MessageRateRange_<ContainerAllocator> & _arg)
  {
    this->message_rate_range = _arg;
    return *this;
  }
  Type & set__message_rate_range_is_present(
    const bool & _arg)
  {
    this->message_rate_range_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::ManagementContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::ManagementContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ManagementContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ManagementContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::ManagementContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::ManagementContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::ManagementContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::ManagementContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::ManagementContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::ManagementContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__ManagementContainer
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ManagementContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__ManagementContainer
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ManagementContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ManagementContainer_ & other) const
  {
    if (this->reference_time != other.reference_time) {
      return false;
    }
    if (this->reference_position != other.reference_position) {
      return false;
    }
    if (this->segmentation_info != other.segmentation_info) {
      return false;
    }
    if (this->segmentation_info_is_present != other.segmentation_info_is_present) {
      return false;
    }
    if (this->message_rate_range != other.message_rate_range) {
      return false;
    }
    if (this->message_rate_range_is_present != other.message_rate_range_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const ManagementContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ManagementContainer_

// alias to use template instance with default allocator
using ManagementContainer =
  etsi_its_cpm_ts_msgs::msg::ManagementContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__STRUCT_HPP_
