// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/ManagementContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/management_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'reference_time'
#include "etsi_its_cpm_ts_msgs/msg/detail/timestamp_its__traits.hpp"
// Member 'reference_position'
#include "etsi_its_cpm_ts_msgs/msg/detail/reference_position__traits.hpp"
// Member 'segmentation_info'
#include "etsi_its_cpm_ts_msgs/msg/detail/message_segmentation_info__traits.hpp"
// Member 'message_rate_range'
#include "etsi_its_cpm_ts_msgs/msg/detail/message_rate_range__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ManagementContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: reference_time
  {
    out << "reference_time: ";
    to_flow_style_yaml(msg.reference_time, out);
    out << ", ";
  }

  // member: reference_position
  {
    out << "reference_position: ";
    to_flow_style_yaml(msg.reference_position, out);
    out << ", ";
  }

  // member: segmentation_info
  {
    out << "segmentation_info: ";
    to_flow_style_yaml(msg.segmentation_info, out);
    out << ", ";
  }

  // member: segmentation_info_is_present
  {
    out << "segmentation_info_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.segmentation_info_is_present, out);
    out << ", ";
  }

  // member: message_rate_range
  {
    out << "message_rate_range: ";
    to_flow_style_yaml(msg.message_rate_range, out);
    out << ", ";
  }

  // member: message_rate_range_is_present
  {
    out << "message_rate_range_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.message_rate_range_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ManagementContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: reference_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reference_time:\n";
    to_block_style_yaml(msg.reference_time, out, indentation + 2);
  }

  // member: reference_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reference_position:\n";
    to_block_style_yaml(msg.reference_position, out, indentation + 2);
  }

  // member: segmentation_info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "segmentation_info:\n";
    to_block_style_yaml(msg.segmentation_info, out, indentation + 2);
  }

  // member: segmentation_info_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "segmentation_info_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.segmentation_info_is_present, out);
    out << "\n";
  }

  // member: message_rate_range
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message_rate_range:\n";
    to_block_style_yaml(msg.message_rate_range, out, indentation + 2);
  }

  // member: message_rate_range_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message_rate_range_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.message_rate_range_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ManagementContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::ManagementContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::ManagementContainer & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::ManagementContainer>()
{
  return "etsi_its_cpm_ts_msgs::msg::ManagementContainer";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::ManagementContainer>()
{
  return "etsi_its_cpm_ts_msgs/msg/ManagementContainer";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::ManagementContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::MessageRateRange>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::MessageSegmentationInfo>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::ReferencePosition>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::TimestampIts>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::ManagementContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::MessageRateRange>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::MessageSegmentationInfo>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::ReferencePosition>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::TimestampIts>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::ManagementContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__TRAITS_HPP_
