// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/MapPosition.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MAP_POSITION__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MAP_POSITION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'map_reference'
#include "etsi_its_cpm_ts_msgs/msg/detail/map_reference__struct.hpp"
// Member 'lane_id'
// Member 'connection_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier1_b__struct.hpp"
// Member 'longitudinal_lane_position'
#include "etsi_its_cpm_ts_msgs/msg/detail/longitudinal_lane_position__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__MapPosition __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__MapPosition __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MapPosition_
{
  using Type = MapPosition_<ContainerAllocator>;

  explicit MapPosition_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : map_reference(_init),
    lane_id(_init),
    connection_id(_init),
    longitudinal_lane_position(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->map_reference_is_present = false;
      this->lane_id_is_present = false;
      this->connection_id_is_present = false;
      this->longitudinal_lane_position_is_present = false;
    }
  }

  explicit MapPosition_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : map_reference(_alloc, _init),
    lane_id(_alloc, _init),
    connection_id(_alloc, _init),
    longitudinal_lane_position(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->map_reference_is_present = false;
      this->lane_id_is_present = false;
      this->connection_id_is_present = false;
      this->longitudinal_lane_position_is_present = false;
    }
  }

  // field types and members
  using _map_reference_type =
    etsi_its_cpm_ts_msgs::msg::MapReference_<ContainerAllocator>;
  _map_reference_type map_reference;
  using _map_reference_is_present_type =
    bool;
  _map_reference_is_present_type map_reference_is_present;
  using _lane_id_type =
    etsi_its_cpm_ts_msgs::msg::Identifier1B_<ContainerAllocator>;
  _lane_id_type lane_id;
  using _lane_id_is_present_type =
    bool;
  _lane_id_is_present_type lane_id_is_present;
  using _connection_id_type =
    etsi_its_cpm_ts_msgs::msg::Identifier1B_<ContainerAllocator>;
  _connection_id_type connection_id;
  using _connection_id_is_present_type =
    bool;
  _connection_id_is_present_type connection_id_is_present;
  using _longitudinal_lane_position_type =
    etsi_its_cpm_ts_msgs::msg::LongitudinalLanePosition_<ContainerAllocator>;
  _longitudinal_lane_position_type longitudinal_lane_position;
  using _longitudinal_lane_position_is_present_type =
    bool;
  _longitudinal_lane_position_is_present_type longitudinal_lane_position_is_present;

  // setters for named parameter idiom
  Type & set__map_reference(
    const etsi_its_cpm_ts_msgs::msg::MapReference_<ContainerAllocator> & _arg)
  {
    this->map_reference = _arg;
    return *this;
  }
  Type & set__map_reference_is_present(
    const bool & _arg)
  {
    this->map_reference_is_present = _arg;
    return *this;
  }
  Type & set__lane_id(
    const etsi_its_cpm_ts_msgs::msg::Identifier1B_<ContainerAllocator> & _arg)
  {
    this->lane_id = _arg;
    return *this;
  }
  Type & set__lane_id_is_present(
    const bool & _arg)
  {
    this->lane_id_is_present = _arg;
    return *this;
  }
  Type & set__connection_id(
    const etsi_its_cpm_ts_msgs::msg::Identifier1B_<ContainerAllocator> & _arg)
  {
    this->connection_id = _arg;
    return *this;
  }
  Type & set__connection_id_is_present(
    const bool & _arg)
  {
    this->connection_id_is_present = _arg;
    return *this;
  }
  Type & set__longitudinal_lane_position(
    const etsi_its_cpm_ts_msgs::msg::LongitudinalLanePosition_<ContainerAllocator> & _arg)
  {
    this->longitudinal_lane_position = _arg;
    return *this;
  }
  Type & set__longitudinal_lane_position_is_present(
    const bool & _arg)
  {
    this->longitudinal_lane_position_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::MapPosition_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::MapPosition_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MapPosition_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MapPosition_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::MapPosition_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::MapPosition_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::MapPosition_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::MapPosition_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::MapPosition_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::MapPosition_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__MapPosition
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MapPosition_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__MapPosition
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MapPosition_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MapPosition_ & other) const
  {
    if (this->map_reference != other.map_reference) {
      return false;
    }
    if (this->map_reference_is_present != other.map_reference_is_present) {
      return false;
    }
    if (this->lane_id != other.lane_id) {
      return false;
    }
    if (this->lane_id_is_present != other.lane_id_is_present) {
      return false;
    }
    if (this->connection_id != other.connection_id) {
      return false;
    }
    if (this->connection_id_is_present != other.connection_id_is_present) {
      return false;
    }
    if (this->longitudinal_lane_position != other.longitudinal_lane_position) {
      return false;
    }
    if (this->longitudinal_lane_position_is_present != other.longitudinal_lane_position_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const MapPosition_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MapPosition_

// alias to use template instance with default allocator
using MapPosition =
  etsi_its_cpm_ts_msgs::msg::MapPosition_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MAP_POSITION__STRUCT_HPP_
