// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/MapReference.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MAP_REFERENCE__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MAP_REFERENCE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'roadsegment'
#include "etsi_its_cpm_ts_msgs/msg/detail/road_segment_reference_id__struct.hpp"
// Member 'intersection'
#include "etsi_its_cpm_ts_msgs/msg/detail/intersection_reference_id__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__MapReference __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__MapReference __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MapReference_
{
  using Type = MapReference_<ContainerAllocator>;

  explicit MapReference_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : roadsegment(_init),
    intersection(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  explicit MapReference_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : roadsegment(_alloc, _init),
    intersection(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  // field types and members
  using _choice_type =
    uint8_t;
  _choice_type choice;
  using _roadsegment_type =
    etsi_its_cpm_ts_msgs::msg::RoadSegmentReferenceId_<ContainerAllocator>;
  _roadsegment_type roadsegment;
  using _intersection_type =
    etsi_its_cpm_ts_msgs::msg::IntersectionReferenceId_<ContainerAllocator>;
  _intersection_type intersection;

  // setters for named parameter idiom
  Type & set__choice(
    const uint8_t & _arg)
  {
    this->choice = _arg;
    return *this;
  }
  Type & set__roadsegment(
    const etsi_its_cpm_ts_msgs::msg::RoadSegmentReferenceId_<ContainerAllocator> & _arg)
  {
    this->roadsegment = _arg;
    return *this;
  }
  Type & set__intersection(
    const etsi_its_cpm_ts_msgs::msg::IntersectionReferenceId_<ContainerAllocator> & _arg)
  {
    this->intersection = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t CHOICE_ROADSEGMENT =
    0u;
  static constexpr uint8_t CHOICE_INTERSECTION =
    1u;

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::MapReference_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::MapReference_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MapReference_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MapReference_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::MapReference_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::MapReference_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::MapReference_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::MapReference_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::MapReference_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::MapReference_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__MapReference
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MapReference_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__MapReference
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MapReference_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MapReference_ & other) const
  {
    if (this->choice != other.choice) {
      return false;
    }
    if (this->roadsegment != other.roadsegment) {
      return false;
    }
    if (this->intersection != other.intersection) {
      return false;
    }
    return true;
  }
  bool operator!=(const MapReference_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MapReference_

// alias to use template instance with default allocator
using MapReference =
  etsi_its_cpm_ts_msgs::msg::MapReference_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MapReference_<ContainerAllocator>::CHOICE_ROADSEGMENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MapReference_<ContainerAllocator>::CHOICE_INTERSECTION;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MAP_REFERENCE__STRUCT_HPP_
