// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/MapReference.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MAP_REFERENCE__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MAP_REFERENCE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/map_reference__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'roadsegment'
#include "etsi_its_cpm_ts_msgs/msg/detail/road_segment_reference_id__traits.hpp"
// Member 'intersection'
#include "etsi_its_cpm_ts_msgs/msg/detail/intersection_reference_id__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const MapReference & msg,
  std::ostream & out)
{
  out << "{";
  // member: choice
  {
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << ", ";
  }

  // member: roadsegment
  {
    out << "roadsegment: ";
    to_flow_style_yaml(msg.roadsegment, out);
    out << ", ";
  }

  // member: intersection
  {
    out << "intersection: ";
    to_flow_style_yaml(msg.intersection, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MapReference & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: choice
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << "\n";
  }

  // member: roadsegment
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "roadsegment:\n";
    to_block_style_yaml(msg.roadsegment, out, indentation + 2);
  }

  // member: intersection
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "intersection:\n";
    to_block_style_yaml(msg.intersection, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MapReference & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::MapReference & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::MapReference & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::MapReference>()
{
  return "etsi_its_cpm_ts_msgs::msg::MapReference";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::MapReference>()
{
  return "etsi_its_cpm_ts_msgs/msg/MapReference";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::MapReference>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::IntersectionReferenceId>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::RoadSegmentReferenceId>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::MapReference>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::IntersectionReferenceId>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::RoadSegmentReferenceId>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::MapReference>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MAP_REFERENCE__TRAITS_HPP_
