// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/MatrixIncludedComponents.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MATRIX_INCLUDED_COMPONENTS__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MATRIX_INCLUDED_COMPONENTS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MatrixIncludedComponents_
{
  using Type = MatrixIncludedComponents_<ContainerAllocator>;

  explicit MatrixIncludedComponents_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->bits_unused = 0;
    }
  }

  explicit MatrixIncludedComponents_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->bits_unused = 0;
    }
  }

  // field types and members
  using _value_type =
    std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>>;
  _value_type value;
  using _bits_unused_type =
    uint8_t;
  _bits_unused_type bits_unused;

  // setters for named parameter idiom
  Type & set__value(
    const std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>> & _arg)
  {
    this->value = _arg;
    return *this;
  }
  Type & set__bits_unused(
    const uint8_t & _arg)
  {
    this->bits_unused = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t SIZE_BITS =
    13u;
  static constexpr uint8_t BIT_INDEX_X_POSITION =
    0u;
  static constexpr uint8_t BIT_INDEX_Y_POSITION =
    1u;
  static constexpr uint8_t BIT_INDEX_Z_POSITION =
    2u;
  static constexpr uint8_t BIT_INDEX_X_VELOCITY_OR_VELOCITY_MAGNITUDE =
    3u;
  static constexpr uint8_t BIT_INDEX_Y_VELOCITY_OR_VELOCITY_DIRECTION =
    4u;
  static constexpr uint8_t BIT_INDEX_Z_SPEED =
    5u;
  static constexpr uint8_t BIT_INDEX_X_ACCEL_OR_ACCEL_MAGNITUDE =
    6u;
  static constexpr uint8_t BIT_INDEX_Y_ACCEL_OR_ACCEL_DIRECTION =
    7u;
  static constexpr uint8_t BIT_INDEX_Z_ACCELERATION =
    8u;
  static constexpr uint8_t BIT_INDEX_Z_ANGLE =
    9u;
  static constexpr uint8_t BIT_INDEX_Y_ANGLE =
    10u;
  static constexpr uint8_t BIT_INDEX_X_ANGLE =
    11u;
  static constexpr uint8_t BIT_INDEX_Z_ANGULAR_VELOCITY =
    12u;

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::MatrixIncludedComponents_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::MatrixIncludedComponents_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MatrixIncludedComponents_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MatrixIncludedComponents_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::MatrixIncludedComponents_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::MatrixIncludedComponents_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::MatrixIncludedComponents_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::MatrixIncludedComponents_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::MatrixIncludedComponents_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::MatrixIncludedComponents_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MatrixIncludedComponents_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MatrixIncludedComponents_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MatrixIncludedComponents_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    if (this->bits_unused != other.bits_unused) {
      return false;
    }
    return true;
  }
  bool operator!=(const MatrixIncludedComponents_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MatrixIncludedComponents_

// alias to use template instance with default allocator
using MatrixIncludedComponents =
  etsi_its_cpm_ts_msgs::msg::MatrixIncludedComponents_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MatrixIncludedComponents_<ContainerAllocator>::SIZE_BITS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MatrixIncludedComponents_<ContainerAllocator>::BIT_INDEX_X_POSITION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MatrixIncludedComponents_<ContainerAllocator>::BIT_INDEX_Y_POSITION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MatrixIncludedComponents_<ContainerAllocator>::BIT_INDEX_Z_POSITION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MatrixIncludedComponents_<ContainerAllocator>::BIT_INDEX_X_VELOCITY_OR_VELOCITY_MAGNITUDE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MatrixIncludedComponents_<ContainerAllocator>::BIT_INDEX_Y_VELOCITY_OR_VELOCITY_DIRECTION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MatrixIncludedComponents_<ContainerAllocator>::BIT_INDEX_Z_SPEED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MatrixIncludedComponents_<ContainerAllocator>::BIT_INDEX_X_ACCEL_OR_ACCEL_MAGNITUDE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MatrixIncludedComponents_<ContainerAllocator>::BIT_INDEX_Y_ACCEL_OR_ACCEL_DIRECTION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MatrixIncludedComponents_<ContainerAllocator>::BIT_INDEX_Z_ACCELERATION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MatrixIncludedComponents_<ContainerAllocator>::BIT_INDEX_Z_ANGLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MatrixIncludedComponents_<ContainerAllocator>::BIT_INDEX_Y_ANGLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MatrixIncludedComponents_<ContainerAllocator>::BIT_INDEX_X_ANGLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MatrixIncludedComponents_<ContainerAllocator>::BIT_INDEX_Z_ANGULAR_VELOCITY;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MATRIX_INCLUDED_COMPONENTS__STRUCT_HPP_
