// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/MessageRateRange.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MESSAGE_RATE_RANGE__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MESSAGE_RATE_RANGE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'message_rate_min'
// Member 'message_rate_max'
#include "etsi_its_cpm_ts_msgs/msg/detail/message_rate_hz__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__MessageRateRange __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__MessageRateRange __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MessageRateRange_
{
  using Type = MessageRateRange_<ContainerAllocator>;

  explicit MessageRateRange_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : message_rate_min(_init),
    message_rate_max(_init)
  {
    (void)_init;
  }

  explicit MessageRateRange_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : message_rate_min(_alloc, _init),
    message_rate_max(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _message_rate_min_type =
    etsi_its_cpm_ts_msgs::msg::MessageRateHz_<ContainerAllocator>;
  _message_rate_min_type message_rate_min;
  using _message_rate_max_type =
    etsi_its_cpm_ts_msgs::msg::MessageRateHz_<ContainerAllocator>;
  _message_rate_max_type message_rate_max;

  // setters for named parameter idiom
  Type & set__message_rate_min(
    const etsi_its_cpm_ts_msgs::msg::MessageRateHz_<ContainerAllocator> & _arg)
  {
    this->message_rate_min = _arg;
    return *this;
  }
  Type & set__message_rate_max(
    const etsi_its_cpm_ts_msgs::msg::MessageRateHz_<ContainerAllocator> & _arg)
  {
    this->message_rate_max = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::MessageRateRange_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::MessageRateRange_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MessageRateRange_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MessageRateRange_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::MessageRateRange_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::MessageRateRange_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::MessageRateRange_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::MessageRateRange_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::MessageRateRange_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::MessageRateRange_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__MessageRateRange
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MessageRateRange_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__MessageRateRange
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MessageRateRange_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MessageRateRange_ & other) const
  {
    if (this->message_rate_min != other.message_rate_min) {
      return false;
    }
    if (this->message_rate_max != other.message_rate_max) {
      return false;
    }
    return true;
  }
  bool operator!=(const MessageRateRange_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MessageRateRange_

// alias to use template instance with default allocator
using MessageRateRange =
  etsi_its_cpm_ts_msgs::msg::MessageRateRange_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MESSAGE_RATE_RANGE__STRUCT_HPP_
