// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/ObjectClass.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/object_class__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `vehicle_sub_class`
#include "etsi_its_cpm_ts_msgs/msg/detail/traffic_participant_type__functions.h"
// Member `vru_sub_class`
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_profile_and_subprofile__functions.h"
// Member `group_sub_class`
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_cluster_information__functions.h"
// Member `other_sub_class`
#include "etsi_its_cpm_ts_msgs/msg/detail/other_sub_class__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__ObjectClass__init(etsi_its_cpm_ts_msgs__msg__ObjectClass * msg)
{
  if (!msg) {
    return false;
  }
  // choice
  // vehicle_sub_class
  if (!etsi_its_cpm_ts_msgs__msg__TrafficParticipantType__init(&msg->vehicle_sub_class)) {
    etsi_its_cpm_ts_msgs__msg__ObjectClass__fini(msg);
    return false;
  }
  // vru_sub_class
  if (!etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__init(&msg->vru_sub_class)) {
    etsi_its_cpm_ts_msgs__msg__ObjectClass__fini(msg);
    return false;
  }
  // group_sub_class
  if (!etsi_its_cpm_ts_msgs__msg__VruClusterInformation__init(&msg->group_sub_class)) {
    etsi_its_cpm_ts_msgs__msg__ObjectClass__fini(msg);
    return false;
  }
  // other_sub_class
  if (!etsi_its_cpm_ts_msgs__msg__OtherSubClass__init(&msg->other_sub_class)) {
    etsi_its_cpm_ts_msgs__msg__ObjectClass__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__ObjectClass__fini(etsi_its_cpm_ts_msgs__msg__ObjectClass * msg)
{
  if (!msg) {
    return;
  }
  // choice
  // vehicle_sub_class
  etsi_its_cpm_ts_msgs__msg__TrafficParticipantType__fini(&msg->vehicle_sub_class);
  // vru_sub_class
  etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__fini(&msg->vru_sub_class);
  // group_sub_class
  etsi_its_cpm_ts_msgs__msg__VruClusterInformation__fini(&msg->group_sub_class);
  // other_sub_class
  etsi_its_cpm_ts_msgs__msg__OtherSubClass__fini(&msg->other_sub_class);
}

bool
etsi_its_cpm_ts_msgs__msg__ObjectClass__are_equal(const etsi_its_cpm_ts_msgs__msg__ObjectClass * lhs, const etsi_its_cpm_ts_msgs__msg__ObjectClass * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // choice
  if (lhs->choice != rhs->choice) {
    return false;
  }
  // vehicle_sub_class
  if (!etsi_its_cpm_ts_msgs__msg__TrafficParticipantType__are_equal(
      &(lhs->vehicle_sub_class), &(rhs->vehicle_sub_class)))
  {
    return false;
  }
  // vru_sub_class
  if (!etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__are_equal(
      &(lhs->vru_sub_class), &(rhs->vru_sub_class)))
  {
    return false;
  }
  // group_sub_class
  if (!etsi_its_cpm_ts_msgs__msg__VruClusterInformation__are_equal(
      &(lhs->group_sub_class), &(rhs->group_sub_class)))
  {
    return false;
  }
  // other_sub_class
  if (!etsi_its_cpm_ts_msgs__msg__OtherSubClass__are_equal(
      &(lhs->other_sub_class), &(rhs->other_sub_class)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__ObjectClass__copy(
  const etsi_its_cpm_ts_msgs__msg__ObjectClass * input,
  etsi_its_cpm_ts_msgs__msg__ObjectClass * output)
{
  if (!input || !output) {
    return false;
  }
  // choice
  output->choice = input->choice;
  // vehicle_sub_class
  if (!etsi_its_cpm_ts_msgs__msg__TrafficParticipantType__copy(
      &(input->vehicle_sub_class), &(output->vehicle_sub_class)))
  {
    return false;
  }
  // vru_sub_class
  if (!etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__copy(
      &(input->vru_sub_class), &(output->vru_sub_class)))
  {
    return false;
  }
  // group_sub_class
  if (!etsi_its_cpm_ts_msgs__msg__VruClusterInformation__copy(
      &(input->group_sub_class), &(output->group_sub_class)))
  {
    return false;
  }
  // other_sub_class
  if (!etsi_its_cpm_ts_msgs__msg__OtherSubClass__copy(
      &(input->other_sub_class), &(output->other_sub_class)))
  {
    return false;
  }
  return true;
}

etsi_its_cpm_ts_msgs__msg__ObjectClass *
etsi_its_cpm_ts_msgs__msg__ObjectClass__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__ObjectClass * msg = (etsi_its_cpm_ts_msgs__msg__ObjectClass *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__ObjectClass), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__ObjectClass));
  bool success = etsi_its_cpm_ts_msgs__msg__ObjectClass__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__ObjectClass__destroy(etsi_its_cpm_ts_msgs__msg__ObjectClass * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__ObjectClass__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence__init(etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__ObjectClass * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__ObjectClass *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__ObjectClass), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__ObjectClass__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__ObjectClass__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence__fini(etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__ObjectClass__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence *
etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence * array = (etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__ObjectClass__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__ObjectClass);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__ObjectClass * data =
      (etsi_its_cpm_ts_msgs__msg__ObjectClass *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__ObjectClass__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__ObjectClass__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__ObjectClass__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
