// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/ObjectClass.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__OBJECT_CLASS__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__OBJECT_CLASS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'CHOICE_VEHICLE_SUB_CLASS'.
enum
{
  etsi_its_cpm_ts_msgs__msg__ObjectClass__CHOICE_VEHICLE_SUB_CLASS = 0
};

/// Constant 'CHOICE_VRU_SUB_CLASS'.
enum
{
  etsi_its_cpm_ts_msgs__msg__ObjectClass__CHOICE_VRU_SUB_CLASS = 1
};

/// Constant 'CHOICE_GROUP_SUB_CLASS'.
enum
{
  etsi_its_cpm_ts_msgs__msg__ObjectClass__CHOICE_GROUP_SUB_CLASS = 2
};

/// Constant 'CHOICE_OTHER_SUB_CLASS'.
enum
{
  etsi_its_cpm_ts_msgs__msg__ObjectClass__CHOICE_OTHER_SUB_CLASS = 3
};

// Include directives for member types
// Member 'vehicle_sub_class'
#include "etsi_its_cpm_ts_msgs/msg/detail/traffic_participant_type__struct.h"
// Member 'vru_sub_class'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_profile_and_subprofile__struct.h"
// Member 'group_sub_class'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_cluster_information__struct.h"
// Member 'other_sub_class'
#include "etsi_its_cpm_ts_msgs/msg/detail/other_sub_class__struct.h"

/// Struct defined in msg/ObjectClass in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__ObjectClass
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF indicates both the class and associated subclass that best describes an object.
  ///  *
  ///  * The following options are available:
  ///  *
  ///  * @field vehicleSubClass: the object is a road vehicle and the specific subclass is specified.
  ///  *
  ///  * @field vruSubClass: the object is a VRU and the specific subclass is specified.
  ///  *
  ///  * @field groupSubClass: the object is a VRU group or cluster and the cluster information is specified.
  ///  *
  ///  * @field otherSubClass: the object is of a different type than the above and the specific subclass is specified.
  ///  *
  ///  * @category: Sensing information
  ///  * @revision: Created in V2.1.1
  ///  */
  /// ObjectClass ::= CHOICE {
  ///     vehicleSubClass      TrafficParticipantType (unknown|passengerCar..tram|agricultural),
  ///     vruSubClass          VruProfileAndSubprofile,
  ///     groupSubClass        VruClusterInformation (WITH COMPONENTS{..., clusterBoundingBoxShape ABSENT}),
  ///     otherSubClass        OtherSubClass,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t choice;
  etsi_its_cpm_ts_msgs__msg__TrafficParticipantType vehicle_sub_class;
  etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile vru_sub_class;
  etsi_its_cpm_ts_msgs__msg__VruClusterInformation group_sub_class;
  etsi_its_cpm_ts_msgs__msg__OtherSubClass other_sub_class;
} etsi_its_cpm_ts_msgs__msg__ObjectClass;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__ObjectClass.
typedef struct etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence
{
  etsi_its_cpm_ts_msgs__msg__ObjectClass * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__ObjectClass__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__OBJECT_CLASS__STRUCT_H_
