// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/ObjectClass.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__OBJECT_CLASS__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__OBJECT_CLASS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'vehicle_sub_class'
#include "etsi_its_cpm_ts_msgs/msg/detail/traffic_participant_type__struct.hpp"
// Member 'vru_sub_class'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_profile_and_subprofile__struct.hpp"
// Member 'group_sub_class'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_cluster_information__struct.hpp"
// Member 'other_sub_class'
#include "etsi_its_cpm_ts_msgs/msg/detail/other_sub_class__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__ObjectClass __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__ObjectClass __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ObjectClass_
{
  using Type = ObjectClass_<ContainerAllocator>;

  explicit ObjectClass_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : vehicle_sub_class(_init),
    vru_sub_class(_init),
    group_sub_class(_init),
    other_sub_class(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  explicit ObjectClass_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : vehicle_sub_class(_alloc, _init),
    vru_sub_class(_alloc, _init),
    group_sub_class(_alloc, _init),
    other_sub_class(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  // field types and members
  using _choice_type =
    uint8_t;
  _choice_type choice;
  using _vehicle_sub_class_type =
    etsi_its_cpm_ts_msgs::msg::TrafficParticipantType_<ContainerAllocator>;
  _vehicle_sub_class_type vehicle_sub_class;
  using _vru_sub_class_type =
    etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile_<ContainerAllocator>;
  _vru_sub_class_type vru_sub_class;
  using _group_sub_class_type =
    etsi_its_cpm_ts_msgs::msg::VruClusterInformation_<ContainerAllocator>;
  _group_sub_class_type group_sub_class;
  using _other_sub_class_type =
    etsi_its_cpm_ts_msgs::msg::OtherSubClass_<ContainerAllocator>;
  _other_sub_class_type other_sub_class;

  // setters for named parameter idiom
  Type & set__choice(
    const uint8_t & _arg)
  {
    this->choice = _arg;
    return *this;
  }
  Type & set__vehicle_sub_class(
    const etsi_its_cpm_ts_msgs::msg::TrafficParticipantType_<ContainerAllocator> & _arg)
  {
    this->vehicle_sub_class = _arg;
    return *this;
  }
  Type & set__vru_sub_class(
    const etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile_<ContainerAllocator> & _arg)
  {
    this->vru_sub_class = _arg;
    return *this;
  }
  Type & set__group_sub_class(
    const etsi_its_cpm_ts_msgs::msg::VruClusterInformation_<ContainerAllocator> & _arg)
  {
    this->group_sub_class = _arg;
    return *this;
  }
  Type & set__other_sub_class(
    const etsi_its_cpm_ts_msgs::msg::OtherSubClass_<ContainerAllocator> & _arg)
  {
    this->other_sub_class = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t CHOICE_VEHICLE_SUB_CLASS =
    0u;
  static constexpr uint8_t CHOICE_VRU_SUB_CLASS =
    1u;
  static constexpr uint8_t CHOICE_GROUP_SUB_CLASS =
    2u;
  static constexpr uint8_t CHOICE_OTHER_SUB_CLASS =
    3u;

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::ObjectClass_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::ObjectClass_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ObjectClass_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ObjectClass_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::ObjectClass_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::ObjectClass_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::ObjectClass_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::ObjectClass_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::ObjectClass_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::ObjectClass_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__ObjectClass
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ObjectClass_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__ObjectClass
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ObjectClass_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ObjectClass_ & other) const
  {
    if (this->choice != other.choice) {
      return false;
    }
    if (this->vehicle_sub_class != other.vehicle_sub_class) {
      return false;
    }
    if (this->vru_sub_class != other.vru_sub_class) {
      return false;
    }
    if (this->group_sub_class != other.group_sub_class) {
      return false;
    }
    if (this->other_sub_class != other.other_sub_class) {
      return false;
    }
    return true;
  }
  bool operator!=(const ObjectClass_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ObjectClass_

// alias to use template instance with default allocator
using ObjectClass =
  etsi_its_cpm_ts_msgs::msg::ObjectClass_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ObjectClass_<ContainerAllocator>::CHOICE_VEHICLE_SUB_CLASS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ObjectClass_<ContainerAllocator>::CHOICE_VRU_SUB_CLASS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ObjectClass_<ContainerAllocator>::CHOICE_GROUP_SUB_CLASS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ObjectClass_<ContainerAllocator>::CHOICE_OTHER_SUB_CLASS;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__OBJECT_CLASS__STRUCT_HPP_
