// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/ObjectClassWithConfidence.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__OBJECT_CLASS_WITH_CONFIDENCE__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__OBJECT_CLASS_WITH_CONFIDENCE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'object_class'
#include "etsi_its_cpm_ts_msgs/msg/detail/object_class__struct.hpp"
// Member 'confidence'
#include "etsi_its_cpm_ts_msgs/msg/detail/confidence_level__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ObjectClassWithConfidence_
{
  using Type = ObjectClassWithConfidence_<ContainerAllocator>;

  explicit ObjectClassWithConfidence_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : object_class(_init),
    confidence(_init)
  {
    (void)_init;
  }

  explicit ObjectClassWithConfidence_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : object_class(_alloc, _init),
    confidence(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _object_class_type =
    etsi_its_cpm_ts_msgs::msg::ObjectClass_<ContainerAllocator>;
  _object_class_type object_class;
  using _confidence_type =
    etsi_its_cpm_ts_msgs::msg::ConfidenceLevel_<ContainerAllocator>;
  _confidence_type confidence;

  // setters for named parameter idiom
  Type & set__object_class(
    const etsi_its_cpm_ts_msgs::msg::ObjectClass_<ContainerAllocator> & _arg)
  {
    this->object_class = _arg;
    return *this;
  }
  Type & set__confidence(
    const etsi_its_cpm_ts_msgs::msg::ConfidenceLevel_<ContainerAllocator> & _arg)
  {
    this->confidence = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ObjectClassWithConfidence_ & other) const
  {
    if (this->object_class != other.object_class) {
      return false;
    }
    if (this->confidence != other.confidence) {
      return false;
    }
    return true;
  }
  bool operator!=(const ObjectClassWithConfidence_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ObjectClassWithConfidence_

// alias to use template instance with default allocator
using ObjectClassWithConfidence =
  etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__OBJECT_CLASS_WITH_CONFIDENCE__STRUCT_HPP_
