// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/ObjectClassWithConfidence.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__OBJECT_CLASS_WITH_CONFIDENCE__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__OBJECT_CLASS_WITH_CONFIDENCE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/object_class_with_confidence__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'object_class'
#include "etsi_its_cpm_ts_msgs/msg/detail/object_class__traits.hpp"
// Member 'confidence'
#include "etsi_its_cpm_ts_msgs/msg/detail/confidence_level__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ObjectClassWithConfidence & msg,
  std::ostream & out)
{
  out << "{";
  // member: object_class
  {
    out << "object_class: ";
    to_flow_style_yaml(msg.object_class, out);
    out << ", ";
  }

  // member: confidence
  {
    out << "confidence: ";
    to_flow_style_yaml(msg.confidence, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ObjectClassWithConfidence & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: object_class
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object_class:\n";
    to_block_style_yaml(msg.object_class, out, indentation + 2);
  }

  // member: confidence
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "confidence:\n";
    to_block_style_yaml(msg.confidence, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ObjectClassWithConfidence & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence>()
{
  return "etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence>()
{
  return "etsi_its_cpm_ts_msgs/msg/ObjectClassWithConfidence";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::ConfidenceLevel>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::ObjectClass>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::ConfidenceLevel>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::ObjectClass>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::ObjectClassWithConfidence>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__OBJECT_CLASS_WITH_CONFIDENCE__TRAITS_HPP_
