// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/OriginatingVehicleContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ORIGINATING_VEHICLE_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ORIGINATING_VEHICLE_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'orientation_angle'
#include "etsi_its_cpm_ts_msgs/msg/detail/wgs84_angle__struct.hpp"
// Member 'pitch_angle'
// Member 'roll_angle'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__struct.hpp"
// Member 'trailer_data_set'
#include "etsi_its_cpm_ts_msgs/msg/detail/trailer_data_set__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct OriginatingVehicleContainer_
{
  using Type = OriginatingVehicleContainer_<ContainerAllocator>;

  explicit OriginatingVehicleContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : orientation_angle(_init),
    pitch_angle(_init),
    roll_angle(_init),
    trailer_data_set(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pitch_angle_is_present = false;
      this->roll_angle_is_present = false;
      this->trailer_data_set_is_present = false;
    }
  }

  explicit OriginatingVehicleContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : orientation_angle(_alloc, _init),
    pitch_angle(_alloc, _init),
    roll_angle(_alloc, _init),
    trailer_data_set(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pitch_angle_is_present = false;
      this->roll_angle_is_present = false;
      this->trailer_data_set_is_present = false;
    }
  }

  // field types and members
  using _orientation_angle_type =
    etsi_its_cpm_ts_msgs::msg::Wgs84Angle_<ContainerAllocator>;
  _orientation_angle_type orientation_angle;
  using _pitch_angle_type =
    etsi_its_cpm_ts_msgs::msg::CartesianAngle_<ContainerAllocator>;
  _pitch_angle_type pitch_angle;
  using _pitch_angle_is_present_type =
    bool;
  _pitch_angle_is_present_type pitch_angle_is_present;
  using _roll_angle_type =
    etsi_its_cpm_ts_msgs::msg::CartesianAngle_<ContainerAllocator>;
  _roll_angle_type roll_angle;
  using _roll_angle_is_present_type =
    bool;
  _roll_angle_is_present_type roll_angle_is_present;
  using _trailer_data_set_type =
    etsi_its_cpm_ts_msgs::msg::TrailerDataSet_<ContainerAllocator>;
  _trailer_data_set_type trailer_data_set;
  using _trailer_data_set_is_present_type =
    bool;
  _trailer_data_set_is_present_type trailer_data_set_is_present;

  // setters for named parameter idiom
  Type & set__orientation_angle(
    const etsi_its_cpm_ts_msgs::msg::Wgs84Angle_<ContainerAllocator> & _arg)
  {
    this->orientation_angle = _arg;
    return *this;
  }
  Type & set__pitch_angle(
    const etsi_its_cpm_ts_msgs::msg::CartesianAngle_<ContainerAllocator> & _arg)
  {
    this->pitch_angle = _arg;
    return *this;
  }
  Type & set__pitch_angle_is_present(
    const bool & _arg)
  {
    this->pitch_angle_is_present = _arg;
    return *this;
  }
  Type & set__roll_angle(
    const etsi_its_cpm_ts_msgs::msg::CartesianAngle_<ContainerAllocator> & _arg)
  {
    this->roll_angle = _arg;
    return *this;
  }
  Type & set__roll_angle_is_present(
    const bool & _arg)
  {
    this->roll_angle_is_present = _arg;
    return *this;
  }
  Type & set__trailer_data_set(
    const etsi_its_cpm_ts_msgs::msg::TrailerDataSet_<ContainerAllocator> & _arg)
  {
    this->trailer_data_set = _arg;
    return *this;
  }
  Type & set__trailer_data_set_is_present(
    const bool & _arg)
  {
    this->trailer_data_set_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const OriginatingVehicleContainer_ & other) const
  {
    if (this->orientation_angle != other.orientation_angle) {
      return false;
    }
    if (this->pitch_angle != other.pitch_angle) {
      return false;
    }
    if (this->pitch_angle_is_present != other.pitch_angle_is_present) {
      return false;
    }
    if (this->roll_angle != other.roll_angle) {
      return false;
    }
    if (this->roll_angle_is_present != other.roll_angle_is_present) {
      return false;
    }
    if (this->trailer_data_set != other.trailer_data_set) {
      return false;
    }
    if (this->trailer_data_set_is_present != other.trailer_data_set_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const OriginatingVehicleContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct OriginatingVehicleContainer_

// alias to use template instance with default allocator
using OriginatingVehicleContainer =
  etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ORIGINATING_VEHICLE_CONTAINER__STRUCT_HPP_
