// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/OriginatingVehicleContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ORIGINATING_VEHICLE_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ORIGINATING_VEHICLE_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/originating_vehicle_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'orientation_angle'
#include "etsi_its_cpm_ts_msgs/msg/detail/wgs84_angle__traits.hpp"
// Member 'pitch_angle'
// Member 'roll_angle'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__traits.hpp"
// Member 'trailer_data_set'
#include "etsi_its_cpm_ts_msgs/msg/detail/trailer_data_set__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const OriginatingVehicleContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: orientation_angle
  {
    out << "orientation_angle: ";
    to_flow_style_yaml(msg.orientation_angle, out);
    out << ", ";
  }

  // member: pitch_angle
  {
    out << "pitch_angle: ";
    to_flow_style_yaml(msg.pitch_angle, out);
    out << ", ";
  }

  // member: pitch_angle_is_present
  {
    out << "pitch_angle_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.pitch_angle_is_present, out);
    out << ", ";
  }

  // member: roll_angle
  {
    out << "roll_angle: ";
    to_flow_style_yaml(msg.roll_angle, out);
    out << ", ";
  }

  // member: roll_angle_is_present
  {
    out << "roll_angle_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.roll_angle_is_present, out);
    out << ", ";
  }

  // member: trailer_data_set
  {
    out << "trailer_data_set: ";
    to_flow_style_yaml(msg.trailer_data_set, out);
    out << ", ";
  }

  // member: trailer_data_set_is_present
  {
    out << "trailer_data_set_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.trailer_data_set_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const OriginatingVehicleContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: orientation_angle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "orientation_angle:\n";
    to_block_style_yaml(msg.orientation_angle, out, indentation + 2);
  }

  // member: pitch_angle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pitch_angle:\n";
    to_block_style_yaml(msg.pitch_angle, out, indentation + 2);
  }

  // member: pitch_angle_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pitch_angle_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.pitch_angle_is_present, out);
    out << "\n";
  }

  // member: roll_angle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "roll_angle:\n";
    to_block_style_yaml(msg.roll_angle, out, indentation + 2);
  }

  // member: roll_angle_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "roll_angle_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.roll_angle_is_present, out);
    out << "\n";
  }

  // member: trailer_data_set
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "trailer_data_set:\n";
    to_block_style_yaml(msg.trailer_data_set, out, indentation + 2);
  }

  // member: trailer_data_set_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "trailer_data_set_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.trailer_data_set_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const OriginatingVehicleContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer>()
{
  return "etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer>()
{
  return "etsi_its_cpm_ts_msgs/msg/OriginatingVehicleContainer";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::CartesianAngle>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::TrailerDataSet>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::Wgs84Angle>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::CartesianAngle>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::TrailerDataSet>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::Wgs84Angle>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ORIGINATING_VEHICLE_CONTAINER__TRAITS_HPP_
