// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/PerceivedObject.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/perceived_object__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `object_id`
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier2_b__functions.h"
// Member `measurement_delta_time`
// Member `object_age`
#include "etsi_its_cpm_ts_msgs/msg/detail/delta_time_milli_second_signed__functions.h"
// Member `position`
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_position3d_with_confidence__functions.h"
// Member `velocity`
#include "etsi_its_cpm_ts_msgs/msg/detail/velocity3d_with_confidence__functions.h"
// Member `acceleration`
#include "etsi_its_cpm_ts_msgs/msg/detail/acceleration3d_with_confidence__functions.h"
// Member `angles`
#include "etsi_its_cpm_ts_msgs/msg/detail/euler_angles_with_confidence__functions.h"
// Member `z_angular_velocity`
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angular_velocity_component__functions.h"
// Member `lower_triangular_correlation_matrices`
#include "etsi_its_cpm_ts_msgs/msg/detail/lower_triangular_positive_semidefinite_matrices__functions.h"
// Member `object_dimension_z`
// Member `object_dimension_y`
// Member `object_dimension_x`
#include "etsi_its_cpm_ts_msgs/msg/detail/object_dimension__functions.h"
// Member `object_perception_quality`
#include "etsi_its_cpm_ts_msgs/msg/detail/object_perception_quality__functions.h"
// Member `sensor_id_list`
#include "etsi_its_cpm_ts_msgs/msg/detail/sequence_of_identifier1_b__functions.h"
// Member `classification`
#include "etsi_its_cpm_ts_msgs/msg/detail/object_class_description__functions.h"
// Member `map_position`
#include "etsi_its_cpm_ts_msgs/msg/detail/map_position__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__PerceivedObject__init(etsi_its_cpm_ts_msgs__msg__PerceivedObject * msg)
{
  if (!msg) {
    return false;
  }
  // object_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier2B__init(&msg->object_id)) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(msg);
    return false;
  }
  // object_id_is_present
  // measurement_delta_time
  if (!etsi_its_cpm_ts_msgs__msg__DeltaTimeMilliSecondSigned__init(&msg->measurement_delta_time)) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(msg);
    return false;
  }
  // position
  if (!etsi_its_cpm_ts_msgs__msg__CartesianPosition3dWithConfidence__init(&msg->position)) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(msg);
    return false;
  }
  // velocity
  if (!etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__init(&msg->velocity)) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(msg);
    return false;
  }
  // velocity_is_present
  // acceleration
  if (!etsi_its_cpm_ts_msgs__msg__Acceleration3dWithConfidence__init(&msg->acceleration)) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(msg);
    return false;
  }
  // acceleration_is_present
  // angles
  if (!etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__init(&msg->angles)) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(msg);
    return false;
  }
  // angles_is_present
  // z_angular_velocity
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngularVelocityComponent__init(&msg->z_angular_velocity)) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(msg);
    return false;
  }
  // z_angular_velocity_is_present
  // lower_triangular_correlation_matrices
  if (!etsi_its_cpm_ts_msgs__msg__LowerTriangularPositiveSemidefiniteMatrices__init(&msg->lower_triangular_correlation_matrices)) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(msg);
    return false;
  }
  // lower_triangular_correlation_matrices_is_present
  // object_dimension_z
  if (!etsi_its_cpm_ts_msgs__msg__ObjectDimension__init(&msg->object_dimension_z)) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(msg);
    return false;
  }
  // object_dimension_z_is_present
  // object_dimension_y
  if (!etsi_its_cpm_ts_msgs__msg__ObjectDimension__init(&msg->object_dimension_y)) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(msg);
    return false;
  }
  // object_dimension_y_is_present
  // object_dimension_x
  if (!etsi_its_cpm_ts_msgs__msg__ObjectDimension__init(&msg->object_dimension_x)) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(msg);
    return false;
  }
  // object_dimension_x_is_present
  // object_age
  if (!etsi_its_cpm_ts_msgs__msg__DeltaTimeMilliSecondSigned__init(&msg->object_age)) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(msg);
    return false;
  }
  // object_age_is_present
  // object_perception_quality
  if (!etsi_its_cpm_ts_msgs__msg__ObjectPerceptionQuality__init(&msg->object_perception_quality)) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(msg);
    return false;
  }
  // object_perception_quality_is_present
  // sensor_id_list
  if (!etsi_its_cpm_ts_msgs__msg__SequenceOfIdentifier1B__init(&msg->sensor_id_list)) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(msg);
    return false;
  }
  // sensor_id_list_is_present
  // classification
  if (!etsi_its_cpm_ts_msgs__msg__ObjectClassDescription__init(&msg->classification)) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(msg);
    return false;
  }
  // classification_is_present
  // map_position
  if (!etsi_its_cpm_ts_msgs__msg__MapPosition__init(&msg->map_position)) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(msg);
    return false;
  }
  // map_position_is_present
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(etsi_its_cpm_ts_msgs__msg__PerceivedObject * msg)
{
  if (!msg) {
    return;
  }
  // object_id
  etsi_its_cpm_ts_msgs__msg__Identifier2B__fini(&msg->object_id);
  // object_id_is_present
  // measurement_delta_time
  etsi_its_cpm_ts_msgs__msg__DeltaTimeMilliSecondSigned__fini(&msg->measurement_delta_time);
  // position
  etsi_its_cpm_ts_msgs__msg__CartesianPosition3dWithConfidence__fini(&msg->position);
  // velocity
  etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__fini(&msg->velocity);
  // velocity_is_present
  // acceleration
  etsi_its_cpm_ts_msgs__msg__Acceleration3dWithConfidence__fini(&msg->acceleration);
  // acceleration_is_present
  // angles
  etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__fini(&msg->angles);
  // angles_is_present
  // z_angular_velocity
  etsi_its_cpm_ts_msgs__msg__CartesianAngularVelocityComponent__fini(&msg->z_angular_velocity);
  // z_angular_velocity_is_present
  // lower_triangular_correlation_matrices
  etsi_its_cpm_ts_msgs__msg__LowerTriangularPositiveSemidefiniteMatrices__fini(&msg->lower_triangular_correlation_matrices);
  // lower_triangular_correlation_matrices_is_present
  // object_dimension_z
  etsi_its_cpm_ts_msgs__msg__ObjectDimension__fini(&msg->object_dimension_z);
  // object_dimension_z_is_present
  // object_dimension_y
  etsi_its_cpm_ts_msgs__msg__ObjectDimension__fini(&msg->object_dimension_y);
  // object_dimension_y_is_present
  // object_dimension_x
  etsi_its_cpm_ts_msgs__msg__ObjectDimension__fini(&msg->object_dimension_x);
  // object_dimension_x_is_present
  // object_age
  etsi_its_cpm_ts_msgs__msg__DeltaTimeMilliSecondSigned__fini(&msg->object_age);
  // object_age_is_present
  // object_perception_quality
  etsi_its_cpm_ts_msgs__msg__ObjectPerceptionQuality__fini(&msg->object_perception_quality);
  // object_perception_quality_is_present
  // sensor_id_list
  etsi_its_cpm_ts_msgs__msg__SequenceOfIdentifier1B__fini(&msg->sensor_id_list);
  // sensor_id_list_is_present
  // classification
  etsi_its_cpm_ts_msgs__msg__ObjectClassDescription__fini(&msg->classification);
  // classification_is_present
  // map_position
  etsi_its_cpm_ts_msgs__msg__MapPosition__fini(&msg->map_position);
  // map_position_is_present
}

bool
etsi_its_cpm_ts_msgs__msg__PerceivedObject__are_equal(const etsi_its_cpm_ts_msgs__msg__PerceivedObject * lhs, const etsi_its_cpm_ts_msgs__msg__PerceivedObject * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // object_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier2B__are_equal(
      &(lhs->object_id), &(rhs->object_id)))
  {
    return false;
  }
  // object_id_is_present
  if (lhs->object_id_is_present != rhs->object_id_is_present) {
    return false;
  }
  // measurement_delta_time
  if (!etsi_its_cpm_ts_msgs__msg__DeltaTimeMilliSecondSigned__are_equal(
      &(lhs->measurement_delta_time), &(rhs->measurement_delta_time)))
  {
    return false;
  }
  // position
  if (!etsi_its_cpm_ts_msgs__msg__CartesianPosition3dWithConfidence__are_equal(
      &(lhs->position), &(rhs->position)))
  {
    return false;
  }
  // velocity
  if (!etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__are_equal(
      &(lhs->velocity), &(rhs->velocity)))
  {
    return false;
  }
  // velocity_is_present
  if (lhs->velocity_is_present != rhs->velocity_is_present) {
    return false;
  }
  // acceleration
  if (!etsi_its_cpm_ts_msgs__msg__Acceleration3dWithConfidence__are_equal(
      &(lhs->acceleration), &(rhs->acceleration)))
  {
    return false;
  }
  // acceleration_is_present
  if (lhs->acceleration_is_present != rhs->acceleration_is_present) {
    return false;
  }
  // angles
  if (!etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__are_equal(
      &(lhs->angles), &(rhs->angles)))
  {
    return false;
  }
  // angles_is_present
  if (lhs->angles_is_present != rhs->angles_is_present) {
    return false;
  }
  // z_angular_velocity
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngularVelocityComponent__are_equal(
      &(lhs->z_angular_velocity), &(rhs->z_angular_velocity)))
  {
    return false;
  }
  // z_angular_velocity_is_present
  if (lhs->z_angular_velocity_is_present != rhs->z_angular_velocity_is_present) {
    return false;
  }
  // lower_triangular_correlation_matrices
  if (!etsi_its_cpm_ts_msgs__msg__LowerTriangularPositiveSemidefiniteMatrices__are_equal(
      &(lhs->lower_triangular_correlation_matrices), &(rhs->lower_triangular_correlation_matrices)))
  {
    return false;
  }
  // lower_triangular_correlation_matrices_is_present
  if (lhs->lower_triangular_correlation_matrices_is_present != rhs->lower_triangular_correlation_matrices_is_present) {
    return false;
  }
  // object_dimension_z
  if (!etsi_its_cpm_ts_msgs__msg__ObjectDimension__are_equal(
      &(lhs->object_dimension_z), &(rhs->object_dimension_z)))
  {
    return false;
  }
  // object_dimension_z_is_present
  if (lhs->object_dimension_z_is_present != rhs->object_dimension_z_is_present) {
    return false;
  }
  // object_dimension_y
  if (!etsi_its_cpm_ts_msgs__msg__ObjectDimension__are_equal(
      &(lhs->object_dimension_y), &(rhs->object_dimension_y)))
  {
    return false;
  }
  // object_dimension_y_is_present
  if (lhs->object_dimension_y_is_present != rhs->object_dimension_y_is_present) {
    return false;
  }
  // object_dimension_x
  if (!etsi_its_cpm_ts_msgs__msg__ObjectDimension__are_equal(
      &(lhs->object_dimension_x), &(rhs->object_dimension_x)))
  {
    return false;
  }
  // object_dimension_x_is_present
  if (lhs->object_dimension_x_is_present != rhs->object_dimension_x_is_present) {
    return false;
  }
  // object_age
  if (!etsi_its_cpm_ts_msgs__msg__DeltaTimeMilliSecondSigned__are_equal(
      &(lhs->object_age), &(rhs->object_age)))
  {
    return false;
  }
  // object_age_is_present
  if (lhs->object_age_is_present != rhs->object_age_is_present) {
    return false;
  }
  // object_perception_quality
  if (!etsi_its_cpm_ts_msgs__msg__ObjectPerceptionQuality__are_equal(
      &(lhs->object_perception_quality), &(rhs->object_perception_quality)))
  {
    return false;
  }
  // object_perception_quality_is_present
  if (lhs->object_perception_quality_is_present != rhs->object_perception_quality_is_present) {
    return false;
  }
  // sensor_id_list
  if (!etsi_its_cpm_ts_msgs__msg__SequenceOfIdentifier1B__are_equal(
      &(lhs->sensor_id_list), &(rhs->sensor_id_list)))
  {
    return false;
  }
  // sensor_id_list_is_present
  if (lhs->sensor_id_list_is_present != rhs->sensor_id_list_is_present) {
    return false;
  }
  // classification
  if (!etsi_its_cpm_ts_msgs__msg__ObjectClassDescription__are_equal(
      &(lhs->classification), &(rhs->classification)))
  {
    return false;
  }
  // classification_is_present
  if (lhs->classification_is_present != rhs->classification_is_present) {
    return false;
  }
  // map_position
  if (!etsi_its_cpm_ts_msgs__msg__MapPosition__are_equal(
      &(lhs->map_position), &(rhs->map_position)))
  {
    return false;
  }
  // map_position_is_present
  if (lhs->map_position_is_present != rhs->map_position_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__PerceivedObject__copy(
  const etsi_its_cpm_ts_msgs__msg__PerceivedObject * input,
  etsi_its_cpm_ts_msgs__msg__PerceivedObject * output)
{
  if (!input || !output) {
    return false;
  }
  // object_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier2B__copy(
      &(input->object_id), &(output->object_id)))
  {
    return false;
  }
  // object_id_is_present
  output->object_id_is_present = input->object_id_is_present;
  // measurement_delta_time
  if (!etsi_its_cpm_ts_msgs__msg__DeltaTimeMilliSecondSigned__copy(
      &(input->measurement_delta_time), &(output->measurement_delta_time)))
  {
    return false;
  }
  // position
  if (!etsi_its_cpm_ts_msgs__msg__CartesianPosition3dWithConfidence__copy(
      &(input->position), &(output->position)))
  {
    return false;
  }
  // velocity
  if (!etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__copy(
      &(input->velocity), &(output->velocity)))
  {
    return false;
  }
  // velocity_is_present
  output->velocity_is_present = input->velocity_is_present;
  // acceleration
  if (!etsi_its_cpm_ts_msgs__msg__Acceleration3dWithConfidence__copy(
      &(input->acceleration), &(output->acceleration)))
  {
    return false;
  }
  // acceleration_is_present
  output->acceleration_is_present = input->acceleration_is_present;
  // angles
  if (!etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__copy(
      &(input->angles), &(output->angles)))
  {
    return false;
  }
  // angles_is_present
  output->angles_is_present = input->angles_is_present;
  // z_angular_velocity
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngularVelocityComponent__copy(
      &(input->z_angular_velocity), &(output->z_angular_velocity)))
  {
    return false;
  }
  // z_angular_velocity_is_present
  output->z_angular_velocity_is_present = input->z_angular_velocity_is_present;
  // lower_triangular_correlation_matrices
  if (!etsi_its_cpm_ts_msgs__msg__LowerTriangularPositiveSemidefiniteMatrices__copy(
      &(input->lower_triangular_correlation_matrices), &(output->lower_triangular_correlation_matrices)))
  {
    return false;
  }
  // lower_triangular_correlation_matrices_is_present
  output->lower_triangular_correlation_matrices_is_present = input->lower_triangular_correlation_matrices_is_present;
  // object_dimension_z
  if (!etsi_its_cpm_ts_msgs__msg__ObjectDimension__copy(
      &(input->object_dimension_z), &(output->object_dimension_z)))
  {
    return false;
  }
  // object_dimension_z_is_present
  output->object_dimension_z_is_present = input->object_dimension_z_is_present;
  // object_dimension_y
  if (!etsi_its_cpm_ts_msgs__msg__ObjectDimension__copy(
      &(input->object_dimension_y), &(output->object_dimension_y)))
  {
    return false;
  }
  // object_dimension_y_is_present
  output->object_dimension_y_is_present = input->object_dimension_y_is_present;
  // object_dimension_x
  if (!etsi_its_cpm_ts_msgs__msg__ObjectDimension__copy(
      &(input->object_dimension_x), &(output->object_dimension_x)))
  {
    return false;
  }
  // object_dimension_x_is_present
  output->object_dimension_x_is_present = input->object_dimension_x_is_present;
  // object_age
  if (!etsi_its_cpm_ts_msgs__msg__DeltaTimeMilliSecondSigned__copy(
      &(input->object_age), &(output->object_age)))
  {
    return false;
  }
  // object_age_is_present
  output->object_age_is_present = input->object_age_is_present;
  // object_perception_quality
  if (!etsi_its_cpm_ts_msgs__msg__ObjectPerceptionQuality__copy(
      &(input->object_perception_quality), &(output->object_perception_quality)))
  {
    return false;
  }
  // object_perception_quality_is_present
  output->object_perception_quality_is_present = input->object_perception_quality_is_present;
  // sensor_id_list
  if (!etsi_its_cpm_ts_msgs__msg__SequenceOfIdentifier1B__copy(
      &(input->sensor_id_list), &(output->sensor_id_list)))
  {
    return false;
  }
  // sensor_id_list_is_present
  output->sensor_id_list_is_present = input->sensor_id_list_is_present;
  // classification
  if (!etsi_its_cpm_ts_msgs__msg__ObjectClassDescription__copy(
      &(input->classification), &(output->classification)))
  {
    return false;
  }
  // classification_is_present
  output->classification_is_present = input->classification_is_present;
  // map_position
  if (!etsi_its_cpm_ts_msgs__msg__MapPosition__copy(
      &(input->map_position), &(output->map_position)))
  {
    return false;
  }
  // map_position_is_present
  output->map_position_is_present = input->map_position_is_present;
  return true;
}

etsi_its_cpm_ts_msgs__msg__PerceivedObject *
etsi_its_cpm_ts_msgs__msg__PerceivedObject__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__PerceivedObject * msg = (etsi_its_cpm_ts_msgs__msg__PerceivedObject *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__PerceivedObject), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__PerceivedObject));
  bool success = etsi_its_cpm_ts_msgs__msg__PerceivedObject__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__PerceivedObject__destroy(etsi_its_cpm_ts_msgs__msg__PerceivedObject * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence__init(etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__PerceivedObject * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__PerceivedObject *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__PerceivedObject), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__PerceivedObject__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence__fini(etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence *
etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence * array = (etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__PerceivedObject__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__PerceivedObject);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__PerceivedObject * data =
      (etsi_its_cpm_ts_msgs__msg__PerceivedObject *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__PerceivedObject__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__PerceivedObject__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__PerceivedObject__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
