// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/PerceivedObject.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEIVED_OBJECT__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEIVED_OBJECT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/perceived_object__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'object_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier2_b__traits.hpp"
// Member 'measurement_delta_time'
// Member 'object_age'
#include "etsi_its_cpm_ts_msgs/msg/detail/delta_time_milli_second_signed__traits.hpp"
// Member 'position'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_position3d_with_confidence__traits.hpp"
// Member 'velocity'
#include "etsi_its_cpm_ts_msgs/msg/detail/velocity3d_with_confidence__traits.hpp"
// Member 'acceleration'
#include "etsi_its_cpm_ts_msgs/msg/detail/acceleration3d_with_confidence__traits.hpp"
// Member 'angles'
#include "etsi_its_cpm_ts_msgs/msg/detail/euler_angles_with_confidence__traits.hpp"
// Member 'z_angular_velocity'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angular_velocity_component__traits.hpp"
// Member 'lower_triangular_correlation_matrices'
#include "etsi_its_cpm_ts_msgs/msg/detail/lower_triangular_positive_semidefinite_matrices__traits.hpp"
// Member 'object_dimension_z'
// Member 'object_dimension_y'
// Member 'object_dimension_x'
#include "etsi_its_cpm_ts_msgs/msg/detail/object_dimension__traits.hpp"
// Member 'object_perception_quality'
#include "etsi_its_cpm_ts_msgs/msg/detail/object_perception_quality__traits.hpp"
// Member 'sensor_id_list'
#include "etsi_its_cpm_ts_msgs/msg/detail/sequence_of_identifier1_b__traits.hpp"
// Member 'classification'
#include "etsi_its_cpm_ts_msgs/msg/detail/object_class_description__traits.hpp"
// Member 'map_position'
#include "etsi_its_cpm_ts_msgs/msg/detail/map_position__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PerceivedObject & msg,
  std::ostream & out)
{
  out << "{";
  // member: object_id
  {
    out << "object_id: ";
    to_flow_style_yaml(msg.object_id, out);
    out << ", ";
  }

  // member: object_id_is_present
  {
    out << "object_id_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.object_id_is_present, out);
    out << ", ";
  }

  // member: measurement_delta_time
  {
    out << "measurement_delta_time: ";
    to_flow_style_yaml(msg.measurement_delta_time, out);
    out << ", ";
  }

  // member: position
  {
    out << "position: ";
    to_flow_style_yaml(msg.position, out);
    out << ", ";
  }

  // member: velocity
  {
    out << "velocity: ";
    to_flow_style_yaml(msg.velocity, out);
    out << ", ";
  }

  // member: velocity_is_present
  {
    out << "velocity_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.velocity_is_present, out);
    out << ", ";
  }

  // member: acceleration
  {
    out << "acceleration: ";
    to_flow_style_yaml(msg.acceleration, out);
    out << ", ";
  }

  // member: acceleration_is_present
  {
    out << "acceleration_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.acceleration_is_present, out);
    out << ", ";
  }

  // member: angles
  {
    out << "angles: ";
    to_flow_style_yaml(msg.angles, out);
    out << ", ";
  }

  // member: angles_is_present
  {
    out << "angles_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.angles_is_present, out);
    out << ", ";
  }

  // member: z_angular_velocity
  {
    out << "z_angular_velocity: ";
    to_flow_style_yaml(msg.z_angular_velocity, out);
    out << ", ";
  }

  // member: z_angular_velocity_is_present
  {
    out << "z_angular_velocity_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.z_angular_velocity_is_present, out);
    out << ", ";
  }

  // member: lower_triangular_correlation_matrices
  {
    out << "lower_triangular_correlation_matrices: ";
    to_flow_style_yaml(msg.lower_triangular_correlation_matrices, out);
    out << ", ";
  }

  // member: lower_triangular_correlation_matrices_is_present
  {
    out << "lower_triangular_correlation_matrices_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lower_triangular_correlation_matrices_is_present, out);
    out << ", ";
  }

  // member: object_dimension_z
  {
    out << "object_dimension_z: ";
    to_flow_style_yaml(msg.object_dimension_z, out);
    out << ", ";
  }

  // member: object_dimension_z_is_present
  {
    out << "object_dimension_z_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.object_dimension_z_is_present, out);
    out << ", ";
  }

  // member: object_dimension_y
  {
    out << "object_dimension_y: ";
    to_flow_style_yaml(msg.object_dimension_y, out);
    out << ", ";
  }

  // member: object_dimension_y_is_present
  {
    out << "object_dimension_y_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.object_dimension_y_is_present, out);
    out << ", ";
  }

  // member: object_dimension_x
  {
    out << "object_dimension_x: ";
    to_flow_style_yaml(msg.object_dimension_x, out);
    out << ", ";
  }

  // member: object_dimension_x_is_present
  {
    out << "object_dimension_x_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.object_dimension_x_is_present, out);
    out << ", ";
  }

  // member: object_age
  {
    out << "object_age: ";
    to_flow_style_yaml(msg.object_age, out);
    out << ", ";
  }

  // member: object_age_is_present
  {
    out << "object_age_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.object_age_is_present, out);
    out << ", ";
  }

  // member: object_perception_quality
  {
    out << "object_perception_quality: ";
    to_flow_style_yaml(msg.object_perception_quality, out);
    out << ", ";
  }

  // member: object_perception_quality_is_present
  {
    out << "object_perception_quality_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.object_perception_quality_is_present, out);
    out << ", ";
  }

  // member: sensor_id_list
  {
    out << "sensor_id_list: ";
    to_flow_style_yaml(msg.sensor_id_list, out);
    out << ", ";
  }

  // member: sensor_id_list_is_present
  {
    out << "sensor_id_list_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_id_list_is_present, out);
    out << ", ";
  }

  // member: classification
  {
    out << "classification: ";
    to_flow_style_yaml(msg.classification, out);
    out << ", ";
  }

  // member: classification_is_present
  {
    out << "classification_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.classification_is_present, out);
    out << ", ";
  }

  // member: map_position
  {
    out << "map_position: ";
    to_flow_style_yaml(msg.map_position, out);
    out << ", ";
  }

  // member: map_position_is_present
  {
    out << "map_position_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.map_position_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PerceivedObject & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: object_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object_id:\n";
    to_block_style_yaml(msg.object_id, out, indentation + 2);
  }

  // member: object_id_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object_id_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.object_id_is_present, out);
    out << "\n";
  }

  // member: measurement_delta_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "measurement_delta_time:\n";
    to_block_style_yaml(msg.measurement_delta_time, out, indentation + 2);
  }

  // member: position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "position:\n";
    to_block_style_yaml(msg.position, out, indentation + 2);
  }

  // member: velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "velocity:\n";
    to_block_style_yaml(msg.velocity, out, indentation + 2);
  }

  // member: velocity_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "velocity_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.velocity_is_present, out);
    out << "\n";
  }

  // member: acceleration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "acceleration:\n";
    to_block_style_yaml(msg.acceleration, out, indentation + 2);
  }

  // member: acceleration_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "acceleration_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.acceleration_is_present, out);
    out << "\n";
  }

  // member: angles
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "angles:\n";
    to_block_style_yaml(msg.angles, out, indentation + 2);
  }

  // member: angles_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "angles_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.angles_is_present, out);
    out << "\n";
  }

  // member: z_angular_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "z_angular_velocity:\n";
    to_block_style_yaml(msg.z_angular_velocity, out, indentation + 2);
  }

  // member: z_angular_velocity_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "z_angular_velocity_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.z_angular_velocity_is_present, out);
    out << "\n";
  }

  // member: lower_triangular_correlation_matrices
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lower_triangular_correlation_matrices:\n";
    to_block_style_yaml(msg.lower_triangular_correlation_matrices, out, indentation + 2);
  }

  // member: lower_triangular_correlation_matrices_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lower_triangular_correlation_matrices_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lower_triangular_correlation_matrices_is_present, out);
    out << "\n";
  }

  // member: object_dimension_z
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object_dimension_z:\n";
    to_block_style_yaml(msg.object_dimension_z, out, indentation + 2);
  }

  // member: object_dimension_z_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object_dimension_z_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.object_dimension_z_is_present, out);
    out << "\n";
  }

  // member: object_dimension_y
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object_dimension_y:\n";
    to_block_style_yaml(msg.object_dimension_y, out, indentation + 2);
  }

  // member: object_dimension_y_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object_dimension_y_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.object_dimension_y_is_present, out);
    out << "\n";
  }

  // member: object_dimension_x
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object_dimension_x:\n";
    to_block_style_yaml(msg.object_dimension_x, out, indentation + 2);
  }

  // member: object_dimension_x_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object_dimension_x_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.object_dimension_x_is_present, out);
    out << "\n";
  }

  // member: object_age
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object_age:\n";
    to_block_style_yaml(msg.object_age, out, indentation + 2);
  }

  // member: object_age_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object_age_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.object_age_is_present, out);
    out << "\n";
  }

  // member: object_perception_quality
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object_perception_quality:\n";
    to_block_style_yaml(msg.object_perception_quality, out, indentation + 2);
  }

  // member: object_perception_quality_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object_perception_quality_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.object_perception_quality_is_present, out);
    out << "\n";
  }

  // member: sensor_id_list
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_id_list:\n";
    to_block_style_yaml(msg.sensor_id_list, out, indentation + 2);
  }

  // member: sensor_id_list_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_id_list_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_id_list_is_present, out);
    out << "\n";
  }

  // member: classification
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "classification:\n";
    to_block_style_yaml(msg.classification, out, indentation + 2);
  }

  // member: classification_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "classification_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.classification_is_present, out);
    out << "\n";
  }

  // member: map_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "map_position:\n";
    to_block_style_yaml(msg.map_position, out, indentation + 2);
  }

  // member: map_position_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "map_position_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.map_position_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PerceivedObject & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::PerceivedObject & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::PerceivedObject & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::PerceivedObject>()
{
  return "etsi_its_cpm_ts_msgs::msg::PerceivedObject";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::PerceivedObject>()
{
  return "etsi_its_cpm_ts_msgs/msg/PerceivedObject";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::PerceivedObject>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::Acceleration3dWithConfidence>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::CartesianAngularVelocityComponent>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::CartesianPosition3dWithConfidence>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::DeltaTimeMilliSecondSigned>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::Identifier2B>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrices>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::MapPosition>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::ObjectClassDescription>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::ObjectDimension>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::ObjectPerceptionQuality>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::SequenceOfIdentifier1B>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::Velocity3dWithConfidence>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::PerceivedObject>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::Acceleration3dWithConfidence>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::CartesianAngularVelocityComponent>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::CartesianPosition3dWithConfidence>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::DeltaTimeMilliSecondSigned>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::Identifier2B>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrices>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::MapPosition>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::ObjectClassDescription>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::ObjectDimension>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::ObjectPerceptionQuality>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::SequenceOfIdentifier1B>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::Velocity3dWithConfidence>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::PerceivedObject>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEIVED_OBJECT__TRAITS_HPP_
