// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/PerceptionRegion.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/perception_region__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `measurement_delta_time`
#include "etsi_its_cpm_ts_msgs/msg/detail/delta_time_milli_second_signed__functions.h"
// Member `perception_region_confidence`
#include "etsi_its_cpm_ts_msgs/msg/detail/confidence_level__functions.h"
// Member `perception_region_shape`
#include "etsi_its_cpm_ts_msgs/msg/detail/shape__functions.h"
// Member `sensor_id_list`
#include "etsi_its_cpm_ts_msgs/msg/detail/sequence_of_identifier1_b__functions.h"
// Member `number_of_perceived_objects`
#include "etsi_its_cpm_ts_msgs/msg/detail/cardinal_number1_b__functions.h"
// Member `perceived_object_ids`
#include "etsi_its_cpm_ts_msgs/msg/detail/perceived_object_ids__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__PerceptionRegion__init(etsi_its_cpm_ts_msgs__msg__PerceptionRegion * msg)
{
  if (!msg) {
    return false;
  }
  // measurement_delta_time
  if (!etsi_its_cpm_ts_msgs__msg__DeltaTimeMilliSecondSigned__init(&msg->measurement_delta_time)) {
    etsi_its_cpm_ts_msgs__msg__PerceptionRegion__fini(msg);
    return false;
  }
  // perception_region_confidence
  if (!etsi_its_cpm_ts_msgs__msg__ConfidenceLevel__init(&msg->perception_region_confidence)) {
    etsi_its_cpm_ts_msgs__msg__PerceptionRegion__fini(msg);
    return false;
  }
  // perception_region_shape
  if (!etsi_its_cpm_ts_msgs__msg__Shape__init(&msg->perception_region_shape)) {
    etsi_its_cpm_ts_msgs__msg__PerceptionRegion__fini(msg);
    return false;
  }
  // shadowing_applies
  // sensor_id_list
  if (!etsi_its_cpm_ts_msgs__msg__SequenceOfIdentifier1B__init(&msg->sensor_id_list)) {
    etsi_its_cpm_ts_msgs__msg__PerceptionRegion__fini(msg);
    return false;
  }
  // sensor_id_list_is_present
  // number_of_perceived_objects
  if (!etsi_its_cpm_ts_msgs__msg__CardinalNumber1B__init(&msg->number_of_perceived_objects)) {
    etsi_its_cpm_ts_msgs__msg__PerceptionRegion__fini(msg);
    return false;
  }
  // number_of_perceived_objects_is_present
  // perceived_object_ids
  if (!etsi_its_cpm_ts_msgs__msg__PerceivedObjectIds__init(&msg->perceived_object_ids)) {
    etsi_its_cpm_ts_msgs__msg__PerceptionRegion__fini(msg);
    return false;
  }
  // perceived_object_ids_is_present
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__PerceptionRegion__fini(etsi_its_cpm_ts_msgs__msg__PerceptionRegion * msg)
{
  if (!msg) {
    return;
  }
  // measurement_delta_time
  etsi_its_cpm_ts_msgs__msg__DeltaTimeMilliSecondSigned__fini(&msg->measurement_delta_time);
  // perception_region_confidence
  etsi_its_cpm_ts_msgs__msg__ConfidenceLevel__fini(&msg->perception_region_confidence);
  // perception_region_shape
  etsi_its_cpm_ts_msgs__msg__Shape__fini(&msg->perception_region_shape);
  // shadowing_applies
  // sensor_id_list
  etsi_its_cpm_ts_msgs__msg__SequenceOfIdentifier1B__fini(&msg->sensor_id_list);
  // sensor_id_list_is_present
  // number_of_perceived_objects
  etsi_its_cpm_ts_msgs__msg__CardinalNumber1B__fini(&msg->number_of_perceived_objects);
  // number_of_perceived_objects_is_present
  // perceived_object_ids
  etsi_its_cpm_ts_msgs__msg__PerceivedObjectIds__fini(&msg->perceived_object_ids);
  // perceived_object_ids_is_present
}

bool
etsi_its_cpm_ts_msgs__msg__PerceptionRegion__are_equal(const etsi_its_cpm_ts_msgs__msg__PerceptionRegion * lhs, const etsi_its_cpm_ts_msgs__msg__PerceptionRegion * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // measurement_delta_time
  if (!etsi_its_cpm_ts_msgs__msg__DeltaTimeMilliSecondSigned__are_equal(
      &(lhs->measurement_delta_time), &(rhs->measurement_delta_time)))
  {
    return false;
  }
  // perception_region_confidence
  if (!etsi_its_cpm_ts_msgs__msg__ConfidenceLevel__are_equal(
      &(lhs->perception_region_confidence), &(rhs->perception_region_confidence)))
  {
    return false;
  }
  // perception_region_shape
  if (!etsi_its_cpm_ts_msgs__msg__Shape__are_equal(
      &(lhs->perception_region_shape), &(rhs->perception_region_shape)))
  {
    return false;
  }
  // shadowing_applies
  if (lhs->shadowing_applies != rhs->shadowing_applies) {
    return false;
  }
  // sensor_id_list
  if (!etsi_its_cpm_ts_msgs__msg__SequenceOfIdentifier1B__are_equal(
      &(lhs->sensor_id_list), &(rhs->sensor_id_list)))
  {
    return false;
  }
  // sensor_id_list_is_present
  if (lhs->sensor_id_list_is_present != rhs->sensor_id_list_is_present) {
    return false;
  }
  // number_of_perceived_objects
  if (!etsi_its_cpm_ts_msgs__msg__CardinalNumber1B__are_equal(
      &(lhs->number_of_perceived_objects), &(rhs->number_of_perceived_objects)))
  {
    return false;
  }
  // number_of_perceived_objects_is_present
  if (lhs->number_of_perceived_objects_is_present != rhs->number_of_perceived_objects_is_present) {
    return false;
  }
  // perceived_object_ids
  if (!etsi_its_cpm_ts_msgs__msg__PerceivedObjectIds__are_equal(
      &(lhs->perceived_object_ids), &(rhs->perceived_object_ids)))
  {
    return false;
  }
  // perceived_object_ids_is_present
  if (lhs->perceived_object_ids_is_present != rhs->perceived_object_ids_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__PerceptionRegion__copy(
  const etsi_its_cpm_ts_msgs__msg__PerceptionRegion * input,
  etsi_its_cpm_ts_msgs__msg__PerceptionRegion * output)
{
  if (!input || !output) {
    return false;
  }
  // measurement_delta_time
  if (!etsi_its_cpm_ts_msgs__msg__DeltaTimeMilliSecondSigned__copy(
      &(input->measurement_delta_time), &(output->measurement_delta_time)))
  {
    return false;
  }
  // perception_region_confidence
  if (!etsi_its_cpm_ts_msgs__msg__ConfidenceLevel__copy(
      &(input->perception_region_confidence), &(output->perception_region_confidence)))
  {
    return false;
  }
  // perception_region_shape
  if (!etsi_its_cpm_ts_msgs__msg__Shape__copy(
      &(input->perception_region_shape), &(output->perception_region_shape)))
  {
    return false;
  }
  // shadowing_applies
  output->shadowing_applies = input->shadowing_applies;
  // sensor_id_list
  if (!etsi_its_cpm_ts_msgs__msg__SequenceOfIdentifier1B__copy(
      &(input->sensor_id_list), &(output->sensor_id_list)))
  {
    return false;
  }
  // sensor_id_list_is_present
  output->sensor_id_list_is_present = input->sensor_id_list_is_present;
  // number_of_perceived_objects
  if (!etsi_its_cpm_ts_msgs__msg__CardinalNumber1B__copy(
      &(input->number_of_perceived_objects), &(output->number_of_perceived_objects)))
  {
    return false;
  }
  // number_of_perceived_objects_is_present
  output->number_of_perceived_objects_is_present = input->number_of_perceived_objects_is_present;
  // perceived_object_ids
  if (!etsi_its_cpm_ts_msgs__msg__PerceivedObjectIds__copy(
      &(input->perceived_object_ids), &(output->perceived_object_ids)))
  {
    return false;
  }
  // perceived_object_ids_is_present
  output->perceived_object_ids_is_present = input->perceived_object_ids_is_present;
  return true;
}

etsi_its_cpm_ts_msgs__msg__PerceptionRegion *
etsi_its_cpm_ts_msgs__msg__PerceptionRegion__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__PerceptionRegion * msg = (etsi_its_cpm_ts_msgs__msg__PerceptionRegion *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__PerceptionRegion), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__PerceptionRegion));
  bool success = etsi_its_cpm_ts_msgs__msg__PerceptionRegion__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__PerceptionRegion__destroy(etsi_its_cpm_ts_msgs__msg__PerceptionRegion * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__PerceptionRegion__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence__init(etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__PerceptionRegion * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__PerceptionRegion *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__PerceptionRegion), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__PerceptionRegion__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__PerceptionRegion__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence__fini(etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__PerceptionRegion__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence *
etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence * array = (etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__PerceptionRegion__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__PerceptionRegion);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__PerceptionRegion * data =
      (etsi_its_cpm_ts_msgs__msg__PerceptionRegion *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__PerceptionRegion__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__PerceptionRegion__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__PerceptionRegion__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
