// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/PerceptionRegion.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEPTION_REGION__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEPTION_REGION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'measurement_delta_time'
#include "etsi_its_cpm_ts_msgs/msg/detail/delta_time_milli_second_signed__struct.hpp"
// Member 'perception_region_confidence'
#include "etsi_its_cpm_ts_msgs/msg/detail/confidence_level__struct.hpp"
// Member 'perception_region_shape'
#include "etsi_its_cpm_ts_msgs/msg/detail/shape__struct.hpp"
// Member 'sensor_id_list'
#include "etsi_its_cpm_ts_msgs/msg/detail/sequence_of_identifier1_b__struct.hpp"
// Member 'number_of_perceived_objects'
#include "etsi_its_cpm_ts_msgs/msg/detail/cardinal_number1_b__struct.hpp"
// Member 'perceived_object_ids'
#include "etsi_its_cpm_ts_msgs/msg/detail/perceived_object_ids__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__PerceptionRegion __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__PerceptionRegion __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PerceptionRegion_
{
  using Type = PerceptionRegion_<ContainerAllocator>;

  explicit PerceptionRegion_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : measurement_delta_time(_init),
    perception_region_confidence(_init),
    perception_region_shape(_init),
    sensor_id_list(_init),
    number_of_perceived_objects(_init),
    perceived_object_ids(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->shadowing_applies = false;
      this->sensor_id_list_is_present = false;
      this->number_of_perceived_objects_is_present = false;
      this->perceived_object_ids_is_present = false;
    }
  }

  explicit PerceptionRegion_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : measurement_delta_time(_alloc, _init),
    perception_region_confidence(_alloc, _init),
    perception_region_shape(_alloc, _init),
    sensor_id_list(_alloc, _init),
    number_of_perceived_objects(_alloc, _init),
    perceived_object_ids(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->shadowing_applies = false;
      this->sensor_id_list_is_present = false;
      this->number_of_perceived_objects_is_present = false;
      this->perceived_object_ids_is_present = false;
    }
  }

  // field types and members
  using _measurement_delta_time_type =
    etsi_its_cpm_ts_msgs::msg::DeltaTimeMilliSecondSigned_<ContainerAllocator>;
  _measurement_delta_time_type measurement_delta_time;
  using _perception_region_confidence_type =
    etsi_its_cpm_ts_msgs::msg::ConfidenceLevel_<ContainerAllocator>;
  _perception_region_confidence_type perception_region_confidence;
  using _perception_region_shape_type =
    etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator>;
  _perception_region_shape_type perception_region_shape;
  using _shadowing_applies_type =
    bool;
  _shadowing_applies_type shadowing_applies;
  using _sensor_id_list_type =
    etsi_its_cpm_ts_msgs::msg::SequenceOfIdentifier1B_<ContainerAllocator>;
  _sensor_id_list_type sensor_id_list;
  using _sensor_id_list_is_present_type =
    bool;
  _sensor_id_list_is_present_type sensor_id_list_is_present;
  using _number_of_perceived_objects_type =
    etsi_its_cpm_ts_msgs::msg::CardinalNumber1B_<ContainerAllocator>;
  _number_of_perceived_objects_type number_of_perceived_objects;
  using _number_of_perceived_objects_is_present_type =
    bool;
  _number_of_perceived_objects_is_present_type number_of_perceived_objects_is_present;
  using _perceived_object_ids_type =
    etsi_its_cpm_ts_msgs::msg::PerceivedObjectIds_<ContainerAllocator>;
  _perceived_object_ids_type perceived_object_ids;
  using _perceived_object_ids_is_present_type =
    bool;
  _perceived_object_ids_is_present_type perceived_object_ids_is_present;

  // setters for named parameter idiom
  Type & set__measurement_delta_time(
    const etsi_its_cpm_ts_msgs::msg::DeltaTimeMilliSecondSigned_<ContainerAllocator> & _arg)
  {
    this->measurement_delta_time = _arg;
    return *this;
  }
  Type & set__perception_region_confidence(
    const etsi_its_cpm_ts_msgs::msg::ConfidenceLevel_<ContainerAllocator> & _arg)
  {
    this->perception_region_confidence = _arg;
    return *this;
  }
  Type & set__perception_region_shape(
    const etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator> & _arg)
  {
    this->perception_region_shape = _arg;
    return *this;
  }
  Type & set__shadowing_applies(
    const bool & _arg)
  {
    this->shadowing_applies = _arg;
    return *this;
  }
  Type & set__sensor_id_list(
    const etsi_its_cpm_ts_msgs::msg::SequenceOfIdentifier1B_<ContainerAllocator> & _arg)
  {
    this->sensor_id_list = _arg;
    return *this;
  }
  Type & set__sensor_id_list_is_present(
    const bool & _arg)
  {
    this->sensor_id_list_is_present = _arg;
    return *this;
  }
  Type & set__number_of_perceived_objects(
    const etsi_its_cpm_ts_msgs::msg::CardinalNumber1B_<ContainerAllocator> & _arg)
  {
    this->number_of_perceived_objects = _arg;
    return *this;
  }
  Type & set__number_of_perceived_objects_is_present(
    const bool & _arg)
  {
    this->number_of_perceived_objects_is_present = _arg;
    return *this;
  }
  Type & set__perceived_object_ids(
    const etsi_its_cpm_ts_msgs::msg::PerceivedObjectIds_<ContainerAllocator> & _arg)
  {
    this->perceived_object_ids = _arg;
    return *this;
  }
  Type & set__perceived_object_ids_is_present(
    const bool & _arg)
  {
    this->perceived_object_ids_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::PerceptionRegion_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::PerceptionRegion_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::PerceptionRegion_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::PerceptionRegion_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::PerceptionRegion_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::PerceptionRegion_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::PerceptionRegion_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::PerceptionRegion_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::PerceptionRegion_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::PerceptionRegion_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__PerceptionRegion
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::PerceptionRegion_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__PerceptionRegion
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::PerceptionRegion_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PerceptionRegion_ & other) const
  {
    if (this->measurement_delta_time != other.measurement_delta_time) {
      return false;
    }
    if (this->perception_region_confidence != other.perception_region_confidence) {
      return false;
    }
    if (this->perception_region_shape != other.perception_region_shape) {
      return false;
    }
    if (this->shadowing_applies != other.shadowing_applies) {
      return false;
    }
    if (this->sensor_id_list != other.sensor_id_list) {
      return false;
    }
    if (this->sensor_id_list_is_present != other.sensor_id_list_is_present) {
      return false;
    }
    if (this->number_of_perceived_objects != other.number_of_perceived_objects) {
      return false;
    }
    if (this->number_of_perceived_objects_is_present != other.number_of_perceived_objects_is_present) {
      return false;
    }
    if (this->perceived_object_ids != other.perceived_object_ids) {
      return false;
    }
    if (this->perceived_object_ids_is_present != other.perceived_object_ids_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const PerceptionRegion_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PerceptionRegion_

// alias to use template instance with default allocator
using PerceptionRegion =
  etsi_its_cpm_ts_msgs::msg::PerceptionRegion_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEPTION_REGION__STRUCT_HPP_
