// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/PerceptionRegion.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEPTION_REGION__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEPTION_REGION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/perception_region__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'measurement_delta_time'
#include "etsi_its_cpm_ts_msgs/msg/detail/delta_time_milli_second_signed__traits.hpp"
// Member 'perception_region_confidence'
#include "etsi_its_cpm_ts_msgs/msg/detail/confidence_level__traits.hpp"
// Member 'perception_region_shape'
#include "etsi_its_cpm_ts_msgs/msg/detail/shape__traits.hpp"
// Member 'sensor_id_list'
#include "etsi_its_cpm_ts_msgs/msg/detail/sequence_of_identifier1_b__traits.hpp"
// Member 'number_of_perceived_objects'
#include "etsi_its_cpm_ts_msgs/msg/detail/cardinal_number1_b__traits.hpp"
// Member 'perceived_object_ids'
#include "etsi_its_cpm_ts_msgs/msg/detail/perceived_object_ids__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PerceptionRegion & msg,
  std::ostream & out)
{
  out << "{";
  // member: measurement_delta_time
  {
    out << "measurement_delta_time: ";
    to_flow_style_yaml(msg.measurement_delta_time, out);
    out << ", ";
  }

  // member: perception_region_confidence
  {
    out << "perception_region_confidence: ";
    to_flow_style_yaml(msg.perception_region_confidence, out);
    out << ", ";
  }

  // member: perception_region_shape
  {
    out << "perception_region_shape: ";
    to_flow_style_yaml(msg.perception_region_shape, out);
    out << ", ";
  }

  // member: shadowing_applies
  {
    out << "shadowing_applies: ";
    rosidl_generator_traits::value_to_yaml(msg.shadowing_applies, out);
    out << ", ";
  }

  // member: sensor_id_list
  {
    out << "sensor_id_list: ";
    to_flow_style_yaml(msg.sensor_id_list, out);
    out << ", ";
  }

  // member: sensor_id_list_is_present
  {
    out << "sensor_id_list_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_id_list_is_present, out);
    out << ", ";
  }

  // member: number_of_perceived_objects
  {
    out << "number_of_perceived_objects: ";
    to_flow_style_yaml(msg.number_of_perceived_objects, out);
    out << ", ";
  }

  // member: number_of_perceived_objects_is_present
  {
    out << "number_of_perceived_objects_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.number_of_perceived_objects_is_present, out);
    out << ", ";
  }

  // member: perceived_object_ids
  {
    out << "perceived_object_ids: ";
    to_flow_style_yaml(msg.perceived_object_ids, out);
    out << ", ";
  }

  // member: perceived_object_ids_is_present
  {
    out << "perceived_object_ids_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.perceived_object_ids_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PerceptionRegion & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: measurement_delta_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "measurement_delta_time:\n";
    to_block_style_yaml(msg.measurement_delta_time, out, indentation + 2);
  }

  // member: perception_region_confidence
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "perception_region_confidence:\n";
    to_block_style_yaml(msg.perception_region_confidence, out, indentation + 2);
  }

  // member: perception_region_shape
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "perception_region_shape:\n";
    to_block_style_yaml(msg.perception_region_shape, out, indentation + 2);
  }

  // member: shadowing_applies
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "shadowing_applies: ";
    rosidl_generator_traits::value_to_yaml(msg.shadowing_applies, out);
    out << "\n";
  }

  // member: sensor_id_list
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_id_list:\n";
    to_block_style_yaml(msg.sensor_id_list, out, indentation + 2);
  }

  // member: sensor_id_list_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_id_list_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_id_list_is_present, out);
    out << "\n";
  }

  // member: number_of_perceived_objects
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "number_of_perceived_objects:\n";
    to_block_style_yaml(msg.number_of_perceived_objects, out, indentation + 2);
  }

  // member: number_of_perceived_objects_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "number_of_perceived_objects_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.number_of_perceived_objects_is_present, out);
    out << "\n";
  }

  // member: perceived_object_ids
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "perceived_object_ids:\n";
    to_block_style_yaml(msg.perceived_object_ids, out, indentation + 2);
  }

  // member: perceived_object_ids_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "perceived_object_ids_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.perceived_object_ids_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PerceptionRegion & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::PerceptionRegion & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::PerceptionRegion & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::PerceptionRegion>()
{
  return "etsi_its_cpm_ts_msgs::msg::PerceptionRegion";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::PerceptionRegion>()
{
  return "etsi_its_cpm_ts_msgs/msg/PerceptionRegion";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::PerceptionRegion>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::CardinalNumber1B>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::ConfidenceLevel>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::DeltaTimeMilliSecondSigned>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::PerceivedObjectIds>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::SequenceOfIdentifier1B>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::Shape>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::PerceptionRegion>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::CardinalNumber1B>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::ConfidenceLevel>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::DeltaTimeMilliSecondSigned>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::PerceivedObjectIds>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::SequenceOfIdentifier1B>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::Shape>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::PerceptionRegion>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEPTION_REGION__TRAITS_HPP_
