// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from etsi_its_cpm_ts_msgs:msg/PerceptionRegion.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "etsi_its_cpm_ts_msgs/msg/detail/perception_region__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void PerceptionRegion_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) etsi_its_cpm_ts_msgs::msg::PerceptionRegion(_init);
}

void PerceptionRegion_fini_function(void * message_memory)
{
  auto typed_message = static_cast<etsi_its_cpm_ts_msgs::msg::PerceptionRegion *>(message_memory);
  typed_message->~PerceptionRegion();
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember PerceptionRegion_message_member_array[10] = {
  {
    "measurement_delta_time",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<etsi_its_cpm_ts_msgs::msg::DeltaTimeMilliSecondSigned>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_cpm_ts_msgs::msg::PerceptionRegion, measurement_delta_time),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "perception_region_confidence",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<etsi_its_cpm_ts_msgs::msg::ConfidenceLevel>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_cpm_ts_msgs::msg::PerceptionRegion, perception_region_confidence),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "perception_region_shape",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<etsi_its_cpm_ts_msgs::msg::Shape>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_cpm_ts_msgs::msg::PerceptionRegion, perception_region_shape),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "shadowing_applies",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_BOOLEAN,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_cpm_ts_msgs::msg::PerceptionRegion, shadowing_applies),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "sensor_id_list",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<etsi_its_cpm_ts_msgs::msg::SequenceOfIdentifier1B>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_cpm_ts_msgs::msg::PerceptionRegion, sensor_id_list),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "sensor_id_list_is_present",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_BOOLEAN,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_cpm_ts_msgs::msg::PerceptionRegion, sensor_id_list_is_present),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "number_of_perceived_objects",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<etsi_its_cpm_ts_msgs::msg::CardinalNumber1B>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_cpm_ts_msgs::msg::PerceptionRegion, number_of_perceived_objects),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "number_of_perceived_objects_is_present",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_BOOLEAN,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_cpm_ts_msgs::msg::PerceptionRegion, number_of_perceived_objects_is_present),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "perceived_object_ids",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<etsi_its_cpm_ts_msgs::msg::PerceivedObjectIds>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_cpm_ts_msgs::msg::PerceptionRegion, perceived_object_ids),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "perceived_object_ids_is_present",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_BOOLEAN,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_cpm_ts_msgs::msg::PerceptionRegion, perceived_object_ids_is_present),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers PerceptionRegion_message_members = {
  "etsi_its_cpm_ts_msgs::msg",  // message namespace
  "PerceptionRegion",  // message name
  10,  // number of fields
  sizeof(etsi_its_cpm_ts_msgs::msg::PerceptionRegion),
  PerceptionRegion_message_member_array,  // message members
  PerceptionRegion_init_function,  // function to initialize message memory (memory has to be allocated)
  PerceptionRegion_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t PerceptionRegion_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &PerceptionRegion_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<etsi_its_cpm_ts_msgs::msg::PerceptionRegion>()
{
  return &::etsi_its_cpm_ts_msgs::msg::rosidl_typesupport_introspection_cpp::PerceptionRegion_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, etsi_its_cpm_ts_msgs, msg, PerceptionRegion)() {
  return &::etsi_its_cpm_ts_msgs::msg::rosidl_typesupport_introspection_cpp::PerceptionRegion_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
