// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/PosConfidenceEllipse.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__POS_CONFIDENCE_ELLIPSE__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__POS_CONFIDENCE_ELLIPSE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'semi_major_confidence'
// Member 'semi_minor_confidence'
#include "etsi_its_cpm_ts_msgs/msg/detail/semi_axis_length__struct.hpp"
// Member 'semi_major_orientation'
#include "etsi_its_cpm_ts_msgs/msg/detail/heading_value__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__PosConfidenceEllipse __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__PosConfidenceEllipse __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PosConfidenceEllipse_
{
  using Type = PosConfidenceEllipse_<ContainerAllocator>;

  explicit PosConfidenceEllipse_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : semi_major_confidence(_init),
    semi_minor_confidence(_init),
    semi_major_orientation(_init)
  {
    (void)_init;
  }

  explicit PosConfidenceEllipse_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : semi_major_confidence(_alloc, _init),
    semi_minor_confidence(_alloc, _init),
    semi_major_orientation(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _semi_major_confidence_type =
    etsi_its_cpm_ts_msgs::msg::SemiAxisLength_<ContainerAllocator>;
  _semi_major_confidence_type semi_major_confidence;
  using _semi_minor_confidence_type =
    etsi_its_cpm_ts_msgs::msg::SemiAxisLength_<ContainerAllocator>;
  _semi_minor_confidence_type semi_minor_confidence;
  using _semi_major_orientation_type =
    etsi_its_cpm_ts_msgs::msg::HeadingValue_<ContainerAllocator>;
  _semi_major_orientation_type semi_major_orientation;

  // setters for named parameter idiom
  Type & set__semi_major_confidence(
    const etsi_its_cpm_ts_msgs::msg::SemiAxisLength_<ContainerAllocator> & _arg)
  {
    this->semi_major_confidence = _arg;
    return *this;
  }
  Type & set__semi_minor_confidence(
    const etsi_its_cpm_ts_msgs::msg::SemiAxisLength_<ContainerAllocator> & _arg)
  {
    this->semi_minor_confidence = _arg;
    return *this;
  }
  Type & set__semi_major_orientation(
    const etsi_its_cpm_ts_msgs::msg::HeadingValue_<ContainerAllocator> & _arg)
  {
    this->semi_major_orientation = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__PosConfidenceEllipse
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__PosConfidenceEllipse
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PosConfidenceEllipse_ & other) const
  {
    if (this->semi_major_confidence != other.semi_major_confidence) {
      return false;
    }
    if (this->semi_minor_confidence != other.semi_minor_confidence) {
      return false;
    }
    if (this->semi_major_orientation != other.semi_major_orientation) {
      return false;
    }
    return true;
  }
  bool operator!=(const PosConfidenceEllipse_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PosConfidenceEllipse_

// alias to use template instance with default allocator
using PosConfidenceEllipse =
  etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__POS_CONFIDENCE_ELLIPSE__STRUCT_HPP_
