// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/PosConfidenceEllipse.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__POS_CONFIDENCE_ELLIPSE__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__POS_CONFIDENCE_ELLIPSE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/pos_confidence_ellipse__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'semi_major_confidence'
// Member 'semi_minor_confidence'
#include "etsi_its_cpm_ts_msgs/msg/detail/semi_axis_length__traits.hpp"
// Member 'semi_major_orientation'
#include "etsi_its_cpm_ts_msgs/msg/detail/heading_value__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PosConfidenceEllipse & msg,
  std::ostream & out)
{
  out << "{";
  // member: semi_major_confidence
  {
    out << "semi_major_confidence: ";
    to_flow_style_yaml(msg.semi_major_confidence, out);
    out << ", ";
  }

  // member: semi_minor_confidence
  {
    out << "semi_minor_confidence: ";
    to_flow_style_yaml(msg.semi_minor_confidence, out);
    out << ", ";
  }

  // member: semi_major_orientation
  {
    out << "semi_major_orientation: ";
    to_flow_style_yaml(msg.semi_major_orientation, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PosConfidenceEllipse & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: semi_major_confidence
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "semi_major_confidence:\n";
    to_block_style_yaml(msg.semi_major_confidence, out, indentation + 2);
  }

  // member: semi_minor_confidence
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "semi_minor_confidence:\n";
    to_block_style_yaml(msg.semi_minor_confidence, out, indentation + 2);
  }

  // member: semi_major_orientation
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "semi_major_orientation:\n";
    to_block_style_yaml(msg.semi_major_orientation, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PosConfidenceEllipse & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse>()
{
  return "etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse>()
{
  return "etsi_its_cpm_ts_msgs/msg/PosConfidenceEllipse";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::HeadingValue>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::SemiAxisLength>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::HeadingValue>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::SemiAxisLength>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__POS_CONFIDENCE_ELLIPSE__TRAITS_HPP_
