// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from etsi_its_cpm_ts_msgs:msg/PosConfidenceEllipse.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "etsi_its_cpm_ts_msgs/msg/detail/pos_confidence_ellipse__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void PosConfidenceEllipse_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse(_init);
}

void PosConfidenceEllipse_fini_function(void * message_memory)
{
  auto typed_message = static_cast<etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse *>(message_memory);
  typed_message->~PosConfidenceEllipse();
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember PosConfidenceEllipse_message_member_array[3] = {
  {
    "semi_major_confidence",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<etsi_its_cpm_ts_msgs::msg::SemiAxisLength>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse, semi_major_confidence),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "semi_minor_confidence",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<etsi_its_cpm_ts_msgs::msg::SemiAxisLength>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse, semi_minor_confidence),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "semi_major_orientation",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<etsi_its_cpm_ts_msgs::msg::HeadingValue>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse, semi_major_orientation),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers PosConfidenceEllipse_message_members = {
  "etsi_its_cpm_ts_msgs::msg",  // message namespace
  "PosConfidenceEllipse",  // message name
  3,  // number of fields
  sizeof(etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse),
  PosConfidenceEllipse_message_member_array,  // message members
  PosConfidenceEllipse_init_function,  // function to initialize message memory (memory has to be allocated)
  PosConfidenceEllipse_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t PosConfidenceEllipse_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &PosConfidenceEllipse_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse>()
{
  return &::etsi_its_cpm_ts_msgs::msg::rosidl_typesupport_introspection_cpp::PosConfidenceEllipse_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, etsi_its_cpm_ts_msgs, msg, PosConfidenceEllipse)() {
  return &::etsi_its_cpm_ts_msgs::msg::rosidl_typesupport_introspection_cpp::PosConfidenceEllipse_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
