// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/RadialShapeDetails.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPE_DETAILS__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPE_DETAILS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'range'
#include "etsi_its_cpm_ts_msgs/msg/detail/standard_length12b__struct.hpp"
// Member 'horizontal_opening_angle_start'
// Member 'horizontal_opening_angle_end'
// Member 'vertical_opening_angle_start'
// Member 'vertical_opening_angle_end'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle_value__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__RadialShapeDetails __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__RadialShapeDetails __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RadialShapeDetails_
{
  using Type = RadialShapeDetails_<ContainerAllocator>;

  explicit RadialShapeDetails_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : range(_init),
    horizontal_opening_angle_start(_init),
    horizontal_opening_angle_end(_init),
    vertical_opening_angle_start(_init),
    vertical_opening_angle_end(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->vertical_opening_angle_start_is_present = false;
      this->vertical_opening_angle_end_is_present = false;
    }
  }

  explicit RadialShapeDetails_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : range(_alloc, _init),
    horizontal_opening_angle_start(_alloc, _init),
    horizontal_opening_angle_end(_alloc, _init),
    vertical_opening_angle_start(_alloc, _init),
    vertical_opening_angle_end(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->vertical_opening_angle_start_is_present = false;
      this->vertical_opening_angle_end_is_present = false;
    }
  }

  // field types and members
  using _range_type =
    etsi_its_cpm_ts_msgs::msg::StandardLength12b_<ContainerAllocator>;
  _range_type range;
  using _horizontal_opening_angle_start_type =
    etsi_its_cpm_ts_msgs::msg::CartesianAngleValue_<ContainerAllocator>;
  _horizontal_opening_angle_start_type horizontal_opening_angle_start;
  using _horizontal_opening_angle_end_type =
    etsi_its_cpm_ts_msgs::msg::CartesianAngleValue_<ContainerAllocator>;
  _horizontal_opening_angle_end_type horizontal_opening_angle_end;
  using _vertical_opening_angle_start_type =
    etsi_its_cpm_ts_msgs::msg::CartesianAngleValue_<ContainerAllocator>;
  _vertical_opening_angle_start_type vertical_opening_angle_start;
  using _vertical_opening_angle_start_is_present_type =
    bool;
  _vertical_opening_angle_start_is_present_type vertical_opening_angle_start_is_present;
  using _vertical_opening_angle_end_type =
    etsi_its_cpm_ts_msgs::msg::CartesianAngleValue_<ContainerAllocator>;
  _vertical_opening_angle_end_type vertical_opening_angle_end;
  using _vertical_opening_angle_end_is_present_type =
    bool;
  _vertical_opening_angle_end_is_present_type vertical_opening_angle_end_is_present;

  // setters for named parameter idiom
  Type & set__range(
    const etsi_its_cpm_ts_msgs::msg::StandardLength12b_<ContainerAllocator> & _arg)
  {
    this->range = _arg;
    return *this;
  }
  Type & set__horizontal_opening_angle_start(
    const etsi_its_cpm_ts_msgs::msg::CartesianAngleValue_<ContainerAllocator> & _arg)
  {
    this->horizontal_opening_angle_start = _arg;
    return *this;
  }
  Type & set__horizontal_opening_angle_end(
    const etsi_its_cpm_ts_msgs::msg::CartesianAngleValue_<ContainerAllocator> & _arg)
  {
    this->horizontal_opening_angle_end = _arg;
    return *this;
  }
  Type & set__vertical_opening_angle_start(
    const etsi_its_cpm_ts_msgs::msg::CartesianAngleValue_<ContainerAllocator> & _arg)
  {
    this->vertical_opening_angle_start = _arg;
    return *this;
  }
  Type & set__vertical_opening_angle_start_is_present(
    const bool & _arg)
  {
    this->vertical_opening_angle_start_is_present = _arg;
    return *this;
  }
  Type & set__vertical_opening_angle_end(
    const etsi_its_cpm_ts_msgs::msg::CartesianAngleValue_<ContainerAllocator> & _arg)
  {
    this->vertical_opening_angle_end = _arg;
    return *this;
  }
  Type & set__vertical_opening_angle_end_is_present(
    const bool & _arg)
  {
    this->vertical_opening_angle_end_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::RadialShapeDetails_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::RadialShapeDetails_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::RadialShapeDetails_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::RadialShapeDetails_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::RadialShapeDetails_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::RadialShapeDetails_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::RadialShapeDetails_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::RadialShapeDetails_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::RadialShapeDetails_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::RadialShapeDetails_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__RadialShapeDetails
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::RadialShapeDetails_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__RadialShapeDetails
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::RadialShapeDetails_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RadialShapeDetails_ & other) const
  {
    if (this->range != other.range) {
      return false;
    }
    if (this->horizontal_opening_angle_start != other.horizontal_opening_angle_start) {
      return false;
    }
    if (this->horizontal_opening_angle_end != other.horizontal_opening_angle_end) {
      return false;
    }
    if (this->vertical_opening_angle_start != other.vertical_opening_angle_start) {
      return false;
    }
    if (this->vertical_opening_angle_start_is_present != other.vertical_opening_angle_start_is_present) {
      return false;
    }
    if (this->vertical_opening_angle_end != other.vertical_opening_angle_end) {
      return false;
    }
    if (this->vertical_opening_angle_end_is_present != other.vertical_opening_angle_end_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const RadialShapeDetails_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RadialShapeDetails_

// alias to use template instance with default allocator
using RadialShapeDetails =
  etsi_its_cpm_ts_msgs::msg::RadialShapeDetails_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPE_DETAILS__STRUCT_HPP_
