// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/RadialShapeDetails.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPE_DETAILS__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPE_DETAILS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/radial_shape_details__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'range'
#include "etsi_its_cpm_ts_msgs/msg/detail/standard_length12b__traits.hpp"
// Member 'horizontal_opening_angle_start'
// Member 'horizontal_opening_angle_end'
// Member 'vertical_opening_angle_start'
// Member 'vertical_opening_angle_end'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle_value__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RadialShapeDetails & msg,
  std::ostream & out)
{
  out << "{";
  // member: range
  {
    out << "range: ";
    to_flow_style_yaml(msg.range, out);
    out << ", ";
  }

  // member: horizontal_opening_angle_start
  {
    out << "horizontal_opening_angle_start: ";
    to_flow_style_yaml(msg.horizontal_opening_angle_start, out);
    out << ", ";
  }

  // member: horizontal_opening_angle_end
  {
    out << "horizontal_opening_angle_end: ";
    to_flow_style_yaml(msg.horizontal_opening_angle_end, out);
    out << ", ";
  }

  // member: vertical_opening_angle_start
  {
    out << "vertical_opening_angle_start: ";
    to_flow_style_yaml(msg.vertical_opening_angle_start, out);
    out << ", ";
  }

  // member: vertical_opening_angle_start_is_present
  {
    out << "vertical_opening_angle_start_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.vertical_opening_angle_start_is_present, out);
    out << ", ";
  }

  // member: vertical_opening_angle_end
  {
    out << "vertical_opening_angle_end: ";
    to_flow_style_yaml(msg.vertical_opening_angle_end, out);
    out << ", ";
  }

  // member: vertical_opening_angle_end_is_present
  {
    out << "vertical_opening_angle_end_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.vertical_opening_angle_end_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RadialShapeDetails & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: range
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "range:\n";
    to_block_style_yaml(msg.range, out, indentation + 2);
  }

  // member: horizontal_opening_angle_start
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "horizontal_opening_angle_start:\n";
    to_block_style_yaml(msg.horizontal_opening_angle_start, out, indentation + 2);
  }

  // member: horizontal_opening_angle_end
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "horizontal_opening_angle_end:\n";
    to_block_style_yaml(msg.horizontal_opening_angle_end, out, indentation + 2);
  }

  // member: vertical_opening_angle_start
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vertical_opening_angle_start:\n";
    to_block_style_yaml(msg.vertical_opening_angle_start, out, indentation + 2);
  }

  // member: vertical_opening_angle_start_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vertical_opening_angle_start_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.vertical_opening_angle_start_is_present, out);
    out << "\n";
  }

  // member: vertical_opening_angle_end
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vertical_opening_angle_end:\n";
    to_block_style_yaml(msg.vertical_opening_angle_end, out, indentation + 2);
  }

  // member: vertical_opening_angle_end_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vertical_opening_angle_end_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.vertical_opening_angle_end_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RadialShapeDetails & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::RadialShapeDetails & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::RadialShapeDetails & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::RadialShapeDetails>()
{
  return "etsi_its_cpm_ts_msgs::msg::RadialShapeDetails";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::RadialShapeDetails>()
{
  return "etsi_its_cpm_ts_msgs/msg/RadialShapeDetails";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::RadialShapeDetails>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::CartesianAngleValue>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::StandardLength12b>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::RadialShapeDetails>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::CartesianAngleValue>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::StandardLength12b>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::RadialShapeDetails>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPE_DETAILS__TRAITS_HPP_
