// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/RadialShapes.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/radial_shapes__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `ref_point_id`
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier1_b__functions.h"
// Member `x_coordinate`
// Member `y_coordinate`
// Member `z_coordinate`
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_coordinate_small__functions.h"
// Member `radial_shapes_list`
#include "etsi_its_cpm_ts_msgs/msg/detail/radial_shapes_list__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__RadialShapes__init(etsi_its_cpm_ts_msgs__msg__RadialShapes * msg)
{
  if (!msg) {
    return false;
  }
  // ref_point_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__init(&msg->ref_point_id)) {
    etsi_its_cpm_ts_msgs__msg__RadialShapes__fini(msg);
    return false;
  }
  // x_coordinate
  if (!etsi_its_cpm_ts_msgs__msg__CartesianCoordinateSmall__init(&msg->x_coordinate)) {
    etsi_its_cpm_ts_msgs__msg__RadialShapes__fini(msg);
    return false;
  }
  // y_coordinate
  if (!etsi_its_cpm_ts_msgs__msg__CartesianCoordinateSmall__init(&msg->y_coordinate)) {
    etsi_its_cpm_ts_msgs__msg__RadialShapes__fini(msg);
    return false;
  }
  // z_coordinate
  if (!etsi_its_cpm_ts_msgs__msg__CartesianCoordinateSmall__init(&msg->z_coordinate)) {
    etsi_its_cpm_ts_msgs__msg__RadialShapes__fini(msg);
    return false;
  }
  // z_coordinate_is_present
  // radial_shapes_list
  if (!etsi_its_cpm_ts_msgs__msg__RadialShapesList__init(&msg->radial_shapes_list)) {
    etsi_its_cpm_ts_msgs__msg__RadialShapes__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__RadialShapes__fini(etsi_its_cpm_ts_msgs__msg__RadialShapes * msg)
{
  if (!msg) {
    return;
  }
  // ref_point_id
  etsi_its_cpm_ts_msgs__msg__Identifier1B__fini(&msg->ref_point_id);
  // x_coordinate
  etsi_its_cpm_ts_msgs__msg__CartesianCoordinateSmall__fini(&msg->x_coordinate);
  // y_coordinate
  etsi_its_cpm_ts_msgs__msg__CartesianCoordinateSmall__fini(&msg->y_coordinate);
  // z_coordinate
  etsi_its_cpm_ts_msgs__msg__CartesianCoordinateSmall__fini(&msg->z_coordinate);
  // z_coordinate_is_present
  // radial_shapes_list
  etsi_its_cpm_ts_msgs__msg__RadialShapesList__fini(&msg->radial_shapes_list);
}

bool
etsi_its_cpm_ts_msgs__msg__RadialShapes__are_equal(const etsi_its_cpm_ts_msgs__msg__RadialShapes * lhs, const etsi_its_cpm_ts_msgs__msg__RadialShapes * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // ref_point_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__are_equal(
      &(lhs->ref_point_id), &(rhs->ref_point_id)))
  {
    return false;
  }
  // x_coordinate
  if (!etsi_its_cpm_ts_msgs__msg__CartesianCoordinateSmall__are_equal(
      &(lhs->x_coordinate), &(rhs->x_coordinate)))
  {
    return false;
  }
  // y_coordinate
  if (!etsi_its_cpm_ts_msgs__msg__CartesianCoordinateSmall__are_equal(
      &(lhs->y_coordinate), &(rhs->y_coordinate)))
  {
    return false;
  }
  // z_coordinate
  if (!etsi_its_cpm_ts_msgs__msg__CartesianCoordinateSmall__are_equal(
      &(lhs->z_coordinate), &(rhs->z_coordinate)))
  {
    return false;
  }
  // z_coordinate_is_present
  if (lhs->z_coordinate_is_present != rhs->z_coordinate_is_present) {
    return false;
  }
  // radial_shapes_list
  if (!etsi_its_cpm_ts_msgs__msg__RadialShapesList__are_equal(
      &(lhs->radial_shapes_list), &(rhs->radial_shapes_list)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__RadialShapes__copy(
  const etsi_its_cpm_ts_msgs__msg__RadialShapes * input,
  etsi_its_cpm_ts_msgs__msg__RadialShapes * output)
{
  if (!input || !output) {
    return false;
  }
  // ref_point_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__copy(
      &(input->ref_point_id), &(output->ref_point_id)))
  {
    return false;
  }
  // x_coordinate
  if (!etsi_its_cpm_ts_msgs__msg__CartesianCoordinateSmall__copy(
      &(input->x_coordinate), &(output->x_coordinate)))
  {
    return false;
  }
  // y_coordinate
  if (!etsi_its_cpm_ts_msgs__msg__CartesianCoordinateSmall__copy(
      &(input->y_coordinate), &(output->y_coordinate)))
  {
    return false;
  }
  // z_coordinate
  if (!etsi_its_cpm_ts_msgs__msg__CartesianCoordinateSmall__copy(
      &(input->z_coordinate), &(output->z_coordinate)))
  {
    return false;
  }
  // z_coordinate_is_present
  output->z_coordinate_is_present = input->z_coordinate_is_present;
  // radial_shapes_list
  if (!etsi_its_cpm_ts_msgs__msg__RadialShapesList__copy(
      &(input->radial_shapes_list), &(output->radial_shapes_list)))
  {
    return false;
  }
  return true;
}

etsi_its_cpm_ts_msgs__msg__RadialShapes *
etsi_its_cpm_ts_msgs__msg__RadialShapes__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__RadialShapes * msg = (etsi_its_cpm_ts_msgs__msg__RadialShapes *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__RadialShapes), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__RadialShapes));
  bool success = etsi_its_cpm_ts_msgs__msg__RadialShapes__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__RadialShapes__destroy(etsi_its_cpm_ts_msgs__msg__RadialShapes * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__RadialShapes__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence__init(etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__RadialShapes * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__RadialShapes *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__RadialShapes), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__RadialShapes__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__RadialShapes__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence__fini(etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__RadialShapes__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence *
etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence * array = (etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__RadialShapes__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__RadialShapes__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__RadialShapes);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__RadialShapes * data =
      (etsi_its_cpm_ts_msgs__msg__RadialShapes *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__RadialShapes__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__RadialShapes__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__RadialShapes__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
