// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/RadialShapes.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPES__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPES__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/radial_shapes__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'ref_point_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier1_b__traits.hpp"
// Member 'x_coordinate'
// Member 'y_coordinate'
// Member 'z_coordinate'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_coordinate_small__traits.hpp"
// Member 'radial_shapes_list'
#include "etsi_its_cpm_ts_msgs/msg/detail/radial_shapes_list__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RadialShapes & msg,
  std::ostream & out)
{
  out << "{";
  // member: ref_point_id
  {
    out << "ref_point_id: ";
    to_flow_style_yaml(msg.ref_point_id, out);
    out << ", ";
  }

  // member: x_coordinate
  {
    out << "x_coordinate: ";
    to_flow_style_yaml(msg.x_coordinate, out);
    out << ", ";
  }

  // member: y_coordinate
  {
    out << "y_coordinate: ";
    to_flow_style_yaml(msg.y_coordinate, out);
    out << ", ";
  }

  // member: z_coordinate
  {
    out << "z_coordinate: ";
    to_flow_style_yaml(msg.z_coordinate, out);
    out << ", ";
  }

  // member: z_coordinate_is_present
  {
    out << "z_coordinate_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.z_coordinate_is_present, out);
    out << ", ";
  }

  // member: radial_shapes_list
  {
    out << "radial_shapes_list: ";
    to_flow_style_yaml(msg.radial_shapes_list, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RadialShapes & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: ref_point_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ref_point_id:\n";
    to_block_style_yaml(msg.ref_point_id, out, indentation + 2);
  }

  // member: x_coordinate
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "x_coordinate:\n";
    to_block_style_yaml(msg.x_coordinate, out, indentation + 2);
  }

  // member: y_coordinate
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "y_coordinate:\n";
    to_block_style_yaml(msg.y_coordinate, out, indentation + 2);
  }

  // member: z_coordinate
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "z_coordinate:\n";
    to_block_style_yaml(msg.z_coordinate, out, indentation + 2);
  }

  // member: z_coordinate_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "z_coordinate_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.z_coordinate_is_present, out);
    out << "\n";
  }

  // member: radial_shapes_list
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "radial_shapes_list:\n";
    to_block_style_yaml(msg.radial_shapes_list, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RadialShapes & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::RadialShapes & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::RadialShapes & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::RadialShapes>()
{
  return "etsi_its_cpm_ts_msgs::msg::RadialShapes";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::RadialShapes>()
{
  return "etsi_its_cpm_ts_msgs/msg/RadialShapes";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::RadialShapes>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::CartesianCoordinateSmall>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::Identifier1B>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::RadialShapesList>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::RadialShapes>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::CartesianCoordinateSmall>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::Identifier1B>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::RadialShapesList>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::RadialShapes>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPES__TRAITS_HPP_
