// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/ReferencePosition.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__REFERENCE_POSITION__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__REFERENCE_POSITION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/reference_position__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'latitude'
#include "etsi_its_cpm_ts_msgs/msg/detail/latitude__traits.hpp"
// Member 'longitude'
#include "etsi_its_cpm_ts_msgs/msg/detail/longitude__traits.hpp"
// Member 'position_confidence_ellipse'
#include "etsi_its_cpm_ts_msgs/msg/detail/pos_confidence_ellipse__traits.hpp"
// Member 'altitude'
#include "etsi_its_cpm_ts_msgs/msg/detail/altitude__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ReferencePosition & msg,
  std::ostream & out)
{
  out << "{";
  // member: latitude
  {
    out << "latitude: ";
    to_flow_style_yaml(msg.latitude, out);
    out << ", ";
  }

  // member: longitude
  {
    out << "longitude: ";
    to_flow_style_yaml(msg.longitude, out);
    out << ", ";
  }

  // member: position_confidence_ellipse
  {
    out << "position_confidence_ellipse: ";
    to_flow_style_yaml(msg.position_confidence_ellipse, out);
    out << ", ";
  }

  // member: altitude
  {
    out << "altitude: ";
    to_flow_style_yaml(msg.altitude, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ReferencePosition & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: latitude
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "latitude:\n";
    to_block_style_yaml(msg.latitude, out, indentation + 2);
  }

  // member: longitude
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "longitude:\n";
    to_block_style_yaml(msg.longitude, out, indentation + 2);
  }

  // member: position_confidence_ellipse
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "position_confidence_ellipse:\n";
    to_block_style_yaml(msg.position_confidence_ellipse, out, indentation + 2);
  }

  // member: altitude
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "altitude:\n";
    to_block_style_yaml(msg.altitude, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ReferencePosition & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::ReferencePosition & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::ReferencePosition & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::ReferencePosition>()
{
  return "etsi_its_cpm_ts_msgs::msg::ReferencePosition";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::ReferencePosition>()
{
  return "etsi_its_cpm_ts_msgs/msg/ReferencePosition";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::ReferencePosition>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::Altitude>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::Latitude>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::Longitude>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::ReferencePosition>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::Altitude>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::Latitude>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::Longitude>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::ReferencePosition>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__REFERENCE_POSITION__TRAITS_HPP_
