// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/SensorInformation.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/sensor_information__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `sensor_id`
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier1_b__functions.h"
// Member `sensor_type`
#include "etsi_its_cpm_ts_msgs/msg/detail/sensor_type__functions.h"
// Member `perception_region_shape`
#include "etsi_its_cpm_ts_msgs/msg/detail/shape__functions.h"
// Member `perception_region_confidence`
#include "etsi_its_cpm_ts_msgs/msg/detail/confidence_level__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__SensorInformation__init(etsi_its_cpm_ts_msgs__msg__SensorInformation * msg)
{
  if (!msg) {
    return false;
  }
  // sensor_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__init(&msg->sensor_id)) {
    etsi_its_cpm_ts_msgs__msg__SensorInformation__fini(msg);
    return false;
  }
  // sensor_type
  if (!etsi_its_cpm_ts_msgs__msg__SensorType__init(&msg->sensor_type)) {
    etsi_its_cpm_ts_msgs__msg__SensorInformation__fini(msg);
    return false;
  }
  // perception_region_shape
  if (!etsi_its_cpm_ts_msgs__msg__Shape__init(&msg->perception_region_shape)) {
    etsi_its_cpm_ts_msgs__msg__SensorInformation__fini(msg);
    return false;
  }
  // perception_region_shape_is_present
  // perception_region_confidence
  if (!etsi_its_cpm_ts_msgs__msg__ConfidenceLevel__init(&msg->perception_region_confidence)) {
    etsi_its_cpm_ts_msgs__msg__SensorInformation__fini(msg);
    return false;
  }
  // perception_region_confidence_is_present
  // shadowing_applies
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__SensorInformation__fini(etsi_its_cpm_ts_msgs__msg__SensorInformation * msg)
{
  if (!msg) {
    return;
  }
  // sensor_id
  etsi_its_cpm_ts_msgs__msg__Identifier1B__fini(&msg->sensor_id);
  // sensor_type
  etsi_its_cpm_ts_msgs__msg__SensorType__fini(&msg->sensor_type);
  // perception_region_shape
  etsi_its_cpm_ts_msgs__msg__Shape__fini(&msg->perception_region_shape);
  // perception_region_shape_is_present
  // perception_region_confidence
  etsi_its_cpm_ts_msgs__msg__ConfidenceLevel__fini(&msg->perception_region_confidence);
  // perception_region_confidence_is_present
  // shadowing_applies
}

bool
etsi_its_cpm_ts_msgs__msg__SensorInformation__are_equal(const etsi_its_cpm_ts_msgs__msg__SensorInformation * lhs, const etsi_its_cpm_ts_msgs__msg__SensorInformation * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // sensor_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__are_equal(
      &(lhs->sensor_id), &(rhs->sensor_id)))
  {
    return false;
  }
  // sensor_type
  if (!etsi_its_cpm_ts_msgs__msg__SensorType__are_equal(
      &(lhs->sensor_type), &(rhs->sensor_type)))
  {
    return false;
  }
  // perception_region_shape
  if (!etsi_its_cpm_ts_msgs__msg__Shape__are_equal(
      &(lhs->perception_region_shape), &(rhs->perception_region_shape)))
  {
    return false;
  }
  // perception_region_shape_is_present
  if (lhs->perception_region_shape_is_present != rhs->perception_region_shape_is_present) {
    return false;
  }
  // perception_region_confidence
  if (!etsi_its_cpm_ts_msgs__msg__ConfidenceLevel__are_equal(
      &(lhs->perception_region_confidence), &(rhs->perception_region_confidence)))
  {
    return false;
  }
  // perception_region_confidence_is_present
  if (lhs->perception_region_confidence_is_present != rhs->perception_region_confidence_is_present) {
    return false;
  }
  // shadowing_applies
  if (lhs->shadowing_applies != rhs->shadowing_applies) {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__SensorInformation__copy(
  const etsi_its_cpm_ts_msgs__msg__SensorInformation * input,
  etsi_its_cpm_ts_msgs__msg__SensorInformation * output)
{
  if (!input || !output) {
    return false;
  }
  // sensor_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__copy(
      &(input->sensor_id), &(output->sensor_id)))
  {
    return false;
  }
  // sensor_type
  if (!etsi_its_cpm_ts_msgs__msg__SensorType__copy(
      &(input->sensor_type), &(output->sensor_type)))
  {
    return false;
  }
  // perception_region_shape
  if (!etsi_its_cpm_ts_msgs__msg__Shape__copy(
      &(input->perception_region_shape), &(output->perception_region_shape)))
  {
    return false;
  }
  // perception_region_shape_is_present
  output->perception_region_shape_is_present = input->perception_region_shape_is_present;
  // perception_region_confidence
  if (!etsi_its_cpm_ts_msgs__msg__ConfidenceLevel__copy(
      &(input->perception_region_confidence), &(output->perception_region_confidence)))
  {
    return false;
  }
  // perception_region_confidence_is_present
  output->perception_region_confidence_is_present = input->perception_region_confidence_is_present;
  // shadowing_applies
  output->shadowing_applies = input->shadowing_applies;
  return true;
}

etsi_its_cpm_ts_msgs__msg__SensorInformation *
etsi_its_cpm_ts_msgs__msg__SensorInformation__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__SensorInformation * msg = (etsi_its_cpm_ts_msgs__msg__SensorInformation *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__SensorInformation), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__SensorInformation));
  bool success = etsi_its_cpm_ts_msgs__msg__SensorInformation__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__SensorInformation__destroy(etsi_its_cpm_ts_msgs__msg__SensorInformation * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__SensorInformation__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence__init(etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__SensorInformation * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__SensorInformation *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__SensorInformation), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__SensorInformation__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__SensorInformation__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence__fini(etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__SensorInformation__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence *
etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence * array = (etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__SensorInformation__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__SensorInformation);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__SensorInformation * data =
      (etsi_its_cpm_ts_msgs__msg__SensorInformation *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__SensorInformation__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__SensorInformation__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__SensorInformation__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
