// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/SensorType.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SENSOR_TYPE__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SENSOR_TYPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cpm_ts_msgs__msg__SensorType__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cpm_ts_msgs__msg__SensorType__MAX = 31
};

/// Constant 'UNDEFINED'.
enum
{
  etsi_its_cpm_ts_msgs__msg__SensorType__UNDEFINED = 0
};

/// Constant 'RADAR'.
enum
{
  etsi_its_cpm_ts_msgs__msg__SensorType__RADAR = 1
};

/// Constant 'LIDAR'.
enum
{
  etsi_its_cpm_ts_msgs__msg__SensorType__LIDAR = 2
};

/// Constant 'MONOVIDEO'.
enum
{
  etsi_its_cpm_ts_msgs__msg__SensorType__MONOVIDEO = 3
};

/// Constant 'STEREOVISION'.
enum
{
  etsi_its_cpm_ts_msgs__msg__SensorType__STEREOVISION = 4
};

/// Constant 'NIGHTVISION'.
enum
{
  etsi_its_cpm_ts_msgs__msg__SensorType__NIGHTVISION = 5
};

/// Constant 'ULTRASONIC'.
enum
{
  etsi_its_cpm_ts_msgs__msg__SensorType__ULTRASONIC = 6
};

/// Constant 'PMD'.
enum
{
  etsi_its_cpm_ts_msgs__msg__SensorType__PMD = 7
};

/// Constant 'INDUCTION_LOOP'.
enum
{
  etsi_its_cpm_ts_msgs__msg__SensorType__INDUCTION_LOOP = 8
};

/// Constant 'SPHERICAL_CAMERA'.
enum
{
  etsi_its_cpm_ts_msgs__msg__SensorType__SPHERICAL_CAMERA = 9
};

/// Constant 'UWB'.
enum
{
  etsi_its_cpm_ts_msgs__msg__SensorType__UWB = 10
};

/// Constant 'ACOUSTIC'.
enum
{
  etsi_its_cpm_ts_msgs__msg__SensorType__ACOUSTIC = 11
};

/// Constant 'LOCAL_AGGREGATION'.
enum
{
  etsi_its_cpm_ts_msgs__msg__SensorType__LOCAL_AGGREGATION = 12
};

/// Constant 'ITS_AGGREGATION'.
enum
{
  etsi_its_cpm_ts_msgs__msg__SensorType__ITS_AGGREGATION = 13
};

/// Struct defined in msg/SensorType in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__SensorType
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the type of sensor.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0  `undefined`         - in case the sensor type is undefined.
  ///  * - 1  `radar`             - in case the sensor is a radar,
  ///  * - 2  `lidar`             - in case the sensor is a lidar,
  ///  * - 3  `monovideo`         - in case the sensor is mono video,
  ///  * - 4  `stereovision`      - in case the sensor is stereo vision,
  ///  * - 5  `nightvision`       - in case the sensor is night vision,
  ///  * - 6  `ultrasonic`        - in case the sensor is ultrasonic,
  ///  * - 7  `pmd`               - in case the sensor is photonic mixing device,
  ///  * - 8  `inductionLoop`     - in case the sensor is an induction loop,
  ///  * - 9  `sphericalCamera`   - in case the sensor is a spherical camera,
  ///  * - 10 `uwb`               - in case the sensor is ultra wide band,
  ///  * - 11 `acoustic`          - in case the sensor is acoustic,
  ///  * - 12 `localAggregation`  - in case the information is provided by a system that aggregates information from different local sensors. Aggregation may include fusion,
  ///  * - 13 `itsAggregation`    - in case the information is provided by a system that aggregates information from other received ITS messages.
  ///  * - 14-31                  - are reserved for future usage.
  ///  *
  ///  * @category: Sensing Information
  ///  * @revision: created in V2.1.1
  /// */
  /// SensorType ::= INTEGER {
  ///     undefined         (0),
  ///     radar             (1),
  ///     lidar             (2),
  ///     monovideo         (3),
  ///     stereovision      (4),
  ///     nightvision       (5),
  ///     ultrasonic        (6),
  ///     pmd               (7),
  ///     inductionLoop     (8),
  ///     sphericalCamera   (9),
  ///     uwb               (10),
  ///     acoustic          (11),
  ///     localAggregation  (12),
  ///     itsAggregation    (13)
  /// } (0..31)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cpm_ts_msgs__msg__SensorType;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__SensorType.
typedef struct etsi_its_cpm_ts_msgs__msg__SensorType__Sequence
{
  etsi_its_cpm_ts_msgs__msg__SensorType * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__SensorType__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SENSOR_TYPE__STRUCT_H_
