// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/TrailerData.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/trailer_data__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `ref_point_id`
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier1_b__functions.h"
// Member `hitch_point_offset`
// Member `front_overhang`
// Member `rear_overhang`
#include "etsi_its_cpm_ts_msgs/msg/detail/standard_length1_b__functions.h"
// Member `trailer_width`
#include "etsi_its_cpm_ts_msgs/msg/detail/vehicle_width__functions.h"
// Member `hitch_angle`
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__TrailerData__init(etsi_its_cpm_ts_msgs__msg__TrailerData * msg)
{
  if (!msg) {
    return false;
  }
  // ref_point_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__init(&msg->ref_point_id)) {
    etsi_its_cpm_ts_msgs__msg__TrailerData__fini(msg);
    return false;
  }
  // hitch_point_offset
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength1B__init(&msg->hitch_point_offset)) {
    etsi_its_cpm_ts_msgs__msg__TrailerData__fini(msg);
    return false;
  }
  // front_overhang
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength1B__init(&msg->front_overhang)) {
    etsi_its_cpm_ts_msgs__msg__TrailerData__fini(msg);
    return false;
  }
  // front_overhang_is_present
  // rear_overhang
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength1B__init(&msg->rear_overhang)) {
    etsi_its_cpm_ts_msgs__msg__TrailerData__fini(msg);
    return false;
  }
  // rear_overhang_is_present
  // trailer_width
  if (!etsi_its_cpm_ts_msgs__msg__VehicleWidth__init(&msg->trailer_width)) {
    etsi_its_cpm_ts_msgs__msg__TrailerData__fini(msg);
    return false;
  }
  // trailer_width_is_present
  // hitch_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__init(&msg->hitch_angle)) {
    etsi_its_cpm_ts_msgs__msg__TrailerData__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__TrailerData__fini(etsi_its_cpm_ts_msgs__msg__TrailerData * msg)
{
  if (!msg) {
    return;
  }
  // ref_point_id
  etsi_its_cpm_ts_msgs__msg__Identifier1B__fini(&msg->ref_point_id);
  // hitch_point_offset
  etsi_its_cpm_ts_msgs__msg__StandardLength1B__fini(&msg->hitch_point_offset);
  // front_overhang
  etsi_its_cpm_ts_msgs__msg__StandardLength1B__fini(&msg->front_overhang);
  // front_overhang_is_present
  // rear_overhang
  etsi_its_cpm_ts_msgs__msg__StandardLength1B__fini(&msg->rear_overhang);
  // rear_overhang_is_present
  // trailer_width
  etsi_its_cpm_ts_msgs__msg__VehicleWidth__fini(&msg->trailer_width);
  // trailer_width_is_present
  // hitch_angle
  etsi_its_cpm_ts_msgs__msg__CartesianAngle__fini(&msg->hitch_angle);
}

bool
etsi_its_cpm_ts_msgs__msg__TrailerData__are_equal(const etsi_its_cpm_ts_msgs__msg__TrailerData * lhs, const etsi_its_cpm_ts_msgs__msg__TrailerData * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // ref_point_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__are_equal(
      &(lhs->ref_point_id), &(rhs->ref_point_id)))
  {
    return false;
  }
  // hitch_point_offset
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength1B__are_equal(
      &(lhs->hitch_point_offset), &(rhs->hitch_point_offset)))
  {
    return false;
  }
  // front_overhang
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength1B__are_equal(
      &(lhs->front_overhang), &(rhs->front_overhang)))
  {
    return false;
  }
  // front_overhang_is_present
  if (lhs->front_overhang_is_present != rhs->front_overhang_is_present) {
    return false;
  }
  // rear_overhang
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength1B__are_equal(
      &(lhs->rear_overhang), &(rhs->rear_overhang)))
  {
    return false;
  }
  // rear_overhang_is_present
  if (lhs->rear_overhang_is_present != rhs->rear_overhang_is_present) {
    return false;
  }
  // trailer_width
  if (!etsi_its_cpm_ts_msgs__msg__VehicleWidth__are_equal(
      &(lhs->trailer_width), &(rhs->trailer_width)))
  {
    return false;
  }
  // trailer_width_is_present
  if (lhs->trailer_width_is_present != rhs->trailer_width_is_present) {
    return false;
  }
  // hitch_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__are_equal(
      &(lhs->hitch_angle), &(rhs->hitch_angle)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__TrailerData__copy(
  const etsi_its_cpm_ts_msgs__msg__TrailerData * input,
  etsi_its_cpm_ts_msgs__msg__TrailerData * output)
{
  if (!input || !output) {
    return false;
  }
  // ref_point_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__copy(
      &(input->ref_point_id), &(output->ref_point_id)))
  {
    return false;
  }
  // hitch_point_offset
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength1B__copy(
      &(input->hitch_point_offset), &(output->hitch_point_offset)))
  {
    return false;
  }
  // front_overhang
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength1B__copy(
      &(input->front_overhang), &(output->front_overhang)))
  {
    return false;
  }
  // front_overhang_is_present
  output->front_overhang_is_present = input->front_overhang_is_present;
  // rear_overhang
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength1B__copy(
      &(input->rear_overhang), &(output->rear_overhang)))
  {
    return false;
  }
  // rear_overhang_is_present
  output->rear_overhang_is_present = input->rear_overhang_is_present;
  // trailer_width
  if (!etsi_its_cpm_ts_msgs__msg__VehicleWidth__copy(
      &(input->trailer_width), &(output->trailer_width)))
  {
    return false;
  }
  // trailer_width_is_present
  output->trailer_width_is_present = input->trailer_width_is_present;
  // hitch_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__copy(
      &(input->hitch_angle), &(output->hitch_angle)))
  {
    return false;
  }
  return true;
}

etsi_its_cpm_ts_msgs__msg__TrailerData *
etsi_its_cpm_ts_msgs__msg__TrailerData__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__TrailerData * msg = (etsi_its_cpm_ts_msgs__msg__TrailerData *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__TrailerData), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__TrailerData));
  bool success = etsi_its_cpm_ts_msgs__msg__TrailerData__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__TrailerData__destroy(etsi_its_cpm_ts_msgs__msg__TrailerData * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__TrailerData__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence__init(etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__TrailerData * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__TrailerData *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__TrailerData), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__TrailerData__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__TrailerData__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence__fini(etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__TrailerData__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence *
etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence * array = (etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__TrailerData__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__TrailerData);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__TrailerData * data =
      (etsi_its_cpm_ts_msgs__msg__TrailerData *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__TrailerData__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__TrailerData__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__TrailerData__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
