// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/TrailerData.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__TRAILER_DATA__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__TRAILER_DATA__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/trailer_data__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'ref_point_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier1_b__traits.hpp"
// Member 'hitch_point_offset'
// Member 'front_overhang'
// Member 'rear_overhang'
#include "etsi_its_cpm_ts_msgs/msg/detail/standard_length1_b__traits.hpp"
// Member 'trailer_width'
#include "etsi_its_cpm_ts_msgs/msg/detail/vehicle_width__traits.hpp"
// Member 'hitch_angle'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const TrailerData & msg,
  std::ostream & out)
{
  out << "{";
  // member: ref_point_id
  {
    out << "ref_point_id: ";
    to_flow_style_yaml(msg.ref_point_id, out);
    out << ", ";
  }

  // member: hitch_point_offset
  {
    out << "hitch_point_offset: ";
    to_flow_style_yaml(msg.hitch_point_offset, out);
    out << ", ";
  }

  // member: front_overhang
  {
    out << "front_overhang: ";
    to_flow_style_yaml(msg.front_overhang, out);
    out << ", ";
  }

  // member: front_overhang_is_present
  {
    out << "front_overhang_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.front_overhang_is_present, out);
    out << ", ";
  }

  // member: rear_overhang
  {
    out << "rear_overhang: ";
    to_flow_style_yaml(msg.rear_overhang, out);
    out << ", ";
  }

  // member: rear_overhang_is_present
  {
    out << "rear_overhang_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.rear_overhang_is_present, out);
    out << ", ";
  }

  // member: trailer_width
  {
    out << "trailer_width: ";
    to_flow_style_yaml(msg.trailer_width, out);
    out << ", ";
  }

  // member: trailer_width_is_present
  {
    out << "trailer_width_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.trailer_width_is_present, out);
    out << ", ";
  }

  // member: hitch_angle
  {
    out << "hitch_angle: ";
    to_flow_style_yaml(msg.hitch_angle, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TrailerData & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: ref_point_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ref_point_id:\n";
    to_block_style_yaml(msg.ref_point_id, out, indentation + 2);
  }

  // member: hitch_point_offset
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "hitch_point_offset:\n";
    to_block_style_yaml(msg.hitch_point_offset, out, indentation + 2);
  }

  // member: front_overhang
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "front_overhang:\n";
    to_block_style_yaml(msg.front_overhang, out, indentation + 2);
  }

  // member: front_overhang_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "front_overhang_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.front_overhang_is_present, out);
    out << "\n";
  }

  // member: rear_overhang
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rear_overhang:\n";
    to_block_style_yaml(msg.rear_overhang, out, indentation + 2);
  }

  // member: rear_overhang_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rear_overhang_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.rear_overhang_is_present, out);
    out << "\n";
  }

  // member: trailer_width
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "trailer_width:\n";
    to_block_style_yaml(msg.trailer_width, out, indentation + 2);
  }

  // member: trailer_width_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "trailer_width_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.trailer_width_is_present, out);
    out << "\n";
  }

  // member: hitch_angle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "hitch_angle:\n";
    to_block_style_yaml(msg.hitch_angle, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TrailerData & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::TrailerData & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::TrailerData & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::TrailerData>()
{
  return "etsi_its_cpm_ts_msgs::msg::TrailerData";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::TrailerData>()
{
  return "etsi_its_cpm_ts_msgs/msg/TrailerData";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::TrailerData>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::CartesianAngle>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::Identifier1B>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::StandardLength1B>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::VehicleWidth>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::TrailerData>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::CartesianAngle>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::Identifier1B>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::StandardLength1B>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::VehicleWidth>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::TrailerData>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__TRAILER_DATA__TRAITS_HPP_
