// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/VelocityPolarWithZ.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/velocity_polar_with_z__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `velocity_magnitude`
#include "etsi_its_cpm_ts_msgs/msg/detail/speed__functions.h"
// Member `velocity_direction`
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__functions.h"
// Member `z_velocity`
#include "etsi_its_cpm_ts_msgs/msg/detail/velocity_component__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__init(etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ * msg)
{
  if (!msg) {
    return false;
  }
  // velocity_magnitude
  if (!etsi_its_cpm_ts_msgs__msg__Speed__init(&msg->velocity_magnitude)) {
    etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__fini(msg);
    return false;
  }
  // velocity_direction
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__init(&msg->velocity_direction)) {
    etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__fini(msg);
    return false;
  }
  // z_velocity
  if (!etsi_its_cpm_ts_msgs__msg__VelocityComponent__init(&msg->z_velocity)) {
    etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__fini(msg);
    return false;
  }
  // z_velocity_is_present
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__fini(etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ * msg)
{
  if (!msg) {
    return;
  }
  // velocity_magnitude
  etsi_its_cpm_ts_msgs__msg__Speed__fini(&msg->velocity_magnitude);
  // velocity_direction
  etsi_its_cpm_ts_msgs__msg__CartesianAngle__fini(&msg->velocity_direction);
  // z_velocity
  etsi_its_cpm_ts_msgs__msg__VelocityComponent__fini(&msg->z_velocity);
  // z_velocity_is_present
}

bool
etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__are_equal(const etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ * lhs, const etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // velocity_magnitude
  if (!etsi_its_cpm_ts_msgs__msg__Speed__are_equal(
      &(lhs->velocity_magnitude), &(rhs->velocity_magnitude)))
  {
    return false;
  }
  // velocity_direction
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__are_equal(
      &(lhs->velocity_direction), &(rhs->velocity_direction)))
  {
    return false;
  }
  // z_velocity
  if (!etsi_its_cpm_ts_msgs__msg__VelocityComponent__are_equal(
      &(lhs->z_velocity), &(rhs->z_velocity)))
  {
    return false;
  }
  // z_velocity_is_present
  if (lhs->z_velocity_is_present != rhs->z_velocity_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__copy(
  const etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ * input,
  etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ * output)
{
  if (!input || !output) {
    return false;
  }
  // velocity_magnitude
  if (!etsi_its_cpm_ts_msgs__msg__Speed__copy(
      &(input->velocity_magnitude), &(output->velocity_magnitude)))
  {
    return false;
  }
  // velocity_direction
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__copy(
      &(input->velocity_direction), &(output->velocity_direction)))
  {
    return false;
  }
  // z_velocity
  if (!etsi_its_cpm_ts_msgs__msg__VelocityComponent__copy(
      &(input->z_velocity), &(output->z_velocity)))
  {
    return false;
  }
  // z_velocity_is_present
  output->z_velocity_is_present = input->z_velocity_is_present;
  return true;
}

etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ *
etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ * msg = (etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ));
  bool success = etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__destroy(etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence__init(etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence__fini(etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence *
etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence * array = (etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ * data =
      (etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
