// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/VelocityPolarWithZ.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VELOCITY_POLAR_WITH_Z__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VELOCITY_POLAR_WITH_Z__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'velocity_magnitude'
#include "etsi_its_cpm_ts_msgs/msg/detail/speed__struct.hpp"
// Member 'velocity_direction'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__struct.hpp"
// Member 'z_velocity'
#include "etsi_its_cpm_ts_msgs/msg/detail/velocity_component__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VelocityPolarWithZ_
{
  using Type = VelocityPolarWithZ_<ContainerAllocator>;

  explicit VelocityPolarWithZ_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : velocity_magnitude(_init),
    velocity_direction(_init),
    z_velocity(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->z_velocity_is_present = false;
    }
  }

  explicit VelocityPolarWithZ_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : velocity_magnitude(_alloc, _init),
    velocity_direction(_alloc, _init),
    z_velocity(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->z_velocity_is_present = false;
    }
  }

  // field types and members
  using _velocity_magnitude_type =
    etsi_its_cpm_ts_msgs::msg::Speed_<ContainerAllocator>;
  _velocity_magnitude_type velocity_magnitude;
  using _velocity_direction_type =
    etsi_its_cpm_ts_msgs::msg::CartesianAngle_<ContainerAllocator>;
  _velocity_direction_type velocity_direction;
  using _z_velocity_type =
    etsi_its_cpm_ts_msgs::msg::VelocityComponent_<ContainerAllocator>;
  _z_velocity_type z_velocity;
  using _z_velocity_is_present_type =
    bool;
  _z_velocity_is_present_type z_velocity_is_present;

  // setters for named parameter idiom
  Type & set__velocity_magnitude(
    const etsi_its_cpm_ts_msgs::msg::Speed_<ContainerAllocator> & _arg)
  {
    this->velocity_magnitude = _arg;
    return *this;
  }
  Type & set__velocity_direction(
    const etsi_its_cpm_ts_msgs::msg::CartesianAngle_<ContainerAllocator> & _arg)
  {
    this->velocity_direction = _arg;
    return *this;
  }
  Type & set__z_velocity(
    const etsi_its_cpm_ts_msgs::msg::VelocityComponent_<ContainerAllocator> & _arg)
  {
    this->z_velocity = _arg;
    return *this;
  }
  Type & set__z_velocity_is_present(
    const bool & _arg)
  {
    this->z_velocity_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::VelocityPolarWithZ_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::VelocityPolarWithZ_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::VelocityPolarWithZ_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::VelocityPolarWithZ_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::VelocityPolarWithZ_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::VelocityPolarWithZ_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::VelocityPolarWithZ_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::VelocityPolarWithZ_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::VelocityPolarWithZ_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::VelocityPolarWithZ_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::VelocityPolarWithZ_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::VelocityPolarWithZ_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VelocityPolarWithZ_ & other) const
  {
    if (this->velocity_magnitude != other.velocity_magnitude) {
      return false;
    }
    if (this->velocity_direction != other.velocity_direction) {
      return false;
    }
    if (this->z_velocity != other.z_velocity) {
      return false;
    }
    if (this->z_velocity_is_present != other.z_velocity_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const VelocityPolarWithZ_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VelocityPolarWithZ_

// alias to use template instance with default allocator
using VelocityPolarWithZ =
  etsi_its_cpm_ts_msgs::msg::VelocityPolarWithZ_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VELOCITY_POLAR_WITH_Z__STRUCT_HPP_
