// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/VruProfileAndSubprofile.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_PROFILE_AND_SUBPROFILE__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_PROFILE_AND_SUBPROFILE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'CHOICE_PEDESTRIAN'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__CHOICE_PEDESTRIAN = 0
};

/// Constant 'CHOICE_BICYCLIST_AND_LIGHT_VRU_VEHICLE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__CHOICE_BICYCLIST_AND_LIGHT_VRU_VEHICLE = 1
};

/// Constant 'CHOICE_MOTORCYCLIST'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__CHOICE_MOTORCYCLIST = 2
};

/// Constant 'CHOICE_ANIMAL'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__CHOICE_ANIMAL = 3
};

// Include directives for member types
// Member 'pedestrian'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_sub_profile_pedestrian__struct.h"
// Member 'bicyclist_and_light_vru_vehicle'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_sub_profile_bicyclist__struct.h"
// Member 'motorcyclist'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_sub_profile_motorcyclist__struct.h"
// Member 'animal'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_sub_profile_animal__struct.h"

/// Struct defined in msg/VruProfileAndSubprofile in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF indicates the profile of a VRU including sub-profile information
  ///  * It identifies four options corresponding to the four types of VRU profiles specified in ETSI TS 103 300-2:
  ///  *
  ///  * @field pedestrian: VRU Profile 1 - Pedestrian.
  ///  *
  ///  * @field bicyclistAndLightVruVehicle: VRU Profile  2 - Bicyclist.
  ///  *
  ///  * @field motorcyclist: VRU Profile 3  - Motorcyclist.
  ///  *
  ///  * @field animal: VRU Profile  4 -  Animal.
  ///  *
  ///  * @category: VRU information
  ///  * @revision: Created in V2.1.1
  ///  */
  /// VruProfileAndSubprofile ::= CHOICE {
  ///    pedestrian                     VruSubProfilePedestrian,
  ///    bicyclistAndLightVruVehicle    VruSubProfileBicyclist,
  ///    motorcyclist                   VruSubProfileMotorcyclist,
  ///    animal                         VruSubProfileAnimal,
  ///    ...
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t choice;
  etsi_its_cpm_ts_msgs__msg__VruSubProfilePedestrian pedestrian;
  etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist bicyclist_and_light_vru_vehicle;
  etsi_its_cpm_ts_msgs__msg__VruSubProfileMotorcyclist motorcyclist;
  etsi_its_cpm_ts_msgs__msg__VruSubProfileAnimal animal;
} etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile.
typedef struct etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence
{
  etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_PROFILE_AND_SUBPROFILE__STRUCT_H_
