// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/VruProfileAndSubprofile.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_PROFILE_AND_SUBPROFILE__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_PROFILE_AND_SUBPROFILE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'pedestrian'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_sub_profile_pedestrian__struct.hpp"
// Member 'bicyclist_and_light_vru_vehicle'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_sub_profile_bicyclist__struct.hpp"
// Member 'motorcyclist'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_sub_profile_motorcyclist__struct.hpp"
// Member 'animal'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_sub_profile_animal__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VruProfileAndSubprofile_
{
  using Type = VruProfileAndSubprofile_<ContainerAllocator>;

  explicit VruProfileAndSubprofile_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pedestrian(_init),
    bicyclist_and_light_vru_vehicle(_init),
    motorcyclist(_init),
    animal(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  explicit VruProfileAndSubprofile_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pedestrian(_alloc, _init),
    bicyclist_and_light_vru_vehicle(_alloc, _init),
    motorcyclist(_alloc, _init),
    animal(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  // field types and members
  using _choice_type =
    uint8_t;
  _choice_type choice;
  using _pedestrian_type =
    etsi_its_cpm_ts_msgs::msg::VruSubProfilePedestrian_<ContainerAllocator>;
  _pedestrian_type pedestrian;
  using _bicyclist_and_light_vru_vehicle_type =
    etsi_its_cpm_ts_msgs::msg::VruSubProfileBicyclist_<ContainerAllocator>;
  _bicyclist_and_light_vru_vehicle_type bicyclist_and_light_vru_vehicle;
  using _motorcyclist_type =
    etsi_its_cpm_ts_msgs::msg::VruSubProfileMotorcyclist_<ContainerAllocator>;
  _motorcyclist_type motorcyclist;
  using _animal_type =
    etsi_its_cpm_ts_msgs::msg::VruSubProfileAnimal_<ContainerAllocator>;
  _animal_type animal;

  // setters for named parameter idiom
  Type & set__choice(
    const uint8_t & _arg)
  {
    this->choice = _arg;
    return *this;
  }
  Type & set__pedestrian(
    const etsi_its_cpm_ts_msgs::msg::VruSubProfilePedestrian_<ContainerAllocator> & _arg)
  {
    this->pedestrian = _arg;
    return *this;
  }
  Type & set__bicyclist_and_light_vru_vehicle(
    const etsi_its_cpm_ts_msgs::msg::VruSubProfileBicyclist_<ContainerAllocator> & _arg)
  {
    this->bicyclist_and_light_vru_vehicle = _arg;
    return *this;
  }
  Type & set__motorcyclist(
    const etsi_its_cpm_ts_msgs::msg::VruSubProfileMotorcyclist_<ContainerAllocator> & _arg)
  {
    this->motorcyclist = _arg;
    return *this;
  }
  Type & set__animal(
    const etsi_its_cpm_ts_msgs::msg::VruSubProfileAnimal_<ContainerAllocator> & _arg)
  {
    this->animal = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t CHOICE_PEDESTRIAN =
    0u;
  static constexpr uint8_t CHOICE_BICYCLIST_AND_LIGHT_VRU_VEHICLE =
    1u;
  static constexpr uint8_t CHOICE_MOTORCYCLIST =
    2u;
  static constexpr uint8_t CHOICE_ANIMAL =
    3u;

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VruProfileAndSubprofile_ & other) const
  {
    if (this->choice != other.choice) {
      return false;
    }
    if (this->pedestrian != other.pedestrian) {
      return false;
    }
    if (this->bicyclist_and_light_vru_vehicle != other.bicyclist_and_light_vru_vehicle) {
      return false;
    }
    if (this->motorcyclist != other.motorcyclist) {
      return false;
    }
    if (this->animal != other.animal) {
      return false;
    }
    return true;
  }
  bool operator!=(const VruProfileAndSubprofile_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VruProfileAndSubprofile_

// alias to use template instance with default allocator
using VruProfileAndSubprofile =
  etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t VruProfileAndSubprofile_<ContainerAllocator>::CHOICE_PEDESTRIAN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t VruProfileAndSubprofile_<ContainerAllocator>::CHOICE_BICYCLIST_AND_LIGHT_VRU_VEHICLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t VruProfileAndSubprofile_<ContainerAllocator>::CHOICE_MOTORCYCLIST;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t VruProfileAndSubprofile_<ContainerAllocator>::CHOICE_ANIMAL;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_PROFILE_AND_SUBPROFILE__STRUCT_HPP_
