// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/VruProfileAndSubprofile.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_PROFILE_AND_SUBPROFILE__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_PROFILE_AND_SUBPROFILE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/vru_profile_and_subprofile__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'pedestrian'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_sub_profile_pedestrian__traits.hpp"
// Member 'bicyclist_and_light_vru_vehicle'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_sub_profile_bicyclist__traits.hpp"
// Member 'motorcyclist'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_sub_profile_motorcyclist__traits.hpp"
// Member 'animal'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_sub_profile_animal__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const VruProfileAndSubprofile & msg,
  std::ostream & out)
{
  out << "{";
  // member: choice
  {
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << ", ";
  }

  // member: pedestrian
  {
    out << "pedestrian: ";
    to_flow_style_yaml(msg.pedestrian, out);
    out << ", ";
  }

  // member: bicyclist_and_light_vru_vehicle
  {
    out << "bicyclist_and_light_vru_vehicle: ";
    to_flow_style_yaml(msg.bicyclist_and_light_vru_vehicle, out);
    out << ", ";
  }

  // member: motorcyclist
  {
    out << "motorcyclist: ";
    to_flow_style_yaml(msg.motorcyclist, out);
    out << ", ";
  }

  // member: animal
  {
    out << "animal: ";
    to_flow_style_yaml(msg.animal, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const VruProfileAndSubprofile & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: choice
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << "\n";
  }

  // member: pedestrian
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pedestrian:\n";
    to_block_style_yaml(msg.pedestrian, out, indentation + 2);
  }

  // member: bicyclist_and_light_vru_vehicle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "bicyclist_and_light_vru_vehicle:\n";
    to_block_style_yaml(msg.bicyclist_and_light_vru_vehicle, out, indentation + 2);
  }

  // member: motorcyclist
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "motorcyclist:\n";
    to_block_style_yaml(msg.motorcyclist, out, indentation + 2);
  }

  // member: animal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "animal:\n";
    to_block_style_yaml(msg.animal, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const VruProfileAndSubprofile & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile>()
{
  return "etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile>()
{
  return "etsi_its_cpm_ts_msgs/msg/VruProfileAndSubprofile";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::VruSubProfileAnimal>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::VruSubProfileBicyclist>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::VruSubProfileMotorcyclist>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::VruSubProfilePedestrian>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::VruSubProfileAnimal>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::VruSubProfileBicyclist>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::VruSubProfileMotorcyclist>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::VruSubProfilePedestrian>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::VruProfileAndSubprofile>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_PROFILE_AND_SUBPROFILE__TRAITS_HPP_
