// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/VruSubProfileBicyclist.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_SUB_PROFILE_BICYCLIST__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_SUB_PROFILE_BICYCLIST__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist__UNAVAILABLE = 0
};

/// Constant 'BICYCLIST'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist__BICYCLIST = 1
};

/// Constant 'WHEELCHAIR_USER'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist__WHEELCHAIR_USER = 2
};

/// Constant 'HORSE_AND_RIDER'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist__HORSE_AND_RIDER = 3
};

/// Constant 'ROLLERSKATER'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist__ROLLERSKATER = 4
};

/// Constant 'E_SCOOTER'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist__E_SCOOTER = 5
};

/// Constant 'PERSONAL_TRANSPORTER'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist__PERSONAL_TRANSPORTER = 6
};

/// Constant 'PEDELEC'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist__PEDELEC = 7
};

/// Constant 'SPEED_PEDELEC'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist__SPEED_PEDELEC = 8
};

/// Constant 'MAX'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist__MAX = 15
};

/// Struct defined in msg/VruSubProfileBicyclist in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the profile of a VRU and its light VRU vehicle / mounted animal.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 `unavailable`           - to indicate that the information  is unavailable,
  ///  * - 1 `bicyclist `            - to indicate a cycle and bicyclist,
  ///  * - 2 `wheelchair-user`       - to indicate a wheelchair and its user,
  ///  * - 3 `horse-and-rider`       - to indicate a horse and rider,
  ///  * - 4 `rollerskater`          - to indicate a rolleskater and skater,
  ///  * - 5 `e-scooter`             - to indicate an e-scooter and rider,
  ///  * - 6 `personal-transporter`  - to indicate a personal-transporter and rider,
  ///  * - 7 `pedelec`               - to indicate a pedelec and rider,
  ///  * - 8 `speed-pedelec`         - to indicate a speed-pedelec and rider.
  ///  * - 9 to 15                   - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
  ///  *
  ///  * @category: VRU information
  ///  * @revision: Created in V2.1.1
  ///  */
  /// VruSubProfileBicyclist ::= ENUMERATED {
  ///     unavailable          (0),
  ///     bicyclist            (1),
  ///     wheelchair-user      (2),
  ///     horse-and-rider      (3),
  ///     rollerskater         (4),
  ///     e-scooter            (5),
  ///     personal-transporter (6),
  ///     pedelec              (7),
  ///     speed-pedelec        (8),
  ///     max                  (15)
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist.
typedef struct etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist__Sequence
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_SUB_PROFILE_BICYCLIST__STRUCT_H_
