// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/VruSubProfileMotorcyclist.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_SUB_PROFILE_MOTORCYCLIST__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_SUB_PROFILE_MOTORCYCLIST__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileMotorcyclist__UNAVAILABLE = 0
};

/// Constant 'MOPED'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileMotorcyclist__MOPED = 1
};

/// Constant 'MOTORCYCLE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileMotorcyclist__MOTORCYCLE = 2
};

/// Constant 'MOTORCYCLE_AND_SIDECAR_RIGHT'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileMotorcyclist__MOTORCYCLE_AND_SIDECAR_RIGHT = 3
};

/// Constant 'MOTORCYCLE_AND_SIDECAR_LEFT'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileMotorcyclist__MOTORCYCLE_AND_SIDECAR_LEFT = 4
};

/// Constant 'MAX'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileMotorcyclist__MAX = 15
};

/// Struct defined in msg/VruSubProfileMotorcyclist in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__VruSubProfileMotorcyclist
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the profile of a motorcyclist and corresponding vehicle.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 `unavailable `                  - to indicate that the information  is unavailable,
  ///  * - 1 `moped`                         - to indicate a moped and rider,
  ///  * - 2 `motorcycle`                    - to indicate a motorcycle and rider,
  ///  * - 3 `motorcycle-and-sidecar-right`  - to indicate a motorcycle with sidecar on the right and rider,
  ///  * - 4 `motorcycle-and-sidecar-left`   - to indicate  a motorcycle with sidecar on the left and rider.
  ///  * - 5 to 15                           - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
  ///  *
  ///  * @category: VRU information
  ///  * @revision: Created in V2.1.1
  ///  */
  /// VruSubProfileMotorcyclist ::= ENUMERATED {
  ///     unavailable                  (0),
  ///     moped                        (1),
  ///     motorcycle                   (2),
  ///     motorcycle-and-sidecar-right (3),
  ///     motorcycle-and-sidecar-left  (4),
  ///     max                          (15)
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cpm_ts_msgs__msg__VruSubProfileMotorcyclist;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__VruSubProfileMotorcyclist.
typedef struct etsi_its_cpm_ts_msgs__msg__VruSubProfileMotorcyclist__Sequence
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileMotorcyclist * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__VruSubProfileMotorcyclist__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_SUB_PROFILE_MOTORCYCLIST__STRUCT_H_
