// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/WrappedCpmContainers.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__WRAPPED_CPM_CONTAINERS__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__WRAPPED_CPM_CONTAINERS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'array'
#include "etsi_its_cpm_ts_msgs/msg/detail/wrapped_cpm_container__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__WrappedCpmContainers __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__WrappedCpmContainers __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct WrappedCpmContainers_
{
  using Type = WrappedCpmContainers_<ContainerAllocator>;

  explicit WrappedCpmContainers_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit WrappedCpmContainers_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _array_type =
    std::vector<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainer_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainer_<ContainerAllocator>>>;
  _array_type array;

  // setters for named parameter idiom
  Type & set__array(
    const std::vector<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainer_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainer_<ContainerAllocator>>> & _arg)
  {
    this->array = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t MIN_SIZE =
    1u;
  static constexpr uint8_t MAX_SIZE =
    8u;

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::WrappedCpmContainers_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::WrappedCpmContainers_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainers_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainers_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::WrappedCpmContainers_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainers_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::WrappedCpmContainers_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainers_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainers_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainers_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__WrappedCpmContainers
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainers_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__WrappedCpmContainers
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainers_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const WrappedCpmContainers_ & other) const
  {
    if (this->array != other.array) {
      return false;
    }
    return true;
  }
  bool operator!=(const WrappedCpmContainers_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct WrappedCpmContainers_

// alias to use template instance with default allocator
using WrappedCpmContainers =
  etsi_its_cpm_ts_msgs::msg::WrappedCpmContainers_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t WrappedCpmContainers_<ContainerAllocator>::MIN_SIZE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t WrappedCpmContainers_<ContainerAllocator>::MAX_SIZE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__WRAPPED_CPM_CONTAINERS__STRUCT_HPP_
