// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/AccelerationPolarWithZ.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ACCELERATION_POLAR_WITH_Z__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ACCELERATION_POLAR_WITH_Z__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'acceleration_magnitude'
#include "etsi_its_cpm_ts_msgs/msg/detail/acceleration_magnitude__struct.hpp"
// Member 'acceleration_direction'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__struct.hpp"
// Member 'z_acceleration'
#include "etsi_its_cpm_ts_msgs/msg/detail/acceleration_component__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AccelerationPolarWithZ_
{
  using Type = AccelerationPolarWithZ_<ContainerAllocator>;

  explicit AccelerationPolarWithZ_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : acceleration_magnitude(_init),
    acceleration_direction(_init),
    z_acceleration(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->z_acceleration_is_present = false;
    }
  }

  explicit AccelerationPolarWithZ_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : acceleration_magnitude(_alloc, _init),
    acceleration_direction(_alloc, _init),
    z_acceleration(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->z_acceleration_is_present = false;
    }
  }

  // field types and members
  using _acceleration_magnitude_type =
    etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude_<ContainerAllocator>;
  _acceleration_magnitude_type acceleration_magnitude;
  using _acceleration_direction_type =
    etsi_its_cpm_ts_msgs::msg::CartesianAngle_<ContainerAllocator>;
  _acceleration_direction_type acceleration_direction;
  using _z_acceleration_type =
    etsi_its_cpm_ts_msgs::msg::AccelerationComponent_<ContainerAllocator>;
  _z_acceleration_type z_acceleration;
  using _z_acceleration_is_present_type =
    bool;
  _z_acceleration_is_present_type z_acceleration_is_present;

  // setters for named parameter idiom
  Type & set__acceleration_magnitude(
    const etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude_<ContainerAllocator> & _arg)
  {
    this->acceleration_magnitude = _arg;
    return *this;
  }
  Type & set__acceleration_direction(
    const etsi_its_cpm_ts_msgs::msg::CartesianAngle_<ContainerAllocator> & _arg)
  {
    this->acceleration_direction = _arg;
    return *this;
  }
  Type & set__z_acceleration(
    const etsi_its_cpm_ts_msgs::msg::AccelerationComponent_<ContainerAllocator> & _arg)
  {
    this->z_acceleration = _arg;
    return *this;
  }
  Type & set__z_acceleration_is_present(
    const bool & _arg)
  {
    this->z_acceleration_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__AccelerationPolarWithZ
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AccelerationPolarWithZ_ & other) const
  {
    if (this->acceleration_magnitude != other.acceleration_magnitude) {
      return false;
    }
    if (this->acceleration_direction != other.acceleration_direction) {
      return false;
    }
    if (this->z_acceleration != other.z_acceleration) {
      return false;
    }
    if (this->z_acceleration_is_present != other.z_acceleration_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const AccelerationPolarWithZ_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AccelerationPolarWithZ_

// alias to use template instance with default allocator
using AccelerationPolarWithZ =
  etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ACCELERATION_POLAR_WITH_Z__STRUCT_HPP_
