// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/AccelerationPolarWithZ.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ACCELERATION_POLAR_WITH_Z__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ACCELERATION_POLAR_WITH_Z__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/acceleration_polar_with_z__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'acceleration_magnitude'
#include "etsi_its_cpm_ts_msgs/msg/detail/acceleration_magnitude__traits.hpp"
// Member 'acceleration_direction'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__traits.hpp"
// Member 'z_acceleration'
#include "etsi_its_cpm_ts_msgs/msg/detail/acceleration_component__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const AccelerationPolarWithZ & msg,
  std::ostream & out)
{
  out << "{";
  // member: acceleration_magnitude
  {
    out << "acceleration_magnitude: ";
    to_flow_style_yaml(msg.acceleration_magnitude, out);
    out << ", ";
  }

  // member: acceleration_direction
  {
    out << "acceleration_direction: ";
    to_flow_style_yaml(msg.acceleration_direction, out);
    out << ", ";
  }

  // member: z_acceleration
  {
    out << "z_acceleration: ";
    to_flow_style_yaml(msg.z_acceleration, out);
    out << ", ";
  }

  // member: z_acceleration_is_present
  {
    out << "z_acceleration_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.z_acceleration_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const AccelerationPolarWithZ & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: acceleration_magnitude
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "acceleration_magnitude:\n";
    to_block_style_yaml(msg.acceleration_magnitude, out, indentation + 2);
  }

  // member: acceleration_direction
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "acceleration_direction:\n";
    to_block_style_yaml(msg.acceleration_direction, out, indentation + 2);
  }

  // member: z_acceleration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "z_acceleration:\n";
    to_block_style_yaml(msg.z_acceleration, out, indentation + 2);
  }

  // member: z_acceleration_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "z_acceleration_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.z_acceleration_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const AccelerationPolarWithZ & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ>()
{
  return "etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ>()
{
  return "etsi_its_cpm_ts_msgs/msg/AccelerationPolarWithZ";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::AccelerationComponent>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::CartesianAngle>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::AccelerationComponent>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::AccelerationMagnitude>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::CartesianAngle>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::AccelerationPolarWithZ>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ACCELERATION_POLAR_WITH_Z__TRAITS_HPP_
