// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/Altitude.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ALTITUDE__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ALTITUDE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/altitude__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'altitude_value'
#include "etsi_its_cpm_ts_msgs/msg/detail/altitude_value__traits.hpp"
// Member 'altitude_confidence'
#include "etsi_its_cpm_ts_msgs/msg/detail/altitude_confidence__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Altitude & msg,
  std::ostream & out)
{
  out << "{";
  // member: altitude_value
  {
    out << "altitude_value: ";
    to_flow_style_yaml(msg.altitude_value, out);
    out << ", ";
  }

  // member: altitude_confidence
  {
    out << "altitude_confidence: ";
    to_flow_style_yaml(msg.altitude_confidence, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Altitude & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: altitude_value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "altitude_value:\n";
    to_block_style_yaml(msg.altitude_value, out, indentation + 2);
  }

  // member: altitude_confidence
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "altitude_confidence:\n";
    to_block_style_yaml(msg.altitude_confidence, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Altitude & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::Altitude & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::Altitude & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::Altitude>()
{
  return "etsi_its_cpm_ts_msgs::msg::Altitude";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::Altitude>()
{
  return "etsi_its_cpm_ts_msgs/msg/Altitude";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::Altitude>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::AltitudeConfidence>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::AltitudeValue>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::Altitude>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::AltitudeConfidence>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::AltitudeValue>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::Altitude>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ALTITUDE__TRAITS_HPP_
