// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/AngularSpeedConfidence.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ANGULAR_SPEED_CONFIDENCE__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ANGULAR_SPEED_CONFIDENCE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'DEG_SEC_01'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AngularSpeedConfidence__DEG_SEC_01 = 0
};

/// Constant 'DEG_SEC_02'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AngularSpeedConfidence__DEG_SEC_02 = 1
};

/// Constant 'DEG_SEC_05'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AngularSpeedConfidence__DEG_SEC_05 = 2
};

/// Constant 'DEG_SEC_10'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AngularSpeedConfidence__DEG_SEC_10 = 3
};

/// Constant 'DEG_SEC_20'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AngularSpeedConfidence__DEG_SEC_20 = 4
};

/// Constant 'DEG_SEC_50'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AngularSpeedConfidence__DEG_SEC_50 = 5
};

/// Constant 'OUT_OF_RANGE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AngularSpeedConfidence__OUT_OF_RANGE = 6
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AngularSpeedConfidence__UNAVAILABLE = 7
};

/// Struct defined in msg/AngularSpeedConfidence in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__AngularSpeedConfidence
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the angular speed confidence value which represents the estimated absolute accuracy of an angular speed value with a default confidence level of 95 %.
  ///  * If required, the confidence level can be defined by the corresponding standards applying this DE.
  ///  * For correlation computation, maximum interval levels can be assumed.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 - `degSec-01`   - if the accuracy is equal to or less than 1 degree/second,
  ///  * - 1 - `degSec-02`   - if the accuracy is equal to or less than 2 degrees/second and greater than 1 degree/second,
  ///  * - 2 - `degSec-05`   - if the accuracy is equal to or less than 5 degrees/second and greater than 2 degrees/second,
  ///  * - 3 - `degSec-10`   - if the accuracy is equal to or less than 10 degrees/second and greater than 5 degrees/second,
  ///  * - 4 - `degSec-20`   - if the accuracy is equal to or less than 20 degrees/second and greater than 10 degrees/second,
  ///  * - 5 - `degSec-50`   - if the accuracy is equal to or less than 50 degrees/second and greater than 20 degrees/second,
  ///  * - 6 - `outOfRange`  - if the accuracy is out of range, i.e. greater than 50 degrees/second,
  ///  * - 7 - `unavailable` - if the accuracy information is unavailable.
  ///  *
  ///  * @category: Kinematic information
  ///  * @revision: Created in V2.1.1
  /// */
  /// AngularSpeedConfidence ::= ENUMERATED {
  ///     degSec-01   (0),
  ///     degSec-02   (1),
  ///     degSec-05   (2),
  ///     degSec-10   (3),
  ///     degSec-20   (4),
  ///     degSec-50   (5),
  ///     outOfRange  (6),
  ///     unavailable (7)
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cpm_ts_msgs__msg__AngularSpeedConfidence;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__AngularSpeedConfidence.
typedef struct etsi_its_cpm_ts_msgs__msg__AngularSpeedConfidence__Sequence
{
  etsi_its_cpm_ts_msgs__msg__AngularSpeedConfidence * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__AngularSpeedConfidence__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ANGULAR_SPEED_CONFIDENCE__STRUCT_H_
