// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/CartesianAngleValue.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CARTESIAN_ANGLE_VALUE__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CARTESIAN_ANGLE_VALUE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__MAX = 3601
};

/// Constant 'VALUE_NOT_USED'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__VALUE_NOT_USED = 3600
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__UNAVAILABLE = 3601
};

/// Struct defined in msg/CartesianAngleValue in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__CartesianAngleValue
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
  ///  * a right-hand local coordinate system from the abscissa.
  ///  *
  ///  * The value shall be set to:
  ///  * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
  ///  * - `36001` if the accuracy information is not available.
  ///  *
  ///  * The value 3600 shall not be used.
  ///  *
  ///  * @unit 0,1 degrees
  ///  * @category: Basic information
  ///  * @revision: Created in V2.1.1
  /// */
  /// CartesianAngleValue ::= INTEGER {
  ///     valueNotUsed (3600),
  ///     unavailable  (3601)
  /// } (0..3601)
  /// ------------------------------------------------------------------------------
  uint16_t value;
} etsi_its_cpm_ts_msgs__msg__CartesianAngleValue;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__CartesianAngleValue.
typedef struct etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__Sequence
{
  etsi_its_cpm_ts_msgs__msg__CartesianAngleValue * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CARTESIAN_ANGLE_VALUE__STRUCT_H_
