// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/CartesianCoordinateLarge.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CARTESIAN_COORDINATE_LARGE__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CARTESIAN_COORDINATE_LARGE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CartesianCoordinateLarge__MIN = -131072l
};

/// Constant 'MAX'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CartesianCoordinateLarge__MAX = 131071l
};

/// Constant 'NEGATIVE_OUT_OF_RANGE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CartesianCoordinateLarge__NEGATIVE_OUT_OF_RANGE = -131072l
};

/// Constant 'POSITIVE_OUT_OF_RANGE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CartesianCoordinateLarge__POSITIVE_OUT_OF_RANGE = 131071l
};

/// Struct defined in msg/CartesianCoordinateLarge in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__CartesianCoordinateLarge
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF represents the value of a cartesian coordinate with a range of -1 310,72 metres to +1 310,70 metres.
  ///  *
  ///  * The value shall be set to:
  ///  * - `-131072` if the longitudinal offset is out of range, i.e. less than or equal to -1 310,72 metres,
  ///  * - `n` (`n > 131 072` and `n < 131 071`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
  ///  * - `131 071` if the longitudinal offset is out of range, i.e. greater than + 1 310,70 metres.
  ///  *
  ///  * @unit 0,01 m
  ///  * @category: Basic information
  ///  * @revision: Created in V2.1.1
  /// */
  /// CartesianCoordinateLarge::= INTEGER{
  ///     negativeOutOfRange (-131072),
  ///     positiveOutOfRange (131071)
  /// } (-131072..131071)
  /// ------------------------------------------------------------------------------
  int32_t value;
} etsi_its_cpm_ts_msgs__msg__CartesianCoordinateLarge;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__CartesianCoordinateLarge.
typedef struct etsi_its_cpm_ts_msgs__msg__CartesianCoordinateLarge__Sequence
{
  etsi_its_cpm_ts_msgs__msg__CartesianCoordinateLarge * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__CartesianCoordinateLarge__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CARTESIAN_COORDINATE_LARGE__STRUCT_H_
