// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/CorrelationCellValue.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CORRELATION_CELL_VALUE__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CORRELATION_CELL_VALUE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CorrelationCellValue__MIN = -100
};

/// Constant 'MAX'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CorrelationCellValue__MAX = 101
};

/// Constant 'FULL_NEGATIVE_CORRELATION'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CorrelationCellValue__FULL_NEGATIVE_CORRELATION = -100
};

/// Constant 'NO_CORRELATION'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CorrelationCellValue__NO_CORRELATION = 0
};

/// Constant 'FULL_POSITIVE_CORRELATION'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CorrelationCellValue__FULL_POSITIVE_CORRELATION = 100
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__CorrelationCellValue__UNAVAILABLE = 101
};

/// Struct defined in msg/CorrelationCellValue in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__CorrelationCellValue
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the Bravais-Pearson correlation value for each cell of a lower triangular correlation matrix.
  ///  *
  ///  * The value shall be set to:
  ///  * - `-100` in case of full negative correlation,
  ///  * - `n` (`n > -100` and `n < 0`) if the correlation is negative and equal to n x 100,
  ///  * - `0` in case of no correlation,
  ///  * - `n` (`n > 0` and `n < 100`) if the correlation is positive and equal to n x 100,
  ///  * - `100` in case of full positive correlation,
  ///  * - `101` in case the correlation information is unavailable.
  ///  *
  ///  * @unit: the value is scaled by 100
  ///  * @category: Basic information
  ///  * @revision: Created in V2.1.1
  /// */
  /// CorrelationCellValue ::= INTEGER {
  ///     full-negative-correlation    (-100),
  ///     no-correlation               (0),
  ///     full-positive-correlation    (100),
  ///     unavailable (101)
  /// } (-100..101)
  /// ------------------------------------------------------------------------------
  int8_t value;
} etsi_its_cpm_ts_msgs__msg__CorrelationCellValue;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__CorrelationCellValue.
typedef struct etsi_its_cpm_ts_msgs__msg__CorrelationCellValue__Sequence
{
  etsi_its_cpm_ts_msgs__msg__CorrelationCellValue * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__CorrelationCellValue__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__CORRELATION_CELL_VALUE__STRUCT_H_
