// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/EllipticalShape.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ELLIPTICAL_SHAPE__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ELLIPTICAL_SHAPE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'shape_reference_point'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_position3d__struct.hpp"
// Member 'semi_major_axis_length'
// Member 'semi_minor_axis_length'
// Member 'height'
#include "etsi_its_cpm_ts_msgs/msg/detail/standard_length12b__struct.hpp"
// Member 'orientation'
#include "etsi_its_cpm_ts_msgs/msg/detail/wgs84_angle_value__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__EllipticalShape __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__EllipticalShape __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct EllipticalShape_
{
  using Type = EllipticalShape_<ContainerAllocator>;

  explicit EllipticalShape_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : shape_reference_point(_init),
    semi_major_axis_length(_init),
    semi_minor_axis_length(_init),
    orientation(_init),
    height(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->shape_reference_point_is_present = false;
      this->orientation_is_present = false;
      this->height_is_present = false;
    }
  }

  explicit EllipticalShape_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : shape_reference_point(_alloc, _init),
    semi_major_axis_length(_alloc, _init),
    semi_minor_axis_length(_alloc, _init),
    orientation(_alloc, _init),
    height(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->shape_reference_point_is_present = false;
      this->orientation_is_present = false;
      this->height_is_present = false;
    }
  }

  // field types and members
  using _shape_reference_point_type =
    etsi_its_cpm_ts_msgs::msg::CartesianPosition3d_<ContainerAllocator>;
  _shape_reference_point_type shape_reference_point;
  using _shape_reference_point_is_present_type =
    bool;
  _shape_reference_point_is_present_type shape_reference_point_is_present;
  using _semi_major_axis_length_type =
    etsi_its_cpm_ts_msgs::msg::StandardLength12b_<ContainerAllocator>;
  _semi_major_axis_length_type semi_major_axis_length;
  using _semi_minor_axis_length_type =
    etsi_its_cpm_ts_msgs::msg::StandardLength12b_<ContainerAllocator>;
  _semi_minor_axis_length_type semi_minor_axis_length;
  using _orientation_type =
    etsi_its_cpm_ts_msgs::msg::Wgs84AngleValue_<ContainerAllocator>;
  _orientation_type orientation;
  using _orientation_is_present_type =
    bool;
  _orientation_is_present_type orientation_is_present;
  using _height_type =
    etsi_its_cpm_ts_msgs::msg::StandardLength12b_<ContainerAllocator>;
  _height_type height;
  using _height_is_present_type =
    bool;
  _height_is_present_type height_is_present;

  // setters for named parameter idiom
  Type & set__shape_reference_point(
    const etsi_its_cpm_ts_msgs::msg::CartesianPosition3d_<ContainerAllocator> & _arg)
  {
    this->shape_reference_point = _arg;
    return *this;
  }
  Type & set__shape_reference_point_is_present(
    const bool & _arg)
  {
    this->shape_reference_point_is_present = _arg;
    return *this;
  }
  Type & set__semi_major_axis_length(
    const etsi_its_cpm_ts_msgs::msg::StandardLength12b_<ContainerAllocator> & _arg)
  {
    this->semi_major_axis_length = _arg;
    return *this;
  }
  Type & set__semi_minor_axis_length(
    const etsi_its_cpm_ts_msgs::msg::StandardLength12b_<ContainerAllocator> & _arg)
  {
    this->semi_minor_axis_length = _arg;
    return *this;
  }
  Type & set__orientation(
    const etsi_its_cpm_ts_msgs::msg::Wgs84AngleValue_<ContainerAllocator> & _arg)
  {
    this->orientation = _arg;
    return *this;
  }
  Type & set__orientation_is_present(
    const bool & _arg)
  {
    this->orientation_is_present = _arg;
    return *this;
  }
  Type & set__height(
    const etsi_its_cpm_ts_msgs::msg::StandardLength12b_<ContainerAllocator> & _arg)
  {
    this->height = _arg;
    return *this;
  }
  Type & set__height_is_present(
    const bool & _arg)
  {
    this->height_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::EllipticalShape_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::EllipticalShape_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::EllipticalShape_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::EllipticalShape_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::EllipticalShape_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::EllipticalShape_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::EllipticalShape_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::EllipticalShape_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::EllipticalShape_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::EllipticalShape_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__EllipticalShape
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::EllipticalShape_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__EllipticalShape
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::EllipticalShape_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EllipticalShape_ & other) const
  {
    if (this->shape_reference_point != other.shape_reference_point) {
      return false;
    }
    if (this->shape_reference_point_is_present != other.shape_reference_point_is_present) {
      return false;
    }
    if (this->semi_major_axis_length != other.semi_major_axis_length) {
      return false;
    }
    if (this->semi_minor_axis_length != other.semi_minor_axis_length) {
      return false;
    }
    if (this->orientation != other.orientation) {
      return false;
    }
    if (this->orientation_is_present != other.orientation_is_present) {
      return false;
    }
    if (this->height != other.height) {
      return false;
    }
    if (this->height_is_present != other.height_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const EllipticalShape_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EllipticalShape_

// alias to use template instance with default allocator
using EllipticalShape =
  etsi_its_cpm_ts_msgs::msg::EllipticalShape_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ELLIPTICAL_SHAPE__STRUCT_HPP_
