// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/IntersectionReferenceId.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__INTERSECTION_REFERENCE_ID__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__INTERSECTION_REFERENCE_ID__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'region'
// Member 'id'
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier2_b__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__IntersectionReferenceId __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__IntersectionReferenceId __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct IntersectionReferenceId_
{
  using Type = IntersectionReferenceId_<ContainerAllocator>;

  explicit IntersectionReferenceId_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : region(_init),
    id(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->region_is_present = false;
    }
  }

  explicit IntersectionReferenceId_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : region(_alloc, _init),
    id(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->region_is_present = false;
    }
  }

  // field types and members
  using _region_type =
    etsi_its_cpm_ts_msgs::msg::Identifier2B_<ContainerAllocator>;
  _region_type region;
  using _region_is_present_type =
    bool;
  _region_is_present_type region_is_present;
  using _id_type =
    etsi_its_cpm_ts_msgs::msg::Identifier2B_<ContainerAllocator>;
  _id_type id;

  // setters for named parameter idiom
  Type & set__region(
    const etsi_its_cpm_ts_msgs::msg::Identifier2B_<ContainerAllocator> & _arg)
  {
    this->region = _arg;
    return *this;
  }
  Type & set__region_is_present(
    const bool & _arg)
  {
    this->region_is_present = _arg;
    return *this;
  }
  Type & set__id(
    const etsi_its_cpm_ts_msgs::msg::Identifier2B_<ContainerAllocator> & _arg)
  {
    this->id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::IntersectionReferenceId_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::IntersectionReferenceId_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::IntersectionReferenceId_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::IntersectionReferenceId_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::IntersectionReferenceId_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::IntersectionReferenceId_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::IntersectionReferenceId_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::IntersectionReferenceId_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::IntersectionReferenceId_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::IntersectionReferenceId_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__IntersectionReferenceId
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::IntersectionReferenceId_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__IntersectionReferenceId
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::IntersectionReferenceId_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const IntersectionReferenceId_ & other) const
  {
    if (this->region != other.region) {
      return false;
    }
    if (this->region_is_present != other.region_is_present) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    return true;
  }
  bool operator!=(const IntersectionReferenceId_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct IntersectionReferenceId_

// alias to use template instance with default allocator
using IntersectionReferenceId =
  etsi_its_cpm_ts_msgs::msg::IntersectionReferenceId_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__INTERSECTION_REFERENCE_ID__STRUCT_HPP_
