// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/ManagementContainer.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/management_container__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `reference_time`
#include "etsi_its_cpm_ts_msgs/msg/detail/timestamp_its__functions.h"
// Member `reference_position`
#include "etsi_its_cpm_ts_msgs/msg/detail/reference_position__functions.h"
// Member `segmentation_info`
#include "etsi_its_cpm_ts_msgs/msg/detail/message_segmentation_info__functions.h"
// Member `message_rate_range`
#include "etsi_its_cpm_ts_msgs/msg/detail/message_rate_range__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__ManagementContainer__init(etsi_its_cpm_ts_msgs__msg__ManagementContainer * msg)
{
  if (!msg) {
    return false;
  }
  // reference_time
  if (!etsi_its_cpm_ts_msgs__msg__TimestampIts__init(&msg->reference_time)) {
    etsi_its_cpm_ts_msgs__msg__ManagementContainer__fini(msg);
    return false;
  }
  // reference_position
  if (!etsi_its_cpm_ts_msgs__msg__ReferencePosition__init(&msg->reference_position)) {
    etsi_its_cpm_ts_msgs__msg__ManagementContainer__fini(msg);
    return false;
  }
  // segmentation_info
  if (!etsi_its_cpm_ts_msgs__msg__MessageSegmentationInfo__init(&msg->segmentation_info)) {
    etsi_its_cpm_ts_msgs__msg__ManagementContainer__fini(msg);
    return false;
  }
  // segmentation_info_is_present
  // message_rate_range
  if (!etsi_its_cpm_ts_msgs__msg__MessageRateRange__init(&msg->message_rate_range)) {
    etsi_its_cpm_ts_msgs__msg__ManagementContainer__fini(msg);
    return false;
  }
  // message_rate_range_is_present
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__ManagementContainer__fini(etsi_its_cpm_ts_msgs__msg__ManagementContainer * msg)
{
  if (!msg) {
    return;
  }
  // reference_time
  etsi_its_cpm_ts_msgs__msg__TimestampIts__fini(&msg->reference_time);
  // reference_position
  etsi_its_cpm_ts_msgs__msg__ReferencePosition__fini(&msg->reference_position);
  // segmentation_info
  etsi_its_cpm_ts_msgs__msg__MessageSegmentationInfo__fini(&msg->segmentation_info);
  // segmentation_info_is_present
  // message_rate_range
  etsi_its_cpm_ts_msgs__msg__MessageRateRange__fini(&msg->message_rate_range);
  // message_rate_range_is_present
}

bool
etsi_its_cpm_ts_msgs__msg__ManagementContainer__are_equal(const etsi_its_cpm_ts_msgs__msg__ManagementContainer * lhs, const etsi_its_cpm_ts_msgs__msg__ManagementContainer * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // reference_time
  if (!etsi_its_cpm_ts_msgs__msg__TimestampIts__are_equal(
      &(lhs->reference_time), &(rhs->reference_time)))
  {
    return false;
  }
  // reference_position
  if (!etsi_its_cpm_ts_msgs__msg__ReferencePosition__are_equal(
      &(lhs->reference_position), &(rhs->reference_position)))
  {
    return false;
  }
  // segmentation_info
  if (!etsi_its_cpm_ts_msgs__msg__MessageSegmentationInfo__are_equal(
      &(lhs->segmentation_info), &(rhs->segmentation_info)))
  {
    return false;
  }
  // segmentation_info_is_present
  if (lhs->segmentation_info_is_present != rhs->segmentation_info_is_present) {
    return false;
  }
  // message_rate_range
  if (!etsi_its_cpm_ts_msgs__msg__MessageRateRange__are_equal(
      &(lhs->message_rate_range), &(rhs->message_rate_range)))
  {
    return false;
  }
  // message_rate_range_is_present
  if (lhs->message_rate_range_is_present != rhs->message_rate_range_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__ManagementContainer__copy(
  const etsi_its_cpm_ts_msgs__msg__ManagementContainer * input,
  etsi_its_cpm_ts_msgs__msg__ManagementContainer * output)
{
  if (!input || !output) {
    return false;
  }
  // reference_time
  if (!etsi_its_cpm_ts_msgs__msg__TimestampIts__copy(
      &(input->reference_time), &(output->reference_time)))
  {
    return false;
  }
  // reference_position
  if (!etsi_its_cpm_ts_msgs__msg__ReferencePosition__copy(
      &(input->reference_position), &(output->reference_position)))
  {
    return false;
  }
  // segmentation_info
  if (!etsi_its_cpm_ts_msgs__msg__MessageSegmentationInfo__copy(
      &(input->segmentation_info), &(output->segmentation_info)))
  {
    return false;
  }
  // segmentation_info_is_present
  output->segmentation_info_is_present = input->segmentation_info_is_present;
  // message_rate_range
  if (!etsi_its_cpm_ts_msgs__msg__MessageRateRange__copy(
      &(input->message_rate_range), &(output->message_rate_range)))
  {
    return false;
  }
  // message_rate_range_is_present
  output->message_rate_range_is_present = input->message_rate_range_is_present;
  return true;
}

etsi_its_cpm_ts_msgs__msg__ManagementContainer *
etsi_its_cpm_ts_msgs__msg__ManagementContainer__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__ManagementContainer * msg = (etsi_its_cpm_ts_msgs__msg__ManagementContainer *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__ManagementContainer), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__ManagementContainer));
  bool success = etsi_its_cpm_ts_msgs__msg__ManagementContainer__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__ManagementContainer__destroy(etsi_its_cpm_ts_msgs__msg__ManagementContainer * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__ManagementContainer__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence__init(etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__ManagementContainer * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__ManagementContainer *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__ManagementContainer), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__ManagementContainer__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__ManagementContainer__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence__fini(etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__ManagementContainer__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence *
etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence * array = (etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__ManagementContainer__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__ManagementContainer);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__ManagementContainer * data =
      (etsi_its_cpm_ts_msgs__msg__ManagementContainer *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__ManagementContainer__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__ManagementContainer__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__ManagementContainer__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
