// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/MapPosition.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/map_position__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `map_reference`
#include "etsi_its_cpm_ts_msgs/msg/detail/map_reference__functions.h"
// Member `lane_id`
// Member `connection_id`
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier1_b__functions.h"
// Member `longitudinal_lane_position`
#include "etsi_its_cpm_ts_msgs/msg/detail/longitudinal_lane_position__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__MapPosition__init(etsi_its_cpm_ts_msgs__msg__MapPosition * msg)
{
  if (!msg) {
    return false;
  }
  // map_reference
  if (!etsi_its_cpm_ts_msgs__msg__MapReference__init(&msg->map_reference)) {
    etsi_its_cpm_ts_msgs__msg__MapPosition__fini(msg);
    return false;
  }
  // map_reference_is_present
  // lane_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__init(&msg->lane_id)) {
    etsi_its_cpm_ts_msgs__msg__MapPosition__fini(msg);
    return false;
  }
  // lane_id_is_present
  // connection_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__init(&msg->connection_id)) {
    etsi_its_cpm_ts_msgs__msg__MapPosition__fini(msg);
    return false;
  }
  // connection_id_is_present
  // longitudinal_lane_position
  if (!etsi_its_cpm_ts_msgs__msg__LongitudinalLanePosition__init(&msg->longitudinal_lane_position)) {
    etsi_its_cpm_ts_msgs__msg__MapPosition__fini(msg);
    return false;
  }
  // longitudinal_lane_position_is_present
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__MapPosition__fini(etsi_its_cpm_ts_msgs__msg__MapPosition * msg)
{
  if (!msg) {
    return;
  }
  // map_reference
  etsi_its_cpm_ts_msgs__msg__MapReference__fini(&msg->map_reference);
  // map_reference_is_present
  // lane_id
  etsi_its_cpm_ts_msgs__msg__Identifier1B__fini(&msg->lane_id);
  // lane_id_is_present
  // connection_id
  etsi_its_cpm_ts_msgs__msg__Identifier1B__fini(&msg->connection_id);
  // connection_id_is_present
  // longitudinal_lane_position
  etsi_its_cpm_ts_msgs__msg__LongitudinalLanePosition__fini(&msg->longitudinal_lane_position);
  // longitudinal_lane_position_is_present
}

bool
etsi_its_cpm_ts_msgs__msg__MapPosition__are_equal(const etsi_its_cpm_ts_msgs__msg__MapPosition * lhs, const etsi_its_cpm_ts_msgs__msg__MapPosition * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // map_reference
  if (!etsi_its_cpm_ts_msgs__msg__MapReference__are_equal(
      &(lhs->map_reference), &(rhs->map_reference)))
  {
    return false;
  }
  // map_reference_is_present
  if (lhs->map_reference_is_present != rhs->map_reference_is_present) {
    return false;
  }
  // lane_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__are_equal(
      &(lhs->lane_id), &(rhs->lane_id)))
  {
    return false;
  }
  // lane_id_is_present
  if (lhs->lane_id_is_present != rhs->lane_id_is_present) {
    return false;
  }
  // connection_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__are_equal(
      &(lhs->connection_id), &(rhs->connection_id)))
  {
    return false;
  }
  // connection_id_is_present
  if (lhs->connection_id_is_present != rhs->connection_id_is_present) {
    return false;
  }
  // longitudinal_lane_position
  if (!etsi_its_cpm_ts_msgs__msg__LongitudinalLanePosition__are_equal(
      &(lhs->longitudinal_lane_position), &(rhs->longitudinal_lane_position)))
  {
    return false;
  }
  // longitudinal_lane_position_is_present
  if (lhs->longitudinal_lane_position_is_present != rhs->longitudinal_lane_position_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__MapPosition__copy(
  const etsi_its_cpm_ts_msgs__msg__MapPosition * input,
  etsi_its_cpm_ts_msgs__msg__MapPosition * output)
{
  if (!input || !output) {
    return false;
  }
  // map_reference
  if (!etsi_its_cpm_ts_msgs__msg__MapReference__copy(
      &(input->map_reference), &(output->map_reference)))
  {
    return false;
  }
  // map_reference_is_present
  output->map_reference_is_present = input->map_reference_is_present;
  // lane_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__copy(
      &(input->lane_id), &(output->lane_id)))
  {
    return false;
  }
  // lane_id_is_present
  output->lane_id_is_present = input->lane_id_is_present;
  // connection_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__copy(
      &(input->connection_id), &(output->connection_id)))
  {
    return false;
  }
  // connection_id_is_present
  output->connection_id_is_present = input->connection_id_is_present;
  // longitudinal_lane_position
  if (!etsi_its_cpm_ts_msgs__msg__LongitudinalLanePosition__copy(
      &(input->longitudinal_lane_position), &(output->longitudinal_lane_position)))
  {
    return false;
  }
  // longitudinal_lane_position_is_present
  output->longitudinal_lane_position_is_present = input->longitudinal_lane_position_is_present;
  return true;
}

etsi_its_cpm_ts_msgs__msg__MapPosition *
etsi_its_cpm_ts_msgs__msg__MapPosition__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__MapPosition * msg = (etsi_its_cpm_ts_msgs__msg__MapPosition *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__MapPosition), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__MapPosition));
  bool success = etsi_its_cpm_ts_msgs__msg__MapPosition__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__MapPosition__destroy(etsi_its_cpm_ts_msgs__msg__MapPosition * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__MapPosition__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence__init(etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__MapPosition * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__MapPosition *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__MapPosition), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__MapPosition__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__MapPosition__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence__fini(etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__MapPosition__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence *
etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence * array = (etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__MapPosition__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__MapPosition);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__MapPosition * data =
      (etsi_its_cpm_ts_msgs__msg__MapPosition *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__MapPosition__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__MapPosition__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__MapPosition__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
