// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/MatrixIncludedComponents.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MATRIX_INCLUDED_COMPONENTS__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MATRIX_INCLUDED_COMPONENTS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SIZE_BITS'.
enum
{
  etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents__SIZE_BITS = 13
};

/// Constant 'BIT_INDEX_X_POSITION'.
enum
{
  etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents__BIT_INDEX_X_POSITION = 0
};

/// Constant 'BIT_INDEX_Y_POSITION'.
enum
{
  etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents__BIT_INDEX_Y_POSITION = 1
};

/// Constant 'BIT_INDEX_Z_POSITION'.
enum
{
  etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents__BIT_INDEX_Z_POSITION = 2
};

/// Constant 'BIT_INDEX_X_VELOCITY_OR_VELOCITY_MAGNITUDE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents__BIT_INDEX_X_VELOCITY_OR_VELOCITY_MAGNITUDE = 3
};

/// Constant 'BIT_INDEX_Y_VELOCITY_OR_VELOCITY_DIRECTION'.
enum
{
  etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents__BIT_INDEX_Y_VELOCITY_OR_VELOCITY_DIRECTION = 4
};

/// Constant 'BIT_INDEX_Z_SPEED'.
enum
{
  etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents__BIT_INDEX_Z_SPEED = 5
};

/// Constant 'BIT_INDEX_X_ACCEL_OR_ACCEL_MAGNITUDE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents__BIT_INDEX_X_ACCEL_OR_ACCEL_MAGNITUDE = 6
};

/// Constant 'BIT_INDEX_Y_ACCEL_OR_ACCEL_DIRECTION'.
enum
{
  etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents__BIT_INDEX_Y_ACCEL_OR_ACCEL_DIRECTION = 7
};

/// Constant 'BIT_INDEX_Z_ACCELERATION'.
enum
{
  etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents__BIT_INDEX_Z_ACCELERATION = 8
};

/// Constant 'BIT_INDEX_Z_ANGLE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents__BIT_INDEX_Z_ANGLE = 9
};

/// Constant 'BIT_INDEX_Y_ANGLE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents__BIT_INDEX_Y_ANGLE = 10
};

/// Constant 'BIT_INDEX_X_ANGLE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents__BIT_INDEX_X_ANGLE = 11
};

/// Constant 'BIT_INDEX_Z_ANGULAR_VELOCITY'.
enum
{
  etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents__BIT_INDEX_Z_ANGULAR_VELOCITY = 12
};

// Include directives for member types
// Member 'value'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/MatrixIncludedComponents in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the components of an @ref PerceivedObject that are included in the @ref LowerTriangularPositiveSemidefiniteMatrix.
  ///  *
  ///  * The corresponding bit shall be set to 1 if the component is included:
  ///  * - 0 - `xCoordinate`                   - when the component xCoordinate of the component @ref CartesianPosition3dWithConfidence is included,
  ///  * - 1 - `yCoordinate`                   - when the component yCoordinate of the component @ref CartesianPosition3dWithConfidence is included,
  ///  * - 2 - `zCoordinate`                   - when the component zCoordinate of the component @ref CartesianPosition3dWithConfidence is included,
  ///  * - 3 - `xVelocityOrVelocityMagnitude`  - when the component xVelocity of the component @ref VelocityCartesian or the component VelocityMagnitude of the component @ref VelocityPolarWithZ is included,
  ///  * - 4 - `yVelocityOrVelocityDirection`  - when the component yVelocity of the component @ref VelocityCartesian or the component VelocityDirection of the component @ref VelocityPolarWithZ is included,
  ///  * - 5 - `zVelocity`                     - when the component zVelocity of the component @ref VelocityCartesian or of the component @ref VelocityPolarWithZ is included,
  ///  * - 6 - `xAccelOrAccelMagnitude`        - when the component xAcceleration of the component @ref AccelerationCartesian or the component AccelerationMagnitude of the component @ref AccelerationPolarWithZ is included,
  ///  * - 7 - `yAccelOrAccelDirection`        - when the component yAcceleration of the component @ref AccelerationCartesian or the component AccelerationDirection of the component @ref AccelerationPolarWithZ is included,
  ///  * - 8 - `zAcceleration`                 - when the component zAcceleration of the component @ref AccelerationCartesian or of the component @ref AccelerationPolarWithZ is included,
  ///  * - 9 - `zAngle`                        - when the component zAngle is included,
  ///  * - 10 - `yAngle`                       - when the component yAngle is included,
  ///  * - 11 - `xAngle`                       - when the component xAngle is included,
  ///  * - 12 - `zAngularVelocity`             - when the component zAngularVelocity is included.
  ///  *
  ///  * Otherwise, it shall be set to 0.
  ///  *
  ///  * @category: Sensing information
  ///  * @revision: Created in V2.1.1
  ///  */
  /// MatrixIncludedComponents::= BIT STRING{
  ///     xPosition                    (0),
  ///     yPosition                    (1),
  ///     zPosition                    (2),
  ///     xVelocityOrVelocityMagnitude (3),
  ///     yVelocityOrVelocityDirection (4),
  ///     zSpeed                       (5),
  ///     xAccelOrAccelMagnitude       (6),
  ///     yAccelOrAccelDirection       (7),
  ///     zAcceleration                (8),
  ///     zAngle                       (9),
  ///     yAngle                      (10),
  ///     xAngle                      (11),
  ///     zAngularVelocity              (12)
  /// } (SIZE(13,...))
  /// ------------------------------------------------------------------------------
  rosidl_runtime_c__uint8__Sequence value;
  uint8_t bits_unused;
} etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents.
typedef struct etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents__Sequence
{
  etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MATRIX_INCLUDED_COMPONENTS__STRUCT_H_
