// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/MessageRateHz.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MESSAGE_RATE_HZ__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MESSAGE_RATE_HZ__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__MessageRateHz __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__MessageRateHz __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MessageRateHz_
{
  using Type = MessageRateHz_<ContainerAllocator>;

  explicit MessageRateHz_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->mantissa = 0;
      this->exponent = 0;
    }
  }

  explicit MessageRateHz_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->mantissa = 0;
      this->exponent = 0;
    }
  }

  // field types and members
  using _mantissa_type =
    uint8_t;
  _mantissa_type mantissa;
  using _exponent_type =
    int8_t;
  _exponent_type exponent;

  // setters for named parameter idiom
  Type & set__mantissa(
    const uint8_t & _arg)
  {
    this->mantissa = _arg;
    return *this;
  }
  Type & set__exponent(
    const int8_t & _arg)
  {
    this->exponent = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t MANTISSA_MIN =
    1u;
  static constexpr uint8_t MANTISSA_MAX =
    100u;
  static constexpr int8_t EXPONENT_MIN =
    -5;
  static constexpr int8_t EXPONENT_MAX =
    2;

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::MessageRateHz_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::MessageRateHz_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MessageRateHz_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MessageRateHz_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::MessageRateHz_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::MessageRateHz_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::MessageRateHz_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::MessageRateHz_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::MessageRateHz_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::MessageRateHz_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__MessageRateHz
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MessageRateHz_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__MessageRateHz
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MessageRateHz_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MessageRateHz_ & other) const
  {
    if (this->mantissa != other.mantissa) {
      return false;
    }
    if (this->exponent != other.exponent) {
      return false;
    }
    return true;
  }
  bool operator!=(const MessageRateHz_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MessageRateHz_

// alias to use template instance with default allocator
using MessageRateHz =
  etsi_its_cpm_ts_msgs::msg::MessageRateHz_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MessageRateHz_<ContainerAllocator>::MANTISSA_MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MessageRateHz_<ContainerAllocator>::MANTISSA_MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t MessageRateHz_<ContainerAllocator>::EXPONENT_MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t MessageRateHz_<ContainerAllocator>::EXPONENT_MAX;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MESSAGE_RATE_HZ__STRUCT_HPP_
