// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/MessageSegmentationInfo.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MESSAGE_SEGMENTATION_INFO__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MESSAGE_SEGMENTATION_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'total_msg_no'
#include "etsi_its_cpm_ts_msgs/msg/detail/cardinal_number3b__struct.hpp"
// Member 'this_msg_no'
#include "etsi_its_cpm_ts_msgs/msg/detail/ordinal_number3b__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__MessageSegmentationInfo __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__MessageSegmentationInfo __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MessageSegmentationInfo_
{
  using Type = MessageSegmentationInfo_<ContainerAllocator>;

  explicit MessageSegmentationInfo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : total_msg_no(_init),
    this_msg_no(_init)
  {
    (void)_init;
  }

  explicit MessageSegmentationInfo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : total_msg_no(_alloc, _init),
    this_msg_no(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _total_msg_no_type =
    etsi_its_cpm_ts_msgs::msg::CardinalNumber3b_<ContainerAllocator>;
  _total_msg_no_type total_msg_no;
  using _this_msg_no_type =
    etsi_its_cpm_ts_msgs::msg::OrdinalNumber3b_<ContainerAllocator>;
  _this_msg_no_type this_msg_no;

  // setters for named parameter idiom
  Type & set__total_msg_no(
    const etsi_its_cpm_ts_msgs::msg::CardinalNumber3b_<ContainerAllocator> & _arg)
  {
    this->total_msg_no = _arg;
    return *this;
  }
  Type & set__this_msg_no(
    const etsi_its_cpm_ts_msgs::msg::OrdinalNumber3b_<ContainerAllocator> & _arg)
  {
    this->this_msg_no = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::MessageSegmentationInfo_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::MessageSegmentationInfo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MessageSegmentationInfo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MessageSegmentationInfo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::MessageSegmentationInfo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::MessageSegmentationInfo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::MessageSegmentationInfo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::MessageSegmentationInfo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::MessageSegmentationInfo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::MessageSegmentationInfo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__MessageSegmentationInfo
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MessageSegmentationInfo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__MessageSegmentationInfo
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::MessageSegmentationInfo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MessageSegmentationInfo_ & other) const
  {
    if (this->total_msg_no != other.total_msg_no) {
      return false;
    }
    if (this->this_msg_no != other.this_msg_no) {
      return false;
    }
    return true;
  }
  bool operator!=(const MessageSegmentationInfo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MessageSegmentationInfo_

// alias to use template instance with default allocator
using MessageSegmentationInfo =
  etsi_its_cpm_ts_msgs::msg::MessageSegmentationInfo_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MESSAGE_SEGMENTATION_INFO__STRUCT_HPP_
