// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/ObjectClassWithConfidence.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/object_class_with_confidence__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `object_class`
#include "etsi_its_cpm_ts_msgs/msg/detail/object_class__functions.h"
// Member `confidence`
#include "etsi_its_cpm_ts_msgs/msg/detail/confidence_level__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__init(etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence * msg)
{
  if (!msg) {
    return false;
  }
  // object_class
  if (!etsi_its_cpm_ts_msgs__msg__ObjectClass__init(&msg->object_class)) {
    etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__fini(msg);
    return false;
  }
  // confidence
  if (!etsi_its_cpm_ts_msgs__msg__ConfidenceLevel__init(&msg->confidence)) {
    etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__fini(etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence * msg)
{
  if (!msg) {
    return;
  }
  // object_class
  etsi_its_cpm_ts_msgs__msg__ObjectClass__fini(&msg->object_class);
  // confidence
  etsi_its_cpm_ts_msgs__msg__ConfidenceLevel__fini(&msg->confidence);
}

bool
etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__are_equal(const etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence * lhs, const etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // object_class
  if (!etsi_its_cpm_ts_msgs__msg__ObjectClass__are_equal(
      &(lhs->object_class), &(rhs->object_class)))
  {
    return false;
  }
  // confidence
  if (!etsi_its_cpm_ts_msgs__msg__ConfidenceLevel__are_equal(
      &(lhs->confidence), &(rhs->confidence)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__copy(
  const etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence * input,
  etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence * output)
{
  if (!input || !output) {
    return false;
  }
  // object_class
  if (!etsi_its_cpm_ts_msgs__msg__ObjectClass__copy(
      &(input->object_class), &(output->object_class)))
  {
    return false;
  }
  // confidence
  if (!etsi_its_cpm_ts_msgs__msg__ConfidenceLevel__copy(
      &(input->confidence), &(output->confidence)))
  {
    return false;
  }
  return true;
}

etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence *
etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence * msg = (etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence));
  bool success = etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__destroy(etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence__init(etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence__fini(etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence *
etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence * array = (etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence * data =
      (etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__ObjectClassWithConfidence__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
