// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/OriginatingVehicleContainer.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/originating_vehicle_container__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `orientation_angle`
#include "etsi_its_cpm_ts_msgs/msg/detail/wgs84_angle__functions.h"
// Member `pitch_angle`
// Member `roll_angle`
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__functions.h"
// Member `trailer_data_set`
#include "etsi_its_cpm_ts_msgs/msg/detail/trailer_data_set__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__init(etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer * msg)
{
  if (!msg) {
    return false;
  }
  // orientation_angle
  if (!etsi_its_cpm_ts_msgs__msg__Wgs84Angle__init(&msg->orientation_angle)) {
    etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__fini(msg);
    return false;
  }
  // pitch_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__init(&msg->pitch_angle)) {
    etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__fini(msg);
    return false;
  }
  // pitch_angle_is_present
  // roll_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__init(&msg->roll_angle)) {
    etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__fini(msg);
    return false;
  }
  // roll_angle_is_present
  // trailer_data_set
  if (!etsi_its_cpm_ts_msgs__msg__TrailerDataSet__init(&msg->trailer_data_set)) {
    etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__fini(msg);
    return false;
  }
  // trailer_data_set_is_present
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__fini(etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer * msg)
{
  if (!msg) {
    return;
  }
  // orientation_angle
  etsi_its_cpm_ts_msgs__msg__Wgs84Angle__fini(&msg->orientation_angle);
  // pitch_angle
  etsi_its_cpm_ts_msgs__msg__CartesianAngle__fini(&msg->pitch_angle);
  // pitch_angle_is_present
  // roll_angle
  etsi_its_cpm_ts_msgs__msg__CartesianAngle__fini(&msg->roll_angle);
  // roll_angle_is_present
  // trailer_data_set
  etsi_its_cpm_ts_msgs__msg__TrailerDataSet__fini(&msg->trailer_data_set);
  // trailer_data_set_is_present
}

bool
etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__are_equal(const etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer * lhs, const etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // orientation_angle
  if (!etsi_its_cpm_ts_msgs__msg__Wgs84Angle__are_equal(
      &(lhs->orientation_angle), &(rhs->orientation_angle)))
  {
    return false;
  }
  // pitch_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__are_equal(
      &(lhs->pitch_angle), &(rhs->pitch_angle)))
  {
    return false;
  }
  // pitch_angle_is_present
  if (lhs->pitch_angle_is_present != rhs->pitch_angle_is_present) {
    return false;
  }
  // roll_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__are_equal(
      &(lhs->roll_angle), &(rhs->roll_angle)))
  {
    return false;
  }
  // roll_angle_is_present
  if (lhs->roll_angle_is_present != rhs->roll_angle_is_present) {
    return false;
  }
  // trailer_data_set
  if (!etsi_its_cpm_ts_msgs__msg__TrailerDataSet__are_equal(
      &(lhs->trailer_data_set), &(rhs->trailer_data_set)))
  {
    return false;
  }
  // trailer_data_set_is_present
  if (lhs->trailer_data_set_is_present != rhs->trailer_data_set_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__copy(
  const etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer * input,
  etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer * output)
{
  if (!input || !output) {
    return false;
  }
  // orientation_angle
  if (!etsi_its_cpm_ts_msgs__msg__Wgs84Angle__copy(
      &(input->orientation_angle), &(output->orientation_angle)))
  {
    return false;
  }
  // pitch_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__copy(
      &(input->pitch_angle), &(output->pitch_angle)))
  {
    return false;
  }
  // pitch_angle_is_present
  output->pitch_angle_is_present = input->pitch_angle_is_present;
  // roll_angle
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngle__copy(
      &(input->roll_angle), &(output->roll_angle)))
  {
    return false;
  }
  // roll_angle_is_present
  output->roll_angle_is_present = input->roll_angle_is_present;
  // trailer_data_set
  if (!etsi_its_cpm_ts_msgs__msg__TrailerDataSet__copy(
      &(input->trailer_data_set), &(output->trailer_data_set)))
  {
    return false;
  }
  // trailer_data_set_is_present
  output->trailer_data_set_is_present = input->trailer_data_set_is_present;
  return true;
}

etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer *
etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer * msg = (etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer));
  bool success = etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__destroy(etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence__init(etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence__fini(etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence *
etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence * array = (etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer * data =
      (etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
