// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/PerceivedObject.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEIVED_OBJECT__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEIVED_OBJECT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'object_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier2_b__struct.hpp"
// Member 'measurement_delta_time'
// Member 'object_age'
#include "etsi_its_cpm_ts_msgs/msg/detail/delta_time_milli_second_signed__struct.hpp"
// Member 'position'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_position3d_with_confidence__struct.hpp"
// Member 'velocity'
#include "etsi_its_cpm_ts_msgs/msg/detail/velocity3d_with_confidence__struct.hpp"
// Member 'acceleration'
#include "etsi_its_cpm_ts_msgs/msg/detail/acceleration3d_with_confidence__struct.hpp"
// Member 'angles'
#include "etsi_its_cpm_ts_msgs/msg/detail/euler_angles_with_confidence__struct.hpp"
// Member 'z_angular_velocity'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angular_velocity_component__struct.hpp"
// Member 'lower_triangular_correlation_matrices'
#include "etsi_its_cpm_ts_msgs/msg/detail/lower_triangular_positive_semidefinite_matrices__struct.hpp"
// Member 'object_dimension_z'
// Member 'object_dimension_y'
// Member 'object_dimension_x'
#include "etsi_its_cpm_ts_msgs/msg/detail/object_dimension__struct.hpp"
// Member 'object_perception_quality'
#include "etsi_its_cpm_ts_msgs/msg/detail/object_perception_quality__struct.hpp"
// Member 'sensor_id_list'
#include "etsi_its_cpm_ts_msgs/msg/detail/sequence_of_identifier1_b__struct.hpp"
// Member 'classification'
#include "etsi_its_cpm_ts_msgs/msg/detail/object_class_description__struct.hpp"
// Member 'map_position'
#include "etsi_its_cpm_ts_msgs/msg/detail/map_position__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__PerceivedObject __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__PerceivedObject __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PerceivedObject_
{
  using Type = PerceivedObject_<ContainerAllocator>;

  explicit PerceivedObject_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : object_id(_init),
    measurement_delta_time(_init),
    position(_init),
    velocity(_init),
    acceleration(_init),
    angles(_init),
    z_angular_velocity(_init),
    lower_triangular_correlation_matrices(_init),
    object_dimension_z(_init),
    object_dimension_y(_init),
    object_dimension_x(_init),
    object_age(_init),
    object_perception_quality(_init),
    sensor_id_list(_init),
    classification(_init),
    map_position(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->object_id_is_present = false;
      this->velocity_is_present = false;
      this->acceleration_is_present = false;
      this->angles_is_present = false;
      this->z_angular_velocity_is_present = false;
      this->lower_triangular_correlation_matrices_is_present = false;
      this->object_dimension_z_is_present = false;
      this->object_dimension_y_is_present = false;
      this->object_dimension_x_is_present = false;
      this->object_age_is_present = false;
      this->object_perception_quality_is_present = false;
      this->sensor_id_list_is_present = false;
      this->classification_is_present = false;
      this->map_position_is_present = false;
    }
  }

  explicit PerceivedObject_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : object_id(_alloc, _init),
    measurement_delta_time(_alloc, _init),
    position(_alloc, _init),
    velocity(_alloc, _init),
    acceleration(_alloc, _init),
    angles(_alloc, _init),
    z_angular_velocity(_alloc, _init),
    lower_triangular_correlation_matrices(_alloc, _init),
    object_dimension_z(_alloc, _init),
    object_dimension_y(_alloc, _init),
    object_dimension_x(_alloc, _init),
    object_age(_alloc, _init),
    object_perception_quality(_alloc, _init),
    sensor_id_list(_alloc, _init),
    classification(_alloc, _init),
    map_position(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->object_id_is_present = false;
      this->velocity_is_present = false;
      this->acceleration_is_present = false;
      this->angles_is_present = false;
      this->z_angular_velocity_is_present = false;
      this->lower_triangular_correlation_matrices_is_present = false;
      this->object_dimension_z_is_present = false;
      this->object_dimension_y_is_present = false;
      this->object_dimension_x_is_present = false;
      this->object_age_is_present = false;
      this->object_perception_quality_is_present = false;
      this->sensor_id_list_is_present = false;
      this->classification_is_present = false;
      this->map_position_is_present = false;
    }
  }

  // field types and members
  using _object_id_type =
    etsi_its_cpm_ts_msgs::msg::Identifier2B_<ContainerAllocator>;
  _object_id_type object_id;
  using _object_id_is_present_type =
    bool;
  _object_id_is_present_type object_id_is_present;
  using _measurement_delta_time_type =
    etsi_its_cpm_ts_msgs::msg::DeltaTimeMilliSecondSigned_<ContainerAllocator>;
  _measurement_delta_time_type measurement_delta_time;
  using _position_type =
    etsi_its_cpm_ts_msgs::msg::CartesianPosition3dWithConfidence_<ContainerAllocator>;
  _position_type position;
  using _velocity_type =
    etsi_its_cpm_ts_msgs::msg::Velocity3dWithConfidence_<ContainerAllocator>;
  _velocity_type velocity;
  using _velocity_is_present_type =
    bool;
  _velocity_is_present_type velocity_is_present;
  using _acceleration_type =
    etsi_its_cpm_ts_msgs::msg::Acceleration3dWithConfidence_<ContainerAllocator>;
  _acceleration_type acceleration;
  using _acceleration_is_present_type =
    bool;
  _acceleration_is_present_type acceleration_is_present;
  using _angles_type =
    etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence_<ContainerAllocator>;
  _angles_type angles;
  using _angles_is_present_type =
    bool;
  _angles_is_present_type angles_is_present;
  using _z_angular_velocity_type =
    etsi_its_cpm_ts_msgs::msg::CartesianAngularVelocityComponent_<ContainerAllocator>;
  _z_angular_velocity_type z_angular_velocity;
  using _z_angular_velocity_is_present_type =
    bool;
  _z_angular_velocity_is_present_type z_angular_velocity_is_present;
  using _lower_triangular_correlation_matrices_type =
    etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrices_<ContainerAllocator>;
  _lower_triangular_correlation_matrices_type lower_triangular_correlation_matrices;
  using _lower_triangular_correlation_matrices_is_present_type =
    bool;
  _lower_triangular_correlation_matrices_is_present_type lower_triangular_correlation_matrices_is_present;
  using _object_dimension_z_type =
    etsi_its_cpm_ts_msgs::msg::ObjectDimension_<ContainerAllocator>;
  _object_dimension_z_type object_dimension_z;
  using _object_dimension_z_is_present_type =
    bool;
  _object_dimension_z_is_present_type object_dimension_z_is_present;
  using _object_dimension_y_type =
    etsi_its_cpm_ts_msgs::msg::ObjectDimension_<ContainerAllocator>;
  _object_dimension_y_type object_dimension_y;
  using _object_dimension_y_is_present_type =
    bool;
  _object_dimension_y_is_present_type object_dimension_y_is_present;
  using _object_dimension_x_type =
    etsi_its_cpm_ts_msgs::msg::ObjectDimension_<ContainerAllocator>;
  _object_dimension_x_type object_dimension_x;
  using _object_dimension_x_is_present_type =
    bool;
  _object_dimension_x_is_present_type object_dimension_x_is_present;
  using _object_age_type =
    etsi_its_cpm_ts_msgs::msg::DeltaTimeMilliSecondSigned_<ContainerAllocator>;
  _object_age_type object_age;
  using _object_age_is_present_type =
    bool;
  _object_age_is_present_type object_age_is_present;
  using _object_perception_quality_type =
    etsi_its_cpm_ts_msgs::msg::ObjectPerceptionQuality_<ContainerAllocator>;
  _object_perception_quality_type object_perception_quality;
  using _object_perception_quality_is_present_type =
    bool;
  _object_perception_quality_is_present_type object_perception_quality_is_present;
  using _sensor_id_list_type =
    etsi_its_cpm_ts_msgs::msg::SequenceOfIdentifier1B_<ContainerAllocator>;
  _sensor_id_list_type sensor_id_list;
  using _sensor_id_list_is_present_type =
    bool;
  _sensor_id_list_is_present_type sensor_id_list_is_present;
  using _classification_type =
    etsi_its_cpm_ts_msgs::msg::ObjectClassDescription_<ContainerAllocator>;
  _classification_type classification;
  using _classification_is_present_type =
    bool;
  _classification_is_present_type classification_is_present;
  using _map_position_type =
    etsi_its_cpm_ts_msgs::msg::MapPosition_<ContainerAllocator>;
  _map_position_type map_position;
  using _map_position_is_present_type =
    bool;
  _map_position_is_present_type map_position_is_present;

  // setters for named parameter idiom
  Type & set__object_id(
    const etsi_its_cpm_ts_msgs::msg::Identifier2B_<ContainerAllocator> & _arg)
  {
    this->object_id = _arg;
    return *this;
  }
  Type & set__object_id_is_present(
    const bool & _arg)
  {
    this->object_id_is_present = _arg;
    return *this;
  }
  Type & set__measurement_delta_time(
    const etsi_its_cpm_ts_msgs::msg::DeltaTimeMilliSecondSigned_<ContainerAllocator> & _arg)
  {
    this->measurement_delta_time = _arg;
    return *this;
  }
  Type & set__position(
    const etsi_its_cpm_ts_msgs::msg::CartesianPosition3dWithConfidence_<ContainerAllocator> & _arg)
  {
    this->position = _arg;
    return *this;
  }
  Type & set__velocity(
    const etsi_its_cpm_ts_msgs::msg::Velocity3dWithConfidence_<ContainerAllocator> & _arg)
  {
    this->velocity = _arg;
    return *this;
  }
  Type & set__velocity_is_present(
    const bool & _arg)
  {
    this->velocity_is_present = _arg;
    return *this;
  }
  Type & set__acceleration(
    const etsi_its_cpm_ts_msgs::msg::Acceleration3dWithConfidence_<ContainerAllocator> & _arg)
  {
    this->acceleration = _arg;
    return *this;
  }
  Type & set__acceleration_is_present(
    const bool & _arg)
  {
    this->acceleration_is_present = _arg;
    return *this;
  }
  Type & set__angles(
    const etsi_its_cpm_ts_msgs::msg::EulerAnglesWithConfidence_<ContainerAllocator> & _arg)
  {
    this->angles = _arg;
    return *this;
  }
  Type & set__angles_is_present(
    const bool & _arg)
  {
    this->angles_is_present = _arg;
    return *this;
  }
  Type & set__z_angular_velocity(
    const etsi_its_cpm_ts_msgs::msg::CartesianAngularVelocityComponent_<ContainerAllocator> & _arg)
  {
    this->z_angular_velocity = _arg;
    return *this;
  }
  Type & set__z_angular_velocity_is_present(
    const bool & _arg)
  {
    this->z_angular_velocity_is_present = _arg;
    return *this;
  }
  Type & set__lower_triangular_correlation_matrices(
    const etsi_its_cpm_ts_msgs::msg::LowerTriangularPositiveSemidefiniteMatrices_<ContainerAllocator> & _arg)
  {
    this->lower_triangular_correlation_matrices = _arg;
    return *this;
  }
  Type & set__lower_triangular_correlation_matrices_is_present(
    const bool & _arg)
  {
    this->lower_triangular_correlation_matrices_is_present = _arg;
    return *this;
  }
  Type & set__object_dimension_z(
    const etsi_its_cpm_ts_msgs::msg::ObjectDimension_<ContainerAllocator> & _arg)
  {
    this->object_dimension_z = _arg;
    return *this;
  }
  Type & set__object_dimension_z_is_present(
    const bool & _arg)
  {
    this->object_dimension_z_is_present = _arg;
    return *this;
  }
  Type & set__object_dimension_y(
    const etsi_its_cpm_ts_msgs::msg::ObjectDimension_<ContainerAllocator> & _arg)
  {
    this->object_dimension_y = _arg;
    return *this;
  }
  Type & set__object_dimension_y_is_present(
    const bool & _arg)
  {
    this->object_dimension_y_is_present = _arg;
    return *this;
  }
  Type & set__object_dimension_x(
    const etsi_its_cpm_ts_msgs::msg::ObjectDimension_<ContainerAllocator> & _arg)
  {
    this->object_dimension_x = _arg;
    return *this;
  }
  Type & set__object_dimension_x_is_present(
    const bool & _arg)
  {
    this->object_dimension_x_is_present = _arg;
    return *this;
  }
  Type & set__object_age(
    const etsi_its_cpm_ts_msgs::msg::DeltaTimeMilliSecondSigned_<ContainerAllocator> & _arg)
  {
    this->object_age = _arg;
    return *this;
  }
  Type & set__object_age_is_present(
    const bool & _arg)
  {
    this->object_age_is_present = _arg;
    return *this;
  }
  Type & set__object_perception_quality(
    const etsi_its_cpm_ts_msgs::msg::ObjectPerceptionQuality_<ContainerAllocator> & _arg)
  {
    this->object_perception_quality = _arg;
    return *this;
  }
  Type & set__object_perception_quality_is_present(
    const bool & _arg)
  {
    this->object_perception_quality_is_present = _arg;
    return *this;
  }
  Type & set__sensor_id_list(
    const etsi_its_cpm_ts_msgs::msg::SequenceOfIdentifier1B_<ContainerAllocator> & _arg)
  {
    this->sensor_id_list = _arg;
    return *this;
  }
  Type & set__sensor_id_list_is_present(
    const bool & _arg)
  {
    this->sensor_id_list_is_present = _arg;
    return *this;
  }
  Type & set__classification(
    const etsi_its_cpm_ts_msgs::msg::ObjectClassDescription_<ContainerAllocator> & _arg)
  {
    this->classification = _arg;
    return *this;
  }
  Type & set__classification_is_present(
    const bool & _arg)
  {
    this->classification_is_present = _arg;
    return *this;
  }
  Type & set__map_position(
    const etsi_its_cpm_ts_msgs::msg::MapPosition_<ContainerAllocator> & _arg)
  {
    this->map_position = _arg;
    return *this;
  }
  Type & set__map_position_is_present(
    const bool & _arg)
  {
    this->map_position_is_present = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint16_t OBJECT_AGE_MIN =
    0u;
  static constexpr uint16_t OBJECT_AGE_MAX =
    2047u;

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::PerceivedObject_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::PerceivedObject_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::PerceivedObject_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::PerceivedObject_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::PerceivedObject_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::PerceivedObject_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::PerceivedObject_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::PerceivedObject_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::PerceivedObject_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::PerceivedObject_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__PerceivedObject
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::PerceivedObject_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__PerceivedObject
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::PerceivedObject_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PerceivedObject_ & other) const
  {
    if (this->object_id != other.object_id) {
      return false;
    }
    if (this->object_id_is_present != other.object_id_is_present) {
      return false;
    }
    if (this->measurement_delta_time != other.measurement_delta_time) {
      return false;
    }
    if (this->position != other.position) {
      return false;
    }
    if (this->velocity != other.velocity) {
      return false;
    }
    if (this->velocity_is_present != other.velocity_is_present) {
      return false;
    }
    if (this->acceleration != other.acceleration) {
      return false;
    }
    if (this->acceleration_is_present != other.acceleration_is_present) {
      return false;
    }
    if (this->angles != other.angles) {
      return false;
    }
    if (this->angles_is_present != other.angles_is_present) {
      return false;
    }
    if (this->z_angular_velocity != other.z_angular_velocity) {
      return false;
    }
    if (this->z_angular_velocity_is_present != other.z_angular_velocity_is_present) {
      return false;
    }
    if (this->lower_triangular_correlation_matrices != other.lower_triangular_correlation_matrices) {
      return false;
    }
    if (this->lower_triangular_correlation_matrices_is_present != other.lower_triangular_correlation_matrices_is_present) {
      return false;
    }
    if (this->object_dimension_z != other.object_dimension_z) {
      return false;
    }
    if (this->object_dimension_z_is_present != other.object_dimension_z_is_present) {
      return false;
    }
    if (this->object_dimension_y != other.object_dimension_y) {
      return false;
    }
    if (this->object_dimension_y_is_present != other.object_dimension_y_is_present) {
      return false;
    }
    if (this->object_dimension_x != other.object_dimension_x) {
      return false;
    }
    if (this->object_dimension_x_is_present != other.object_dimension_x_is_present) {
      return false;
    }
    if (this->object_age != other.object_age) {
      return false;
    }
    if (this->object_age_is_present != other.object_age_is_present) {
      return false;
    }
    if (this->object_perception_quality != other.object_perception_quality) {
      return false;
    }
    if (this->object_perception_quality_is_present != other.object_perception_quality_is_present) {
      return false;
    }
    if (this->sensor_id_list != other.sensor_id_list) {
      return false;
    }
    if (this->sensor_id_list_is_present != other.sensor_id_list_is_present) {
      return false;
    }
    if (this->classification != other.classification) {
      return false;
    }
    if (this->classification_is_present != other.classification_is_present) {
      return false;
    }
    if (this->map_position != other.map_position) {
      return false;
    }
    if (this->map_position_is_present != other.map_position_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const PerceivedObject_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PerceivedObject_

// alias to use template instance with default allocator
using PerceivedObject =
  etsi_its_cpm_ts_msgs::msg::PerceivedObject_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t PerceivedObject_<ContainerAllocator>::OBJECT_AGE_MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t PerceivedObject_<ContainerAllocator>::OBJECT_AGE_MAX;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEIVED_OBJECT__STRUCT_HPP_
