// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/PerceivedObjectContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEIVED_OBJECT_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEIVED_OBJECT_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'number_of_perceived_objects'
#include "etsi_its_cpm_ts_msgs/msg/detail/cardinal_number1_b__struct.hpp"
// Member 'perceived_objects'
#include "etsi_its_cpm_ts_msgs/msg/detail/perceived_objects__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__PerceivedObjectContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__PerceivedObjectContainer __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PerceivedObjectContainer_
{
  using Type = PerceivedObjectContainer_<ContainerAllocator>;

  explicit PerceivedObjectContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : number_of_perceived_objects(_init),
    perceived_objects(_init)
  {
    (void)_init;
  }

  explicit PerceivedObjectContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : number_of_perceived_objects(_alloc, _init),
    perceived_objects(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _number_of_perceived_objects_type =
    etsi_its_cpm_ts_msgs::msg::CardinalNumber1B_<ContainerAllocator>;
  _number_of_perceived_objects_type number_of_perceived_objects;
  using _perceived_objects_type =
    etsi_its_cpm_ts_msgs::msg::PerceivedObjects_<ContainerAllocator>;
  _perceived_objects_type perceived_objects;

  // setters for named parameter idiom
  Type & set__number_of_perceived_objects(
    const etsi_its_cpm_ts_msgs::msg::CardinalNumber1B_<ContainerAllocator> & _arg)
  {
    this->number_of_perceived_objects = _arg;
    return *this;
  }
  Type & set__perceived_objects(
    const etsi_its_cpm_ts_msgs::msg::PerceivedObjects_<ContainerAllocator> & _arg)
  {
    this->perceived_objects = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__PerceivedObjectContainer
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__PerceivedObjectContainer
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PerceivedObjectContainer_ & other) const
  {
    if (this->number_of_perceived_objects != other.number_of_perceived_objects) {
      return false;
    }
    if (this->perceived_objects != other.perceived_objects) {
      return false;
    }
    return true;
  }
  bool operator!=(const PerceivedObjectContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PerceivedObjectContainer_

// alias to use template instance with default allocator
using PerceivedObjectContainer =
  etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEIVED_OBJECT_CONTAINER__STRUCT_HPP_
