// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/RadialShape.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/radial_shape__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `shape_reference_point`
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_position3d__functions.h"
// Member `range`
#include "etsi_its_cpm_ts_msgs/msg/detail/standard_length12b__functions.h"
// Member `stationary_horizontal_opening_angle_start`
// Member `stationary_horizontal_opening_angle_end`
#include "etsi_its_cpm_ts_msgs/msg/detail/wgs84_angle_value__functions.h"
// Member `vertical_opening_angle_start`
// Member `vertical_opening_angle_end`
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle_value__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__RadialShape__init(etsi_its_cpm_ts_msgs__msg__RadialShape * msg)
{
  if (!msg) {
    return false;
  }
  // shape_reference_point
  if (!etsi_its_cpm_ts_msgs__msg__CartesianPosition3d__init(&msg->shape_reference_point)) {
    etsi_its_cpm_ts_msgs__msg__RadialShape__fini(msg);
    return false;
  }
  // shape_reference_point_is_present
  // range
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength12b__init(&msg->range)) {
    etsi_its_cpm_ts_msgs__msg__RadialShape__fini(msg);
    return false;
  }
  // stationary_horizontal_opening_angle_start
  if (!etsi_its_cpm_ts_msgs__msg__Wgs84AngleValue__init(&msg->stationary_horizontal_opening_angle_start)) {
    etsi_its_cpm_ts_msgs__msg__RadialShape__fini(msg);
    return false;
  }
  // stationary_horizontal_opening_angle_end
  if (!etsi_its_cpm_ts_msgs__msg__Wgs84AngleValue__init(&msg->stationary_horizontal_opening_angle_end)) {
    etsi_its_cpm_ts_msgs__msg__RadialShape__fini(msg);
    return false;
  }
  // vertical_opening_angle_start
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__init(&msg->vertical_opening_angle_start)) {
    etsi_its_cpm_ts_msgs__msg__RadialShape__fini(msg);
    return false;
  }
  // vertical_opening_angle_start_is_present
  // vertical_opening_angle_end
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__init(&msg->vertical_opening_angle_end)) {
    etsi_its_cpm_ts_msgs__msg__RadialShape__fini(msg);
    return false;
  }
  // vertical_opening_angle_end_is_present
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__RadialShape__fini(etsi_its_cpm_ts_msgs__msg__RadialShape * msg)
{
  if (!msg) {
    return;
  }
  // shape_reference_point
  etsi_its_cpm_ts_msgs__msg__CartesianPosition3d__fini(&msg->shape_reference_point);
  // shape_reference_point_is_present
  // range
  etsi_its_cpm_ts_msgs__msg__StandardLength12b__fini(&msg->range);
  // stationary_horizontal_opening_angle_start
  etsi_its_cpm_ts_msgs__msg__Wgs84AngleValue__fini(&msg->stationary_horizontal_opening_angle_start);
  // stationary_horizontal_opening_angle_end
  etsi_its_cpm_ts_msgs__msg__Wgs84AngleValue__fini(&msg->stationary_horizontal_opening_angle_end);
  // vertical_opening_angle_start
  etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__fini(&msg->vertical_opening_angle_start);
  // vertical_opening_angle_start_is_present
  // vertical_opening_angle_end
  etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__fini(&msg->vertical_opening_angle_end);
  // vertical_opening_angle_end_is_present
}

bool
etsi_its_cpm_ts_msgs__msg__RadialShape__are_equal(const etsi_its_cpm_ts_msgs__msg__RadialShape * lhs, const etsi_its_cpm_ts_msgs__msg__RadialShape * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // shape_reference_point
  if (!etsi_its_cpm_ts_msgs__msg__CartesianPosition3d__are_equal(
      &(lhs->shape_reference_point), &(rhs->shape_reference_point)))
  {
    return false;
  }
  // shape_reference_point_is_present
  if (lhs->shape_reference_point_is_present != rhs->shape_reference_point_is_present) {
    return false;
  }
  // range
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength12b__are_equal(
      &(lhs->range), &(rhs->range)))
  {
    return false;
  }
  // stationary_horizontal_opening_angle_start
  if (!etsi_its_cpm_ts_msgs__msg__Wgs84AngleValue__are_equal(
      &(lhs->stationary_horizontal_opening_angle_start), &(rhs->stationary_horizontal_opening_angle_start)))
  {
    return false;
  }
  // stationary_horizontal_opening_angle_end
  if (!etsi_its_cpm_ts_msgs__msg__Wgs84AngleValue__are_equal(
      &(lhs->stationary_horizontal_opening_angle_end), &(rhs->stationary_horizontal_opening_angle_end)))
  {
    return false;
  }
  // vertical_opening_angle_start
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__are_equal(
      &(lhs->vertical_opening_angle_start), &(rhs->vertical_opening_angle_start)))
  {
    return false;
  }
  // vertical_opening_angle_start_is_present
  if (lhs->vertical_opening_angle_start_is_present != rhs->vertical_opening_angle_start_is_present) {
    return false;
  }
  // vertical_opening_angle_end
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__are_equal(
      &(lhs->vertical_opening_angle_end), &(rhs->vertical_opening_angle_end)))
  {
    return false;
  }
  // vertical_opening_angle_end_is_present
  if (lhs->vertical_opening_angle_end_is_present != rhs->vertical_opening_angle_end_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__RadialShape__copy(
  const etsi_its_cpm_ts_msgs__msg__RadialShape * input,
  etsi_its_cpm_ts_msgs__msg__RadialShape * output)
{
  if (!input || !output) {
    return false;
  }
  // shape_reference_point
  if (!etsi_its_cpm_ts_msgs__msg__CartesianPosition3d__copy(
      &(input->shape_reference_point), &(output->shape_reference_point)))
  {
    return false;
  }
  // shape_reference_point_is_present
  output->shape_reference_point_is_present = input->shape_reference_point_is_present;
  // range
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength12b__copy(
      &(input->range), &(output->range)))
  {
    return false;
  }
  // stationary_horizontal_opening_angle_start
  if (!etsi_its_cpm_ts_msgs__msg__Wgs84AngleValue__copy(
      &(input->stationary_horizontal_opening_angle_start), &(output->stationary_horizontal_opening_angle_start)))
  {
    return false;
  }
  // stationary_horizontal_opening_angle_end
  if (!etsi_its_cpm_ts_msgs__msg__Wgs84AngleValue__copy(
      &(input->stationary_horizontal_opening_angle_end), &(output->stationary_horizontal_opening_angle_end)))
  {
    return false;
  }
  // vertical_opening_angle_start
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__copy(
      &(input->vertical_opening_angle_start), &(output->vertical_opening_angle_start)))
  {
    return false;
  }
  // vertical_opening_angle_start_is_present
  output->vertical_opening_angle_start_is_present = input->vertical_opening_angle_start_is_present;
  // vertical_opening_angle_end
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__copy(
      &(input->vertical_opening_angle_end), &(output->vertical_opening_angle_end)))
  {
    return false;
  }
  // vertical_opening_angle_end_is_present
  output->vertical_opening_angle_end_is_present = input->vertical_opening_angle_end_is_present;
  return true;
}

etsi_its_cpm_ts_msgs__msg__RadialShape *
etsi_its_cpm_ts_msgs__msg__RadialShape__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__RadialShape * msg = (etsi_its_cpm_ts_msgs__msg__RadialShape *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__RadialShape), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__RadialShape));
  bool success = etsi_its_cpm_ts_msgs__msg__RadialShape__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__RadialShape__destroy(etsi_its_cpm_ts_msgs__msg__RadialShape * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__RadialShape__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence__init(etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__RadialShape * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__RadialShape *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__RadialShape), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__RadialShape__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__RadialShape__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence__fini(etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__RadialShape__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence *
etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence * array = (etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__RadialShape__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__RadialShape);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__RadialShape * data =
      (etsi_its_cpm_ts_msgs__msg__RadialShape *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__RadialShape__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__RadialShape__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__RadialShape__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
