// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/RadialShapeDetails.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/radial_shape_details__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `range`
#include "etsi_its_cpm_ts_msgs/msg/detail/standard_length12b__functions.h"
// Member `horizontal_opening_angle_start`
// Member `horizontal_opening_angle_end`
// Member `vertical_opening_angle_start`
// Member `vertical_opening_angle_end`
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle_value__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__init(etsi_its_cpm_ts_msgs__msg__RadialShapeDetails * msg)
{
  if (!msg) {
    return false;
  }
  // range
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength12b__init(&msg->range)) {
    etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__fini(msg);
    return false;
  }
  // horizontal_opening_angle_start
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__init(&msg->horizontal_opening_angle_start)) {
    etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__fini(msg);
    return false;
  }
  // horizontal_opening_angle_end
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__init(&msg->horizontal_opening_angle_end)) {
    etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__fini(msg);
    return false;
  }
  // vertical_opening_angle_start
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__init(&msg->vertical_opening_angle_start)) {
    etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__fini(msg);
    return false;
  }
  // vertical_opening_angle_start_is_present
  // vertical_opening_angle_end
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__init(&msg->vertical_opening_angle_end)) {
    etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__fini(msg);
    return false;
  }
  // vertical_opening_angle_end_is_present
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__fini(etsi_its_cpm_ts_msgs__msg__RadialShapeDetails * msg)
{
  if (!msg) {
    return;
  }
  // range
  etsi_its_cpm_ts_msgs__msg__StandardLength12b__fini(&msg->range);
  // horizontal_opening_angle_start
  etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__fini(&msg->horizontal_opening_angle_start);
  // horizontal_opening_angle_end
  etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__fini(&msg->horizontal_opening_angle_end);
  // vertical_opening_angle_start
  etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__fini(&msg->vertical_opening_angle_start);
  // vertical_opening_angle_start_is_present
  // vertical_opening_angle_end
  etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__fini(&msg->vertical_opening_angle_end);
  // vertical_opening_angle_end_is_present
}

bool
etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__are_equal(const etsi_its_cpm_ts_msgs__msg__RadialShapeDetails * lhs, const etsi_its_cpm_ts_msgs__msg__RadialShapeDetails * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // range
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength12b__are_equal(
      &(lhs->range), &(rhs->range)))
  {
    return false;
  }
  // horizontal_opening_angle_start
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__are_equal(
      &(lhs->horizontal_opening_angle_start), &(rhs->horizontal_opening_angle_start)))
  {
    return false;
  }
  // horizontal_opening_angle_end
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__are_equal(
      &(lhs->horizontal_opening_angle_end), &(rhs->horizontal_opening_angle_end)))
  {
    return false;
  }
  // vertical_opening_angle_start
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__are_equal(
      &(lhs->vertical_opening_angle_start), &(rhs->vertical_opening_angle_start)))
  {
    return false;
  }
  // vertical_opening_angle_start_is_present
  if (lhs->vertical_opening_angle_start_is_present != rhs->vertical_opening_angle_start_is_present) {
    return false;
  }
  // vertical_opening_angle_end
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__are_equal(
      &(lhs->vertical_opening_angle_end), &(rhs->vertical_opening_angle_end)))
  {
    return false;
  }
  // vertical_opening_angle_end_is_present
  if (lhs->vertical_opening_angle_end_is_present != rhs->vertical_opening_angle_end_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__copy(
  const etsi_its_cpm_ts_msgs__msg__RadialShapeDetails * input,
  etsi_its_cpm_ts_msgs__msg__RadialShapeDetails * output)
{
  if (!input || !output) {
    return false;
  }
  // range
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength12b__copy(
      &(input->range), &(output->range)))
  {
    return false;
  }
  // horizontal_opening_angle_start
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__copy(
      &(input->horizontal_opening_angle_start), &(output->horizontal_opening_angle_start)))
  {
    return false;
  }
  // horizontal_opening_angle_end
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__copy(
      &(input->horizontal_opening_angle_end), &(output->horizontal_opening_angle_end)))
  {
    return false;
  }
  // vertical_opening_angle_start
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__copy(
      &(input->vertical_opening_angle_start), &(output->vertical_opening_angle_start)))
  {
    return false;
  }
  // vertical_opening_angle_start_is_present
  output->vertical_opening_angle_start_is_present = input->vertical_opening_angle_start_is_present;
  // vertical_opening_angle_end
  if (!etsi_its_cpm_ts_msgs__msg__CartesianAngleValue__copy(
      &(input->vertical_opening_angle_end), &(output->vertical_opening_angle_end)))
  {
    return false;
  }
  // vertical_opening_angle_end_is_present
  output->vertical_opening_angle_end_is_present = input->vertical_opening_angle_end_is_present;
  return true;
}

etsi_its_cpm_ts_msgs__msg__RadialShapeDetails *
etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__RadialShapeDetails * msg = (etsi_its_cpm_ts_msgs__msg__RadialShapeDetails *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__RadialShapeDetails), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__RadialShapeDetails));
  bool success = etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__destroy(etsi_its_cpm_ts_msgs__msg__RadialShapeDetails * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence__init(etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__RadialShapeDetails * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__RadialShapeDetails *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__RadialShapeDetails), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence__fini(etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence *
etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence * array = (etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__RadialShapeDetails);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__RadialShapeDetails * data =
      (etsi_its_cpm_ts_msgs__msg__RadialShapeDetails *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__RadialShapeDetails__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
