// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/RectangularShape.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/rectangular_shape__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `center_point`
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_position3d__functions.h"
// Member `semi_length`
// Member `semi_breadth`
// Member `height`
#include "etsi_its_cpm_ts_msgs/msg/detail/standard_length12b__functions.h"
// Member `orientation`
#include "etsi_its_cpm_ts_msgs/msg/detail/wgs84_angle_value__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__RectangularShape__init(etsi_its_cpm_ts_msgs__msg__RectangularShape * msg)
{
  if (!msg) {
    return false;
  }
  // center_point
  if (!etsi_its_cpm_ts_msgs__msg__CartesianPosition3d__init(&msg->center_point)) {
    etsi_its_cpm_ts_msgs__msg__RectangularShape__fini(msg);
    return false;
  }
  // center_point_is_present
  // semi_length
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength12b__init(&msg->semi_length)) {
    etsi_its_cpm_ts_msgs__msg__RectangularShape__fini(msg);
    return false;
  }
  // semi_breadth
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength12b__init(&msg->semi_breadth)) {
    etsi_its_cpm_ts_msgs__msg__RectangularShape__fini(msg);
    return false;
  }
  // orientation
  if (!etsi_its_cpm_ts_msgs__msg__Wgs84AngleValue__init(&msg->orientation)) {
    etsi_its_cpm_ts_msgs__msg__RectangularShape__fini(msg);
    return false;
  }
  // orientation_is_present
  // height
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength12b__init(&msg->height)) {
    etsi_its_cpm_ts_msgs__msg__RectangularShape__fini(msg);
    return false;
  }
  // height_is_present
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__RectangularShape__fini(etsi_its_cpm_ts_msgs__msg__RectangularShape * msg)
{
  if (!msg) {
    return;
  }
  // center_point
  etsi_its_cpm_ts_msgs__msg__CartesianPosition3d__fini(&msg->center_point);
  // center_point_is_present
  // semi_length
  etsi_its_cpm_ts_msgs__msg__StandardLength12b__fini(&msg->semi_length);
  // semi_breadth
  etsi_its_cpm_ts_msgs__msg__StandardLength12b__fini(&msg->semi_breadth);
  // orientation
  etsi_its_cpm_ts_msgs__msg__Wgs84AngleValue__fini(&msg->orientation);
  // orientation_is_present
  // height
  etsi_its_cpm_ts_msgs__msg__StandardLength12b__fini(&msg->height);
  // height_is_present
}

bool
etsi_its_cpm_ts_msgs__msg__RectangularShape__are_equal(const etsi_its_cpm_ts_msgs__msg__RectangularShape * lhs, const etsi_its_cpm_ts_msgs__msg__RectangularShape * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // center_point
  if (!etsi_its_cpm_ts_msgs__msg__CartesianPosition3d__are_equal(
      &(lhs->center_point), &(rhs->center_point)))
  {
    return false;
  }
  // center_point_is_present
  if (lhs->center_point_is_present != rhs->center_point_is_present) {
    return false;
  }
  // semi_length
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength12b__are_equal(
      &(lhs->semi_length), &(rhs->semi_length)))
  {
    return false;
  }
  // semi_breadth
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength12b__are_equal(
      &(lhs->semi_breadth), &(rhs->semi_breadth)))
  {
    return false;
  }
  // orientation
  if (!etsi_its_cpm_ts_msgs__msg__Wgs84AngleValue__are_equal(
      &(lhs->orientation), &(rhs->orientation)))
  {
    return false;
  }
  // orientation_is_present
  if (lhs->orientation_is_present != rhs->orientation_is_present) {
    return false;
  }
  // height
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength12b__are_equal(
      &(lhs->height), &(rhs->height)))
  {
    return false;
  }
  // height_is_present
  if (lhs->height_is_present != rhs->height_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__RectangularShape__copy(
  const etsi_its_cpm_ts_msgs__msg__RectangularShape * input,
  etsi_its_cpm_ts_msgs__msg__RectangularShape * output)
{
  if (!input || !output) {
    return false;
  }
  // center_point
  if (!etsi_its_cpm_ts_msgs__msg__CartesianPosition3d__copy(
      &(input->center_point), &(output->center_point)))
  {
    return false;
  }
  // center_point_is_present
  output->center_point_is_present = input->center_point_is_present;
  // semi_length
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength12b__copy(
      &(input->semi_length), &(output->semi_length)))
  {
    return false;
  }
  // semi_breadth
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength12b__copy(
      &(input->semi_breadth), &(output->semi_breadth)))
  {
    return false;
  }
  // orientation
  if (!etsi_its_cpm_ts_msgs__msg__Wgs84AngleValue__copy(
      &(input->orientation), &(output->orientation)))
  {
    return false;
  }
  // orientation_is_present
  output->orientation_is_present = input->orientation_is_present;
  // height
  if (!etsi_its_cpm_ts_msgs__msg__StandardLength12b__copy(
      &(input->height), &(output->height)))
  {
    return false;
  }
  // height_is_present
  output->height_is_present = input->height_is_present;
  return true;
}

etsi_its_cpm_ts_msgs__msg__RectangularShape *
etsi_its_cpm_ts_msgs__msg__RectangularShape__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__RectangularShape * msg = (etsi_its_cpm_ts_msgs__msg__RectangularShape *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__RectangularShape), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__RectangularShape));
  bool success = etsi_its_cpm_ts_msgs__msg__RectangularShape__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__RectangularShape__destroy(etsi_its_cpm_ts_msgs__msg__RectangularShape * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__RectangularShape__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence__init(etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__RectangularShape * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__RectangularShape *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__RectangularShape), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__RectangularShape__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__RectangularShape__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence__fini(etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__RectangularShape__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence *
etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence * array = (etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__RectangularShape__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__RectangularShape);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__RectangularShape * data =
      (etsi_its_cpm_ts_msgs__msg__RectangularShape *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__RectangularShape__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__RectangularShape__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__RectangularShape__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
