// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/ReferencePosition.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__REFERENCE_POSITION__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__REFERENCE_POSITION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'latitude'
#include "etsi_its_cpm_ts_msgs/msg/detail/latitude__struct.hpp"
// Member 'longitude'
#include "etsi_its_cpm_ts_msgs/msg/detail/longitude__struct.hpp"
// Member 'position_confidence_ellipse'
#include "etsi_its_cpm_ts_msgs/msg/detail/pos_confidence_ellipse__struct.hpp"
// Member 'altitude'
#include "etsi_its_cpm_ts_msgs/msg/detail/altitude__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__ReferencePosition __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__ReferencePosition __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ReferencePosition_
{
  using Type = ReferencePosition_<ContainerAllocator>;

  explicit ReferencePosition_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : latitude(_init),
    longitude(_init),
    position_confidence_ellipse(_init),
    altitude(_init)
  {
    (void)_init;
  }

  explicit ReferencePosition_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : latitude(_alloc, _init),
    longitude(_alloc, _init),
    position_confidence_ellipse(_alloc, _init),
    altitude(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _latitude_type =
    etsi_its_cpm_ts_msgs::msg::Latitude_<ContainerAllocator>;
  _latitude_type latitude;
  using _longitude_type =
    etsi_its_cpm_ts_msgs::msg::Longitude_<ContainerAllocator>;
  _longitude_type longitude;
  using _position_confidence_ellipse_type =
    etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse_<ContainerAllocator>;
  _position_confidence_ellipse_type position_confidence_ellipse;
  using _altitude_type =
    etsi_its_cpm_ts_msgs::msg::Altitude_<ContainerAllocator>;
  _altitude_type altitude;

  // setters for named parameter idiom
  Type & set__latitude(
    const etsi_its_cpm_ts_msgs::msg::Latitude_<ContainerAllocator> & _arg)
  {
    this->latitude = _arg;
    return *this;
  }
  Type & set__longitude(
    const etsi_its_cpm_ts_msgs::msg::Longitude_<ContainerAllocator> & _arg)
  {
    this->longitude = _arg;
    return *this;
  }
  Type & set__position_confidence_ellipse(
    const etsi_its_cpm_ts_msgs::msg::PosConfidenceEllipse_<ContainerAllocator> & _arg)
  {
    this->position_confidence_ellipse = _arg;
    return *this;
  }
  Type & set__altitude(
    const etsi_its_cpm_ts_msgs::msg::Altitude_<ContainerAllocator> & _arg)
  {
    this->altitude = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::ReferencePosition_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::ReferencePosition_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ReferencePosition_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ReferencePosition_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::ReferencePosition_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::ReferencePosition_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::ReferencePosition_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::ReferencePosition_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::ReferencePosition_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::ReferencePosition_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__ReferencePosition
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ReferencePosition_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__ReferencePosition
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::ReferencePosition_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ReferencePosition_ & other) const
  {
    if (this->latitude != other.latitude) {
      return false;
    }
    if (this->longitude != other.longitude) {
      return false;
    }
    if (this->position_confidence_ellipse != other.position_confidence_ellipse) {
      return false;
    }
    if (this->altitude != other.altitude) {
      return false;
    }
    return true;
  }
  bool operator!=(const ReferencePosition_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ReferencePosition_

// alias to use template instance with default allocator
using ReferencePosition =
  etsi_its_cpm_ts_msgs::msg::ReferencePosition_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__REFERENCE_POSITION__STRUCT_HPP_
