// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/SensorInformation.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SENSOR_INFORMATION__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SENSOR_INFORMATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'sensor_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier1_b__struct.hpp"
// Member 'sensor_type'
#include "etsi_its_cpm_ts_msgs/msg/detail/sensor_type__struct.hpp"
// Member 'perception_region_shape'
#include "etsi_its_cpm_ts_msgs/msg/detail/shape__struct.hpp"
// Member 'perception_region_confidence'
#include "etsi_its_cpm_ts_msgs/msg/detail/confidence_level__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__SensorInformation __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__SensorInformation __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SensorInformation_
{
  using Type = SensorInformation_<ContainerAllocator>;

  explicit SensorInformation_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : sensor_id(_init),
    sensor_type(_init),
    perception_region_shape(_init),
    perception_region_confidence(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->perception_region_shape_is_present = false;
      this->perception_region_confidence_is_present = false;
      this->shadowing_applies = false;
    }
  }

  explicit SensorInformation_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : sensor_id(_alloc, _init),
    sensor_type(_alloc, _init),
    perception_region_shape(_alloc, _init),
    perception_region_confidence(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->perception_region_shape_is_present = false;
      this->perception_region_confidence_is_present = false;
      this->shadowing_applies = false;
    }
  }

  // field types and members
  using _sensor_id_type =
    etsi_its_cpm_ts_msgs::msg::Identifier1B_<ContainerAllocator>;
  _sensor_id_type sensor_id;
  using _sensor_type_type =
    etsi_its_cpm_ts_msgs::msg::SensorType_<ContainerAllocator>;
  _sensor_type_type sensor_type;
  using _perception_region_shape_type =
    etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator>;
  _perception_region_shape_type perception_region_shape;
  using _perception_region_shape_is_present_type =
    bool;
  _perception_region_shape_is_present_type perception_region_shape_is_present;
  using _perception_region_confidence_type =
    etsi_its_cpm_ts_msgs::msg::ConfidenceLevel_<ContainerAllocator>;
  _perception_region_confidence_type perception_region_confidence;
  using _perception_region_confidence_is_present_type =
    bool;
  _perception_region_confidence_is_present_type perception_region_confidence_is_present;
  using _shadowing_applies_type =
    bool;
  _shadowing_applies_type shadowing_applies;

  // setters for named parameter idiom
  Type & set__sensor_id(
    const etsi_its_cpm_ts_msgs::msg::Identifier1B_<ContainerAllocator> & _arg)
  {
    this->sensor_id = _arg;
    return *this;
  }
  Type & set__sensor_type(
    const etsi_its_cpm_ts_msgs::msg::SensorType_<ContainerAllocator> & _arg)
  {
    this->sensor_type = _arg;
    return *this;
  }
  Type & set__perception_region_shape(
    const etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator> & _arg)
  {
    this->perception_region_shape = _arg;
    return *this;
  }
  Type & set__perception_region_shape_is_present(
    const bool & _arg)
  {
    this->perception_region_shape_is_present = _arg;
    return *this;
  }
  Type & set__perception_region_confidence(
    const etsi_its_cpm_ts_msgs::msg::ConfidenceLevel_<ContainerAllocator> & _arg)
  {
    this->perception_region_confidence = _arg;
    return *this;
  }
  Type & set__perception_region_confidence_is_present(
    const bool & _arg)
  {
    this->perception_region_confidence_is_present = _arg;
    return *this;
  }
  Type & set__shadowing_applies(
    const bool & _arg)
  {
    this->shadowing_applies = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::SensorInformation_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::SensorInformation_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::SensorInformation_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::SensorInformation_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::SensorInformation_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::SensorInformation_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::SensorInformation_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::SensorInformation_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::SensorInformation_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::SensorInformation_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__SensorInformation
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::SensorInformation_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__SensorInformation
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::SensorInformation_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SensorInformation_ & other) const
  {
    if (this->sensor_id != other.sensor_id) {
      return false;
    }
    if (this->sensor_type != other.sensor_type) {
      return false;
    }
    if (this->perception_region_shape != other.perception_region_shape) {
      return false;
    }
    if (this->perception_region_shape_is_present != other.perception_region_shape_is_present) {
      return false;
    }
    if (this->perception_region_confidence != other.perception_region_confidence) {
      return false;
    }
    if (this->perception_region_confidence_is_present != other.perception_region_confidence_is_present) {
      return false;
    }
    if (this->shadowing_applies != other.shadowing_applies) {
      return false;
    }
    return true;
  }
  bool operator!=(const SensorInformation_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SensorInformation_

// alias to use template instance with default allocator
using SensorInformation =
  etsi_its_cpm_ts_msgs::msg::SensorInformation_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SENSOR_INFORMATION__STRUCT_HPP_
