// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/Shape.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SHAPE__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SHAPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'CHOICE_RECTANGULAR'.
enum
{
  etsi_its_cpm_ts_msgs__msg__Shape__CHOICE_RECTANGULAR = 0
};

/// Constant 'CHOICE_CIRCULAR'.
enum
{
  etsi_its_cpm_ts_msgs__msg__Shape__CHOICE_CIRCULAR = 1
};

/// Constant 'CHOICE_POLYGONAL'.
enum
{
  etsi_its_cpm_ts_msgs__msg__Shape__CHOICE_POLYGONAL = 2
};

/// Constant 'CHOICE_ELLIPTICAL'.
enum
{
  etsi_its_cpm_ts_msgs__msg__Shape__CHOICE_ELLIPTICAL = 3
};

/// Constant 'CHOICE_RADIAL'.
enum
{
  etsi_its_cpm_ts_msgs__msg__Shape__CHOICE_RADIAL = 4
};

/// Constant 'CHOICE_RADIAL_SHAPES'.
enum
{
  etsi_its_cpm_ts_msgs__msg__Shape__CHOICE_RADIAL_SHAPES = 5
};

// Include directives for member types
// Member 'rectangular'
#include "etsi_its_cpm_ts_msgs/msg/detail/rectangular_shape__struct.h"
// Member 'circular'
#include "etsi_its_cpm_ts_msgs/msg/detail/circular_shape__struct.h"
// Member 'polygonal'
#include "etsi_its_cpm_ts_msgs/msg/detail/polygonal_shape__struct.h"
// Member 'elliptical'
#include "etsi_its_cpm_ts_msgs/msg/detail/elliptical_shape__struct.h"
// Member 'radial'
#include "etsi_its_cpm_ts_msgs/msg/detail/radial_shape__struct.h"
// Member 'radial_shapes'
#include "etsi_its_cpm_ts_msgs/msg/detail/radial_shapes__struct.h"

/// Struct defined in msg/Shape in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__Shape
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF provides the definition of a geographical area or volume, based on different options.
  ///  *
  ///  * It is a choice of the following components:
  ///  *
  ///  * @field rectangular: definition of an rectangular area or a right rectangular prism (with a rectangular base) also called a cuboid, or informally a rectangular box.
  ///  *
  ///  * @field circular: definition of an area of circular shape or a right circular cylinder.
  ///  *
  ///  * @field polygonal: definition of an area of polygonal shape or a right prism.
  ///  *
  ///  * @field elliptical: definition of an area of elliptical shape or a right elliptical cylinder.
  ///  *
  ///  * @field radial: definition of a radial shape.
  ///  *
  ///  * @field radialList: definition of list of radial shapes.
  ///  *
  ///  * @category: GeoReference information
  ///  * @revision: Created in V2.1.1
  ///  */
  /// Shape::= CHOICE {
  ///    rectangular       RectangularShape,
  ///    circular          CircularShape,
  ///    polygonal         PolygonalShape,
  ///    elliptical        EllipticalShape,
  ///    radial            RadialShape,
  ///    radialShapes      RadialShapes,
  ///    ...
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t choice;
  etsi_its_cpm_ts_msgs__msg__RectangularShape rectangular;
  etsi_its_cpm_ts_msgs__msg__CircularShape circular;
  etsi_its_cpm_ts_msgs__msg__PolygonalShape polygonal;
  etsi_its_cpm_ts_msgs__msg__EllipticalShape elliptical;
  etsi_its_cpm_ts_msgs__msg__RadialShape radial;
  etsi_its_cpm_ts_msgs__msg__RadialShapes radial_shapes;
} etsi_its_cpm_ts_msgs__msg__Shape;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__Shape.
typedef struct etsi_its_cpm_ts_msgs__msg__Shape__Sequence
{
  etsi_its_cpm_ts_msgs__msg__Shape * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__Shape__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SHAPE__STRUCT_H_
