// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/Shape.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SHAPE__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SHAPE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'rectangular'
#include "etsi_its_cpm_ts_msgs/msg/detail/rectangular_shape__struct.hpp"
// Member 'circular'
#include "etsi_its_cpm_ts_msgs/msg/detail/circular_shape__struct.hpp"
// Member 'polygonal'
#include "etsi_its_cpm_ts_msgs/msg/detail/polygonal_shape__struct.hpp"
// Member 'elliptical'
#include "etsi_its_cpm_ts_msgs/msg/detail/elliptical_shape__struct.hpp"
// Member 'radial'
#include "etsi_its_cpm_ts_msgs/msg/detail/radial_shape__struct.hpp"
// Member 'radial_shapes'
#include "etsi_its_cpm_ts_msgs/msg/detail/radial_shapes__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__Shape __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__Shape __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Shape_
{
  using Type = Shape_<ContainerAllocator>;

  explicit Shape_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : rectangular(_init),
    circular(_init),
    polygonal(_init),
    elliptical(_init),
    radial(_init),
    radial_shapes(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  explicit Shape_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : rectangular(_alloc, _init),
    circular(_alloc, _init),
    polygonal(_alloc, _init),
    elliptical(_alloc, _init),
    radial(_alloc, _init),
    radial_shapes(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  // field types and members
  using _choice_type =
    uint8_t;
  _choice_type choice;
  using _rectangular_type =
    etsi_its_cpm_ts_msgs::msg::RectangularShape_<ContainerAllocator>;
  _rectangular_type rectangular;
  using _circular_type =
    etsi_its_cpm_ts_msgs::msg::CircularShape_<ContainerAllocator>;
  _circular_type circular;
  using _polygonal_type =
    etsi_its_cpm_ts_msgs::msg::PolygonalShape_<ContainerAllocator>;
  _polygonal_type polygonal;
  using _elliptical_type =
    etsi_its_cpm_ts_msgs::msg::EllipticalShape_<ContainerAllocator>;
  _elliptical_type elliptical;
  using _radial_type =
    etsi_its_cpm_ts_msgs::msg::RadialShape_<ContainerAllocator>;
  _radial_type radial;
  using _radial_shapes_type =
    etsi_its_cpm_ts_msgs::msg::RadialShapes_<ContainerAllocator>;
  _radial_shapes_type radial_shapes;

  // setters for named parameter idiom
  Type & set__choice(
    const uint8_t & _arg)
  {
    this->choice = _arg;
    return *this;
  }
  Type & set__rectangular(
    const etsi_its_cpm_ts_msgs::msg::RectangularShape_<ContainerAllocator> & _arg)
  {
    this->rectangular = _arg;
    return *this;
  }
  Type & set__circular(
    const etsi_its_cpm_ts_msgs::msg::CircularShape_<ContainerAllocator> & _arg)
  {
    this->circular = _arg;
    return *this;
  }
  Type & set__polygonal(
    const etsi_its_cpm_ts_msgs::msg::PolygonalShape_<ContainerAllocator> & _arg)
  {
    this->polygonal = _arg;
    return *this;
  }
  Type & set__elliptical(
    const etsi_its_cpm_ts_msgs::msg::EllipticalShape_<ContainerAllocator> & _arg)
  {
    this->elliptical = _arg;
    return *this;
  }
  Type & set__radial(
    const etsi_its_cpm_ts_msgs::msg::RadialShape_<ContainerAllocator> & _arg)
  {
    this->radial = _arg;
    return *this;
  }
  Type & set__radial_shapes(
    const etsi_its_cpm_ts_msgs::msg::RadialShapes_<ContainerAllocator> & _arg)
  {
    this->radial_shapes = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t CHOICE_RECTANGULAR =
    0u;
  static constexpr uint8_t CHOICE_CIRCULAR =
    1u;
  static constexpr uint8_t CHOICE_POLYGONAL =
    2u;
  static constexpr uint8_t CHOICE_ELLIPTICAL =
    3u;
  static constexpr uint8_t CHOICE_RADIAL =
    4u;
  static constexpr uint8_t CHOICE_RADIAL_SHAPES =
    5u;

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__Shape
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__Shape
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Shape_ & other) const
  {
    if (this->choice != other.choice) {
      return false;
    }
    if (this->rectangular != other.rectangular) {
      return false;
    }
    if (this->circular != other.circular) {
      return false;
    }
    if (this->polygonal != other.polygonal) {
      return false;
    }
    if (this->elliptical != other.elliptical) {
      return false;
    }
    if (this->radial != other.radial) {
      return false;
    }
    if (this->radial_shapes != other.radial_shapes) {
      return false;
    }
    return true;
  }
  bool operator!=(const Shape_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Shape_

// alias to use template instance with default allocator
using Shape =
  etsi_its_cpm_ts_msgs::msg::Shape_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Shape_<ContainerAllocator>::CHOICE_RECTANGULAR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Shape_<ContainerAllocator>::CHOICE_CIRCULAR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Shape_<ContainerAllocator>::CHOICE_POLYGONAL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Shape_<ContainerAllocator>::CHOICE_ELLIPTICAL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Shape_<ContainerAllocator>::CHOICE_RADIAL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Shape_<ContainerAllocator>::CHOICE_RADIAL_SHAPES;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SHAPE__STRUCT_HPP_
