// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/Shape.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SHAPE__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SHAPE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/shape__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'rectangular'
#include "etsi_its_cpm_ts_msgs/msg/detail/rectangular_shape__traits.hpp"
// Member 'circular'
#include "etsi_its_cpm_ts_msgs/msg/detail/circular_shape__traits.hpp"
// Member 'polygonal'
#include "etsi_its_cpm_ts_msgs/msg/detail/polygonal_shape__traits.hpp"
// Member 'elliptical'
#include "etsi_its_cpm_ts_msgs/msg/detail/elliptical_shape__traits.hpp"
// Member 'radial'
#include "etsi_its_cpm_ts_msgs/msg/detail/radial_shape__traits.hpp"
// Member 'radial_shapes'
#include "etsi_its_cpm_ts_msgs/msg/detail/radial_shapes__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Shape & msg,
  std::ostream & out)
{
  out << "{";
  // member: choice
  {
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << ", ";
  }

  // member: rectangular
  {
    out << "rectangular: ";
    to_flow_style_yaml(msg.rectangular, out);
    out << ", ";
  }

  // member: circular
  {
    out << "circular: ";
    to_flow_style_yaml(msg.circular, out);
    out << ", ";
  }

  // member: polygonal
  {
    out << "polygonal: ";
    to_flow_style_yaml(msg.polygonal, out);
    out << ", ";
  }

  // member: elliptical
  {
    out << "elliptical: ";
    to_flow_style_yaml(msg.elliptical, out);
    out << ", ";
  }

  // member: radial
  {
    out << "radial: ";
    to_flow_style_yaml(msg.radial, out);
    out << ", ";
  }

  // member: radial_shapes
  {
    out << "radial_shapes: ";
    to_flow_style_yaml(msg.radial_shapes, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Shape & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: choice
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << "\n";
  }

  // member: rectangular
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rectangular:\n";
    to_block_style_yaml(msg.rectangular, out, indentation + 2);
  }

  // member: circular
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "circular:\n";
    to_block_style_yaml(msg.circular, out, indentation + 2);
  }

  // member: polygonal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "polygonal:\n";
    to_block_style_yaml(msg.polygonal, out, indentation + 2);
  }

  // member: elliptical
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "elliptical:\n";
    to_block_style_yaml(msg.elliptical, out, indentation + 2);
  }

  // member: radial
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "radial:\n";
    to_block_style_yaml(msg.radial, out, indentation + 2);
  }

  // member: radial_shapes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "radial_shapes:\n";
    to_block_style_yaml(msg.radial_shapes, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Shape & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::Shape & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::Shape & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::Shape>()
{
  return "etsi_its_cpm_ts_msgs::msg::Shape";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::Shape>()
{
  return "etsi_its_cpm_ts_msgs/msg/Shape";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::Shape>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::CircularShape>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::EllipticalShape>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::PolygonalShape>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::RadialShape>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::RadialShapes>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::RectangularShape>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::Shape>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::CircularShape>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::EllipticalShape>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::PolygonalShape>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::RadialShape>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::RadialShapes>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::RectangularShape>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::Shape>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SHAPE__TRAITS_HPP_
