// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/TrailerData.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__TRAILER_DATA__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__TRAILER_DATA__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'ref_point_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier1_b__struct.hpp"
// Member 'hitch_point_offset'
// Member 'front_overhang'
// Member 'rear_overhang'
#include "etsi_its_cpm_ts_msgs/msg/detail/standard_length1_b__struct.hpp"
// Member 'trailer_width'
#include "etsi_its_cpm_ts_msgs/msg/detail/vehicle_width__struct.hpp"
// Member 'hitch_angle'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__TrailerData __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__TrailerData __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct TrailerData_
{
  using Type = TrailerData_<ContainerAllocator>;

  explicit TrailerData_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : ref_point_id(_init),
    hitch_point_offset(_init),
    front_overhang(_init),
    rear_overhang(_init),
    trailer_width(_init),
    hitch_angle(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->front_overhang_is_present = false;
      this->rear_overhang_is_present = false;
      this->trailer_width_is_present = false;
    }
  }

  explicit TrailerData_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : ref_point_id(_alloc, _init),
    hitch_point_offset(_alloc, _init),
    front_overhang(_alloc, _init),
    rear_overhang(_alloc, _init),
    trailer_width(_alloc, _init),
    hitch_angle(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->front_overhang_is_present = false;
      this->rear_overhang_is_present = false;
      this->trailer_width_is_present = false;
    }
  }

  // field types and members
  using _ref_point_id_type =
    etsi_its_cpm_ts_msgs::msg::Identifier1B_<ContainerAllocator>;
  _ref_point_id_type ref_point_id;
  using _hitch_point_offset_type =
    etsi_its_cpm_ts_msgs::msg::StandardLength1B_<ContainerAllocator>;
  _hitch_point_offset_type hitch_point_offset;
  using _front_overhang_type =
    etsi_its_cpm_ts_msgs::msg::StandardLength1B_<ContainerAllocator>;
  _front_overhang_type front_overhang;
  using _front_overhang_is_present_type =
    bool;
  _front_overhang_is_present_type front_overhang_is_present;
  using _rear_overhang_type =
    etsi_its_cpm_ts_msgs::msg::StandardLength1B_<ContainerAllocator>;
  _rear_overhang_type rear_overhang;
  using _rear_overhang_is_present_type =
    bool;
  _rear_overhang_is_present_type rear_overhang_is_present;
  using _trailer_width_type =
    etsi_its_cpm_ts_msgs::msg::VehicleWidth_<ContainerAllocator>;
  _trailer_width_type trailer_width;
  using _trailer_width_is_present_type =
    bool;
  _trailer_width_is_present_type trailer_width_is_present;
  using _hitch_angle_type =
    etsi_its_cpm_ts_msgs::msg::CartesianAngle_<ContainerAllocator>;
  _hitch_angle_type hitch_angle;

  // setters for named parameter idiom
  Type & set__ref_point_id(
    const etsi_its_cpm_ts_msgs::msg::Identifier1B_<ContainerAllocator> & _arg)
  {
    this->ref_point_id = _arg;
    return *this;
  }
  Type & set__hitch_point_offset(
    const etsi_its_cpm_ts_msgs::msg::StandardLength1B_<ContainerAllocator> & _arg)
  {
    this->hitch_point_offset = _arg;
    return *this;
  }
  Type & set__front_overhang(
    const etsi_its_cpm_ts_msgs::msg::StandardLength1B_<ContainerAllocator> & _arg)
  {
    this->front_overhang = _arg;
    return *this;
  }
  Type & set__front_overhang_is_present(
    const bool & _arg)
  {
    this->front_overhang_is_present = _arg;
    return *this;
  }
  Type & set__rear_overhang(
    const etsi_its_cpm_ts_msgs::msg::StandardLength1B_<ContainerAllocator> & _arg)
  {
    this->rear_overhang = _arg;
    return *this;
  }
  Type & set__rear_overhang_is_present(
    const bool & _arg)
  {
    this->rear_overhang_is_present = _arg;
    return *this;
  }
  Type & set__trailer_width(
    const etsi_its_cpm_ts_msgs::msg::VehicleWidth_<ContainerAllocator> & _arg)
  {
    this->trailer_width = _arg;
    return *this;
  }
  Type & set__trailer_width_is_present(
    const bool & _arg)
  {
    this->trailer_width_is_present = _arg;
    return *this;
  }
  Type & set__hitch_angle(
    const etsi_its_cpm_ts_msgs::msg::CartesianAngle_<ContainerAllocator> & _arg)
  {
    this->hitch_angle = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::TrailerData_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::TrailerData_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::TrailerData_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::TrailerData_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::TrailerData_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::TrailerData_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::TrailerData_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::TrailerData_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::TrailerData_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::TrailerData_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__TrailerData
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::TrailerData_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__TrailerData
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::TrailerData_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrailerData_ & other) const
  {
    if (this->ref_point_id != other.ref_point_id) {
      return false;
    }
    if (this->hitch_point_offset != other.hitch_point_offset) {
      return false;
    }
    if (this->front_overhang != other.front_overhang) {
      return false;
    }
    if (this->front_overhang_is_present != other.front_overhang_is_present) {
      return false;
    }
    if (this->rear_overhang != other.rear_overhang) {
      return false;
    }
    if (this->rear_overhang_is_present != other.rear_overhang_is_present) {
      return false;
    }
    if (this->trailer_width != other.trailer_width) {
      return false;
    }
    if (this->trailer_width_is_present != other.trailer_width_is_present) {
      return false;
    }
    if (this->hitch_angle != other.hitch_angle) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrailerData_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrailerData_

// alias to use template instance with default allocator
using TrailerData =
  etsi_its_cpm_ts_msgs::msg::TrailerData_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__TRAILER_DATA__STRUCT_HPP_
