// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/Velocity3dWithConfidence.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/velocity3d_with_confidence__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `polar_velocity`
#include "etsi_its_cpm_ts_msgs/msg/detail/velocity_polar_with_z__functions.h"
// Member `cartesian_velocity`
#include "etsi_its_cpm_ts_msgs/msg/detail/velocity_cartesian__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__init(etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence * msg)
{
  if (!msg) {
    return false;
  }
  // choice
  // polar_velocity
  if (!etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__init(&msg->polar_velocity)) {
    etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__fini(msg);
    return false;
  }
  // cartesian_velocity
  if (!etsi_its_cpm_ts_msgs__msg__VelocityCartesian__init(&msg->cartesian_velocity)) {
    etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__fini(etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence * msg)
{
  if (!msg) {
    return;
  }
  // choice
  // polar_velocity
  etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__fini(&msg->polar_velocity);
  // cartesian_velocity
  etsi_its_cpm_ts_msgs__msg__VelocityCartesian__fini(&msg->cartesian_velocity);
}

bool
etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__are_equal(const etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence * lhs, const etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // choice
  if (lhs->choice != rhs->choice) {
    return false;
  }
  // polar_velocity
  if (!etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__are_equal(
      &(lhs->polar_velocity), &(rhs->polar_velocity)))
  {
    return false;
  }
  // cartesian_velocity
  if (!etsi_its_cpm_ts_msgs__msg__VelocityCartesian__are_equal(
      &(lhs->cartesian_velocity), &(rhs->cartesian_velocity)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__copy(
  const etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence * input,
  etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence * output)
{
  if (!input || !output) {
    return false;
  }
  // choice
  output->choice = input->choice;
  // polar_velocity
  if (!etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__copy(
      &(input->polar_velocity), &(output->polar_velocity)))
  {
    return false;
  }
  // cartesian_velocity
  if (!etsi_its_cpm_ts_msgs__msg__VelocityCartesian__copy(
      &(input->cartesian_velocity), &(output->cartesian_velocity)))
  {
    return false;
  }
  return true;
}

etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence *
etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence * msg = (etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence));
  bool success = etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__destroy(etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence__init(etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence__fini(etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence *
etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence * array = (etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence * data =
      (etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
