// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/VelocityCartesian.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VELOCITY_CARTESIAN__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VELOCITY_CARTESIAN__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'x_velocity'
// Member 'y_velocity'
// Member 'z_velocity'
#include "etsi_its_cpm_ts_msgs/msg/detail/velocity_component__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__VelocityCartesian __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__VelocityCartesian __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VelocityCartesian_
{
  using Type = VelocityCartesian_<ContainerAllocator>;

  explicit VelocityCartesian_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : x_velocity(_init),
    y_velocity(_init),
    z_velocity(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->z_velocity_is_present = false;
    }
  }

  explicit VelocityCartesian_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : x_velocity(_alloc, _init),
    y_velocity(_alloc, _init),
    z_velocity(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->z_velocity_is_present = false;
    }
  }

  // field types and members
  using _x_velocity_type =
    etsi_its_cpm_ts_msgs::msg::VelocityComponent_<ContainerAllocator>;
  _x_velocity_type x_velocity;
  using _y_velocity_type =
    etsi_its_cpm_ts_msgs::msg::VelocityComponent_<ContainerAllocator>;
  _y_velocity_type y_velocity;
  using _z_velocity_type =
    etsi_its_cpm_ts_msgs::msg::VelocityComponent_<ContainerAllocator>;
  _z_velocity_type z_velocity;
  using _z_velocity_is_present_type =
    bool;
  _z_velocity_is_present_type z_velocity_is_present;

  // setters for named parameter idiom
  Type & set__x_velocity(
    const etsi_its_cpm_ts_msgs::msg::VelocityComponent_<ContainerAllocator> & _arg)
  {
    this->x_velocity = _arg;
    return *this;
  }
  Type & set__y_velocity(
    const etsi_its_cpm_ts_msgs::msg::VelocityComponent_<ContainerAllocator> & _arg)
  {
    this->y_velocity = _arg;
    return *this;
  }
  Type & set__z_velocity(
    const etsi_its_cpm_ts_msgs::msg::VelocityComponent_<ContainerAllocator> & _arg)
  {
    this->z_velocity = _arg;
    return *this;
  }
  Type & set__z_velocity_is_present(
    const bool & _arg)
  {
    this->z_velocity_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::VelocityCartesian_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::VelocityCartesian_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::VelocityCartesian_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::VelocityCartesian_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::VelocityCartesian_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::VelocityCartesian_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::VelocityCartesian_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::VelocityCartesian_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::VelocityCartesian_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::VelocityCartesian_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__VelocityCartesian
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::VelocityCartesian_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__VelocityCartesian
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::VelocityCartesian_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VelocityCartesian_ & other) const
  {
    if (this->x_velocity != other.x_velocity) {
      return false;
    }
    if (this->y_velocity != other.y_velocity) {
      return false;
    }
    if (this->z_velocity != other.z_velocity) {
      return false;
    }
    if (this->z_velocity_is_present != other.z_velocity_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const VelocityCartesian_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VelocityCartesian_

// alias to use template instance with default allocator
using VelocityCartesian =
  etsi_its_cpm_ts_msgs::msg::VelocityCartesian_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VELOCITY_CARTESIAN__STRUCT_HPP_
