// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/VruClusterInformation.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_cluster_information__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `cluster_id`
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier1_b__functions.h"
// Member `cluster_bounding_box_shape`
#include "etsi_its_cpm_ts_msgs/msg/detail/shape__functions.h"
// Member `cluster_cardinality_size`
#include "etsi_its_cpm_ts_msgs/msg/detail/cardinal_number1_b__functions.h"
// Member `cluster_profiles`
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_cluster_profiles__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__VruClusterInformation__init(etsi_its_cpm_ts_msgs__msg__VruClusterInformation * msg)
{
  if (!msg) {
    return false;
  }
  // cluster_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__init(&msg->cluster_id)) {
    etsi_its_cpm_ts_msgs__msg__VruClusterInformation__fini(msg);
    return false;
  }
  // cluster_id_is_present
  // cluster_bounding_box_shape
  if (!etsi_its_cpm_ts_msgs__msg__Shape__init(&msg->cluster_bounding_box_shape)) {
    etsi_its_cpm_ts_msgs__msg__VruClusterInformation__fini(msg);
    return false;
  }
  // cluster_bounding_box_shape_is_present
  // cluster_cardinality_size
  if (!etsi_its_cpm_ts_msgs__msg__CardinalNumber1B__init(&msg->cluster_cardinality_size)) {
    etsi_its_cpm_ts_msgs__msg__VruClusterInformation__fini(msg);
    return false;
  }
  // cluster_profiles
  if (!etsi_its_cpm_ts_msgs__msg__VruClusterProfiles__init(&msg->cluster_profiles)) {
    etsi_its_cpm_ts_msgs__msg__VruClusterInformation__fini(msg);
    return false;
  }
  // cluster_profiles_is_present
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__VruClusterInformation__fini(etsi_its_cpm_ts_msgs__msg__VruClusterInformation * msg)
{
  if (!msg) {
    return;
  }
  // cluster_id
  etsi_its_cpm_ts_msgs__msg__Identifier1B__fini(&msg->cluster_id);
  // cluster_id_is_present
  // cluster_bounding_box_shape
  etsi_its_cpm_ts_msgs__msg__Shape__fini(&msg->cluster_bounding_box_shape);
  // cluster_bounding_box_shape_is_present
  // cluster_cardinality_size
  etsi_its_cpm_ts_msgs__msg__CardinalNumber1B__fini(&msg->cluster_cardinality_size);
  // cluster_profiles
  etsi_its_cpm_ts_msgs__msg__VruClusterProfiles__fini(&msg->cluster_profiles);
  // cluster_profiles_is_present
}

bool
etsi_its_cpm_ts_msgs__msg__VruClusterInformation__are_equal(const etsi_its_cpm_ts_msgs__msg__VruClusterInformation * lhs, const etsi_its_cpm_ts_msgs__msg__VruClusterInformation * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // cluster_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__are_equal(
      &(lhs->cluster_id), &(rhs->cluster_id)))
  {
    return false;
  }
  // cluster_id_is_present
  if (lhs->cluster_id_is_present != rhs->cluster_id_is_present) {
    return false;
  }
  // cluster_bounding_box_shape
  if (!etsi_its_cpm_ts_msgs__msg__Shape__are_equal(
      &(lhs->cluster_bounding_box_shape), &(rhs->cluster_bounding_box_shape)))
  {
    return false;
  }
  // cluster_bounding_box_shape_is_present
  if (lhs->cluster_bounding_box_shape_is_present != rhs->cluster_bounding_box_shape_is_present) {
    return false;
  }
  // cluster_cardinality_size
  if (!etsi_its_cpm_ts_msgs__msg__CardinalNumber1B__are_equal(
      &(lhs->cluster_cardinality_size), &(rhs->cluster_cardinality_size)))
  {
    return false;
  }
  // cluster_profiles
  if (!etsi_its_cpm_ts_msgs__msg__VruClusterProfiles__are_equal(
      &(lhs->cluster_profiles), &(rhs->cluster_profiles)))
  {
    return false;
  }
  // cluster_profiles_is_present
  if (lhs->cluster_profiles_is_present != rhs->cluster_profiles_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__VruClusterInformation__copy(
  const etsi_its_cpm_ts_msgs__msg__VruClusterInformation * input,
  etsi_its_cpm_ts_msgs__msg__VruClusterInformation * output)
{
  if (!input || !output) {
    return false;
  }
  // cluster_id
  if (!etsi_its_cpm_ts_msgs__msg__Identifier1B__copy(
      &(input->cluster_id), &(output->cluster_id)))
  {
    return false;
  }
  // cluster_id_is_present
  output->cluster_id_is_present = input->cluster_id_is_present;
  // cluster_bounding_box_shape
  if (!etsi_its_cpm_ts_msgs__msg__Shape__copy(
      &(input->cluster_bounding_box_shape), &(output->cluster_bounding_box_shape)))
  {
    return false;
  }
  // cluster_bounding_box_shape_is_present
  output->cluster_bounding_box_shape_is_present = input->cluster_bounding_box_shape_is_present;
  // cluster_cardinality_size
  if (!etsi_its_cpm_ts_msgs__msg__CardinalNumber1B__copy(
      &(input->cluster_cardinality_size), &(output->cluster_cardinality_size)))
  {
    return false;
  }
  // cluster_profiles
  if (!etsi_its_cpm_ts_msgs__msg__VruClusterProfiles__copy(
      &(input->cluster_profiles), &(output->cluster_profiles)))
  {
    return false;
  }
  // cluster_profiles_is_present
  output->cluster_profiles_is_present = input->cluster_profiles_is_present;
  return true;
}

etsi_its_cpm_ts_msgs__msg__VruClusterInformation *
etsi_its_cpm_ts_msgs__msg__VruClusterInformation__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__VruClusterInformation * msg = (etsi_its_cpm_ts_msgs__msg__VruClusterInformation *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__VruClusterInformation), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__VruClusterInformation));
  bool success = etsi_its_cpm_ts_msgs__msg__VruClusterInformation__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__VruClusterInformation__destroy(etsi_its_cpm_ts_msgs__msg__VruClusterInformation * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__VruClusterInformation__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence__init(etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__VruClusterInformation * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__VruClusterInformation *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__VruClusterInformation), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__VruClusterInformation__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__VruClusterInformation__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence__fini(etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__VruClusterInformation__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence *
etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence * array = (etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__VruClusterInformation__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__VruClusterInformation);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__VruClusterInformation * data =
      (etsi_its_cpm_ts_msgs__msg__VruClusterInformation *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__VruClusterInformation__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__VruClusterInformation__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__VruClusterInformation__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
