// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/VruClusterInformation.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_INFORMATION__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_INFORMATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'cluster_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier1_b__struct.hpp"
// Member 'cluster_bounding_box_shape'
#include "etsi_its_cpm_ts_msgs/msg/detail/shape__struct.hpp"
// Member 'cluster_cardinality_size'
#include "etsi_its_cpm_ts_msgs/msg/detail/cardinal_number1_b__struct.hpp"
// Member 'cluster_profiles'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_cluster_profiles__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__VruClusterInformation __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__VruClusterInformation __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VruClusterInformation_
{
  using Type = VruClusterInformation_<ContainerAllocator>;

  explicit VruClusterInformation_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cluster_id(_init),
    cluster_bounding_box_shape(_init),
    cluster_cardinality_size(_init),
    cluster_profiles(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->cluster_id_is_present = false;
      this->cluster_bounding_box_shape_is_present = false;
      this->cluster_profiles_is_present = false;
    }
  }

  explicit VruClusterInformation_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cluster_id(_alloc, _init),
    cluster_bounding_box_shape(_alloc, _init),
    cluster_cardinality_size(_alloc, _init),
    cluster_profiles(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->cluster_id_is_present = false;
      this->cluster_bounding_box_shape_is_present = false;
      this->cluster_profiles_is_present = false;
    }
  }

  // field types and members
  using _cluster_id_type =
    etsi_its_cpm_ts_msgs::msg::Identifier1B_<ContainerAllocator>;
  _cluster_id_type cluster_id;
  using _cluster_id_is_present_type =
    bool;
  _cluster_id_is_present_type cluster_id_is_present;
  using _cluster_bounding_box_shape_type =
    etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator>;
  _cluster_bounding_box_shape_type cluster_bounding_box_shape;
  using _cluster_bounding_box_shape_is_present_type =
    bool;
  _cluster_bounding_box_shape_is_present_type cluster_bounding_box_shape_is_present;
  using _cluster_cardinality_size_type =
    etsi_its_cpm_ts_msgs::msg::CardinalNumber1B_<ContainerAllocator>;
  _cluster_cardinality_size_type cluster_cardinality_size;
  using _cluster_profiles_type =
    etsi_its_cpm_ts_msgs::msg::VruClusterProfiles_<ContainerAllocator>;
  _cluster_profiles_type cluster_profiles;
  using _cluster_profiles_is_present_type =
    bool;
  _cluster_profiles_is_present_type cluster_profiles_is_present;

  // setters for named parameter idiom
  Type & set__cluster_id(
    const etsi_its_cpm_ts_msgs::msg::Identifier1B_<ContainerAllocator> & _arg)
  {
    this->cluster_id = _arg;
    return *this;
  }
  Type & set__cluster_id_is_present(
    const bool & _arg)
  {
    this->cluster_id_is_present = _arg;
    return *this;
  }
  Type & set__cluster_bounding_box_shape(
    const etsi_its_cpm_ts_msgs::msg::Shape_<ContainerAllocator> & _arg)
  {
    this->cluster_bounding_box_shape = _arg;
    return *this;
  }
  Type & set__cluster_bounding_box_shape_is_present(
    const bool & _arg)
  {
    this->cluster_bounding_box_shape_is_present = _arg;
    return *this;
  }
  Type & set__cluster_cardinality_size(
    const etsi_its_cpm_ts_msgs::msg::CardinalNumber1B_<ContainerAllocator> & _arg)
  {
    this->cluster_cardinality_size = _arg;
    return *this;
  }
  Type & set__cluster_profiles(
    const etsi_its_cpm_ts_msgs::msg::VruClusterProfiles_<ContainerAllocator> & _arg)
  {
    this->cluster_profiles = _arg;
    return *this;
  }
  Type & set__cluster_profiles_is_present(
    const bool & _arg)
  {
    this->cluster_profiles_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::VruClusterInformation_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::VruClusterInformation_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::VruClusterInformation_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::VruClusterInformation_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::VruClusterInformation_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::VruClusterInformation_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::VruClusterInformation_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::VruClusterInformation_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::VruClusterInformation_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::VruClusterInformation_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__VruClusterInformation
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::VruClusterInformation_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__VruClusterInformation
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::VruClusterInformation_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VruClusterInformation_ & other) const
  {
    if (this->cluster_id != other.cluster_id) {
      return false;
    }
    if (this->cluster_id_is_present != other.cluster_id_is_present) {
      return false;
    }
    if (this->cluster_bounding_box_shape != other.cluster_bounding_box_shape) {
      return false;
    }
    if (this->cluster_bounding_box_shape_is_present != other.cluster_bounding_box_shape_is_present) {
      return false;
    }
    if (this->cluster_cardinality_size != other.cluster_cardinality_size) {
      return false;
    }
    if (this->cluster_profiles != other.cluster_profiles) {
      return false;
    }
    if (this->cluster_profiles_is_present != other.cluster_profiles_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const VruClusterInformation_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VruClusterInformation_

// alias to use template instance with default allocator
using VruClusterInformation =
  etsi_its_cpm_ts_msgs::msg::VruClusterInformation_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_INFORMATION__STRUCT_HPP_
