// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/VruClusterInformation.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_INFORMATION__TRAITS_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_INFORMATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cpm_ts_msgs/msg/detail/vru_cluster_information__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'cluster_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier1_b__traits.hpp"
// Member 'cluster_bounding_box_shape'
#include "etsi_its_cpm_ts_msgs/msg/detail/shape__traits.hpp"
// Member 'cluster_cardinality_size'
#include "etsi_its_cpm_ts_msgs/msg/detail/cardinal_number1_b__traits.hpp"
// Member 'cluster_profiles'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_cluster_profiles__traits.hpp"

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const VruClusterInformation & msg,
  std::ostream & out)
{
  out << "{";
  // member: cluster_id
  {
    out << "cluster_id: ";
    to_flow_style_yaml(msg.cluster_id, out);
    out << ", ";
  }

  // member: cluster_id_is_present
  {
    out << "cluster_id_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_id_is_present, out);
    out << ", ";
  }

  // member: cluster_bounding_box_shape
  {
    out << "cluster_bounding_box_shape: ";
    to_flow_style_yaml(msg.cluster_bounding_box_shape, out);
    out << ", ";
  }

  // member: cluster_bounding_box_shape_is_present
  {
    out << "cluster_bounding_box_shape_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_bounding_box_shape_is_present, out);
    out << ", ";
  }

  // member: cluster_cardinality_size
  {
    out << "cluster_cardinality_size: ";
    to_flow_style_yaml(msg.cluster_cardinality_size, out);
    out << ", ";
  }

  // member: cluster_profiles
  {
    out << "cluster_profiles: ";
    to_flow_style_yaml(msg.cluster_profiles, out);
    out << ", ";
  }

  // member: cluster_profiles_is_present
  {
    out << "cluster_profiles_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_profiles_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const VruClusterInformation & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: cluster_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cluster_id:\n";
    to_block_style_yaml(msg.cluster_id, out, indentation + 2);
  }

  // member: cluster_id_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cluster_id_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_id_is_present, out);
    out << "\n";
  }

  // member: cluster_bounding_box_shape
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cluster_bounding_box_shape:\n";
    to_block_style_yaml(msg.cluster_bounding_box_shape, out, indentation + 2);
  }

  // member: cluster_bounding_box_shape_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cluster_bounding_box_shape_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_bounding_box_shape_is_present, out);
    out << "\n";
  }

  // member: cluster_cardinality_size
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cluster_cardinality_size:\n";
    to_block_style_yaml(msg.cluster_cardinality_size, out, indentation + 2);
  }

  // member: cluster_profiles
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cluster_profiles:\n";
    to_block_style_yaml(msg.cluster_profiles, out, indentation + 2);
  }

  // member: cluster_profiles_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cluster_profiles_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_profiles_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const VruClusterInformation & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cpm_ts_msgs::msg::VruClusterInformation & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cpm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cpm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cpm_ts_msgs::msg::VruClusterInformation & msg)
{
  return etsi_its_cpm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cpm_ts_msgs::msg::VruClusterInformation>()
{
  return "etsi_its_cpm_ts_msgs::msg::VruClusterInformation";
}

template<>
inline const char * name<etsi_its_cpm_ts_msgs::msg::VruClusterInformation>()
{
  return "etsi_its_cpm_ts_msgs/msg/VruClusterInformation";
}

template<>
struct has_fixed_size<etsi_its_cpm_ts_msgs::msg::VruClusterInformation>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cpm_ts_msgs::msg::CardinalNumber1B>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::Identifier1B>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::Shape>::value && has_fixed_size<etsi_its_cpm_ts_msgs::msg::VruClusterProfiles>::value> {};

template<>
struct has_bounded_size<etsi_its_cpm_ts_msgs::msg::VruClusterInformation>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cpm_ts_msgs::msg::CardinalNumber1B>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::Identifier1B>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::Shape>::value && has_bounded_size<etsi_its_cpm_ts_msgs::msg::VruClusterProfiles>::value> {};

template<>
struct is_message<etsi_its_cpm_ts_msgs::msg::VruClusterInformation>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_INFORMATION__TRAITS_HPP_
