// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cpm_ts_msgs:msg/VruProfileAndSubprofile.idl
// generated code does not contain a copyright notice
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_profile_and_subprofile__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `pedestrian`
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_sub_profile_pedestrian__functions.h"
// Member `bicyclist_and_light_vru_vehicle`
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_sub_profile_bicyclist__functions.h"
// Member `motorcyclist`
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_sub_profile_motorcyclist__functions.h"
// Member `animal`
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_sub_profile_animal__functions.h"

bool
etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__init(etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile * msg)
{
  if (!msg) {
    return false;
  }
  // choice
  // pedestrian
  if (!etsi_its_cpm_ts_msgs__msg__VruSubProfilePedestrian__init(&msg->pedestrian)) {
    etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__fini(msg);
    return false;
  }
  // bicyclist_and_light_vru_vehicle
  if (!etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist__init(&msg->bicyclist_and_light_vru_vehicle)) {
    etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__fini(msg);
    return false;
  }
  // motorcyclist
  if (!etsi_its_cpm_ts_msgs__msg__VruSubProfileMotorcyclist__init(&msg->motorcyclist)) {
    etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__fini(msg);
    return false;
  }
  // animal
  if (!etsi_its_cpm_ts_msgs__msg__VruSubProfileAnimal__init(&msg->animal)) {
    etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__fini(etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile * msg)
{
  if (!msg) {
    return;
  }
  // choice
  // pedestrian
  etsi_its_cpm_ts_msgs__msg__VruSubProfilePedestrian__fini(&msg->pedestrian);
  // bicyclist_and_light_vru_vehicle
  etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist__fini(&msg->bicyclist_and_light_vru_vehicle);
  // motorcyclist
  etsi_its_cpm_ts_msgs__msg__VruSubProfileMotorcyclist__fini(&msg->motorcyclist);
  // animal
  etsi_its_cpm_ts_msgs__msg__VruSubProfileAnimal__fini(&msg->animal);
}

bool
etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__are_equal(const etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile * lhs, const etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // choice
  if (lhs->choice != rhs->choice) {
    return false;
  }
  // pedestrian
  if (!etsi_its_cpm_ts_msgs__msg__VruSubProfilePedestrian__are_equal(
      &(lhs->pedestrian), &(rhs->pedestrian)))
  {
    return false;
  }
  // bicyclist_and_light_vru_vehicle
  if (!etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist__are_equal(
      &(lhs->bicyclist_and_light_vru_vehicle), &(rhs->bicyclist_and_light_vru_vehicle)))
  {
    return false;
  }
  // motorcyclist
  if (!etsi_its_cpm_ts_msgs__msg__VruSubProfileMotorcyclist__are_equal(
      &(lhs->motorcyclist), &(rhs->motorcyclist)))
  {
    return false;
  }
  // animal
  if (!etsi_its_cpm_ts_msgs__msg__VruSubProfileAnimal__are_equal(
      &(lhs->animal), &(rhs->animal)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__copy(
  const etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile * input,
  etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile * output)
{
  if (!input || !output) {
    return false;
  }
  // choice
  output->choice = input->choice;
  // pedestrian
  if (!etsi_its_cpm_ts_msgs__msg__VruSubProfilePedestrian__copy(
      &(input->pedestrian), &(output->pedestrian)))
  {
    return false;
  }
  // bicyclist_and_light_vru_vehicle
  if (!etsi_its_cpm_ts_msgs__msg__VruSubProfileBicyclist__copy(
      &(input->bicyclist_and_light_vru_vehicle), &(output->bicyclist_and_light_vru_vehicle)))
  {
    return false;
  }
  // motorcyclist
  if (!etsi_its_cpm_ts_msgs__msg__VruSubProfileMotorcyclist__copy(
      &(input->motorcyclist), &(output->motorcyclist)))
  {
    return false;
  }
  // animal
  if (!etsi_its_cpm_ts_msgs__msg__VruSubProfileAnimal__copy(
      &(input->animal), &(output->animal)))
  {
    return false;
  }
  return true;
}

etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile *
etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile * msg = (etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile));
  bool success = etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__destroy(etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence__init(etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile * data = NULL;

  if (size) {
    data = (etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile *)allocator.zero_allocate(size, sizeof(etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence__fini(etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence *
etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence * array = (etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence *)allocator.allocate(sizeof(etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence__destroy(etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence__are_equal(const etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence * lhs, const etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence__copy(
  const etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence * input,
  etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile * data =
      (etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cpm_ts_msgs__msg__VruProfileAndSubprofile__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
