// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/VruSubProfileAnimal.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_SUB_PROFILE_ANIMAL__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_SUB_PROFILE_ANIMAL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileAnimal__UNAVAILABLE = 0
};

/// Constant 'WILD_ANIMAL'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileAnimal__WILD_ANIMAL = 1
};

/// Constant 'FARM_ANIMAL'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileAnimal__FARM_ANIMAL = 2
};

/// Constant 'SERVICE_ANIMAL'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileAnimal__SERVICE_ANIMAL = 3
};

/// Constant 'MAX'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileAnimal__MAX = 15
};

/// Struct defined in msg/VruSubProfileAnimal in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__VruSubProfileAnimal
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the profile of an animal
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 `unavailable`     - to indicate that the information  is unavailable,
  ///  * - 1 `wild-animal`     - to indicate a animal living in the wildness,
  ///  * - 2 `farm-animal`     - to indicate an animal beloning to a farm,
  ///  * - 3 `service-animal`  - to indicate an animal that supports a human being.
  ///  * - 4 to 15             - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
  ///  *
  ///  * @category: VRU information
  ///  * @revision: Created in V2.1.1
  ///  */
  /// VruSubProfileAnimal ::= ENUMERATED {
  ///     unavailable    (0),
  ///     wild-animal    (1),
  ///     farm-animal    (2),
  ///     service-animal (3),
  ///     max            (15)
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_cpm_ts_msgs__msg__VruSubProfileAnimal;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__VruSubProfileAnimal.
typedef struct etsi_its_cpm_ts_msgs__msg__VruSubProfileAnimal__Sequence
{
  etsi_its_cpm_ts_msgs__msg__VruSubProfileAnimal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__VruSubProfileAnimal__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_SUB_PROFILE_ANIMAL__STRUCT_H_
