// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/WrappedCpmContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__WRAPPED_CPM_CONTAINER__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__WRAPPED_CPM_CONTAINER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'CHOICE_CONTAINER_DATA_ORIGINATING_VEHICLE_CONTAINER'.
enum
{
  etsi_its_cpm_ts_msgs__msg__WrappedCpmContainer__CHOICE_CONTAINER_DATA_ORIGINATING_VEHICLE_CONTAINER = 1
};

/// Constant 'CHOICE_CONTAINER_DATA_ORIGINATING_RSU_CONTAINER'.
enum
{
  etsi_its_cpm_ts_msgs__msg__WrappedCpmContainer__CHOICE_CONTAINER_DATA_ORIGINATING_RSU_CONTAINER = 2
};

/// Constant 'CHOICE_CONTAINER_DATA_SENSOR_INFORMATION_CONTAINER'.
enum
{
  etsi_its_cpm_ts_msgs__msg__WrappedCpmContainer__CHOICE_CONTAINER_DATA_SENSOR_INFORMATION_CONTAINER = 3
};

/// Constant 'CHOICE_CONTAINER_DATA_PERCEPTION_REGION_CONTAINER'.
enum
{
  etsi_its_cpm_ts_msgs__msg__WrappedCpmContainer__CHOICE_CONTAINER_DATA_PERCEPTION_REGION_CONTAINER = 4
};

/// Constant 'CHOICE_CONTAINER_DATA_PERCEIVED_OBJECT_CONTAINER'.
enum
{
  etsi_its_cpm_ts_msgs__msg__WrappedCpmContainer__CHOICE_CONTAINER_DATA_PERCEIVED_OBJECT_CONTAINER = 5
};

// Include directives for member types
// Member 'container_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/cpm_container_id__struct.h"
// Member 'container_data_originating_vehicle_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/originating_vehicle_container__struct.h"
// Member 'container_data_originating_rsu_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/originating_rsu_container__struct.h"
// Member 'container_data_sensor_information_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/sensor_information_container__struct.h"
// Member 'container_data_perception_region_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/perception_region_container__struct.h"
// Member 'container_data_perceived_object_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/perceived_object_container__struct.h"

/// Struct defined in msg/WrappedCpmContainer in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__WrappedCpmContainer
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF represents a CPM container preceded by its type identifier and a lenght indicator.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field containerId: the identifier of the container type.
  ///  *
  ///  * @field containerData: the container content consistent with the container type.
  ///  *
  /// */
  /// WrappedCpmContainer ::= SEQUENCE {
  ///    containerId     CPM-CONTAINER-ID-AND-TYPE.&id( {CpmContainers} ),
  ///    containerData   CPM-CONTAINER-ID-AND-TYPE.&Type( {CpmContainers}{@containerId} )
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cpm_ts_msgs__msg__CpmContainerId container_id;
  etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer container_data_originating_vehicle_container;
  etsi_its_cpm_ts_msgs__msg__OriginatingRsuContainer container_data_originating_rsu_container;
  etsi_its_cpm_ts_msgs__msg__SensorInformationContainer container_data_sensor_information_container;
  etsi_its_cpm_ts_msgs__msg__PerceptionRegionContainer container_data_perception_region_container;
  etsi_its_cpm_ts_msgs__msg__PerceivedObjectContainer container_data_perceived_object_container;
} etsi_its_cpm_ts_msgs__msg__WrappedCpmContainer;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__WrappedCpmContainer.
typedef struct etsi_its_cpm_ts_msgs__msg__WrappedCpmContainer__Sequence
{
  etsi_its_cpm_ts_msgs__msg__WrappedCpmContainer * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__WrappedCpmContainer__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__WRAPPED_CPM_CONTAINER__STRUCT_H_
