// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cpm_ts_msgs:msg/WrappedCpmContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__WRAPPED_CPM_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__WRAPPED_CPM_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'container_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/cpm_container_id__struct.hpp"
// Member 'container_data_originating_vehicle_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/originating_vehicle_container__struct.hpp"
// Member 'container_data_originating_rsu_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/originating_rsu_container__struct.hpp"
// Member 'container_data_sensor_information_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/sensor_information_container__struct.hpp"
// Member 'container_data_perception_region_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/perception_region_container__struct.hpp"
// Member 'container_data_perceived_object_container'
#include "etsi_its_cpm_ts_msgs/msg/detail/perceived_object_container__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__WrappedCpmContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cpm_ts_msgs__msg__WrappedCpmContainer __declspec(deprecated)
#endif

namespace etsi_its_cpm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct WrappedCpmContainer_
{
  using Type = WrappedCpmContainer_<ContainerAllocator>;

  explicit WrappedCpmContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : container_id(_init),
    container_data_originating_vehicle_container(_init),
    container_data_originating_rsu_container(_init),
    container_data_sensor_information_container(_init),
    container_data_perception_region_container(_init),
    container_data_perceived_object_container(_init)
  {
    (void)_init;
  }

  explicit WrappedCpmContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : container_id(_alloc, _init),
    container_data_originating_vehicle_container(_alloc, _init),
    container_data_originating_rsu_container(_alloc, _init),
    container_data_sensor_information_container(_alloc, _init),
    container_data_perception_region_container(_alloc, _init),
    container_data_perceived_object_container(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _container_id_type =
    etsi_its_cpm_ts_msgs::msg::CpmContainerId_<ContainerAllocator>;
  _container_id_type container_id;
  using _container_data_originating_vehicle_container_type =
    etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer_<ContainerAllocator>;
  _container_data_originating_vehicle_container_type container_data_originating_vehicle_container;
  using _container_data_originating_rsu_container_type =
    etsi_its_cpm_ts_msgs::msg::OriginatingRsuContainer_<ContainerAllocator>;
  _container_data_originating_rsu_container_type container_data_originating_rsu_container;
  using _container_data_sensor_information_container_type =
    etsi_its_cpm_ts_msgs::msg::SensorInformationContainer_<ContainerAllocator>;
  _container_data_sensor_information_container_type container_data_sensor_information_container;
  using _container_data_perception_region_container_type =
    etsi_its_cpm_ts_msgs::msg::PerceptionRegionContainer_<ContainerAllocator>;
  _container_data_perception_region_container_type container_data_perception_region_container;
  using _container_data_perceived_object_container_type =
    etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer_<ContainerAllocator>;
  _container_data_perceived_object_container_type container_data_perceived_object_container;

  // setters for named parameter idiom
  Type & set__container_id(
    const etsi_its_cpm_ts_msgs::msg::CpmContainerId_<ContainerAllocator> & _arg)
  {
    this->container_id = _arg;
    return *this;
  }
  Type & set__container_data_originating_vehicle_container(
    const etsi_its_cpm_ts_msgs::msg::OriginatingVehicleContainer_<ContainerAllocator> & _arg)
  {
    this->container_data_originating_vehicle_container = _arg;
    return *this;
  }
  Type & set__container_data_originating_rsu_container(
    const etsi_its_cpm_ts_msgs::msg::OriginatingRsuContainer_<ContainerAllocator> & _arg)
  {
    this->container_data_originating_rsu_container = _arg;
    return *this;
  }
  Type & set__container_data_sensor_information_container(
    const etsi_its_cpm_ts_msgs::msg::SensorInformationContainer_<ContainerAllocator> & _arg)
  {
    this->container_data_sensor_information_container = _arg;
    return *this;
  }
  Type & set__container_data_perception_region_container(
    const etsi_its_cpm_ts_msgs::msg::PerceptionRegionContainer_<ContainerAllocator> & _arg)
  {
    this->container_data_perception_region_container = _arg;
    return *this;
  }
  Type & set__container_data_perceived_object_container(
    const etsi_its_cpm_ts_msgs::msg::PerceivedObjectContainer_<ContainerAllocator> & _arg)
  {
    this->container_data_perceived_object_container = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t CHOICE_CONTAINER_DATA_ORIGINATING_VEHICLE_CONTAINER =
    1u;
  static constexpr uint8_t CHOICE_CONTAINER_DATA_ORIGINATING_RSU_CONTAINER =
    2u;
  static constexpr uint8_t CHOICE_CONTAINER_DATA_SENSOR_INFORMATION_CONTAINER =
    3u;
  static constexpr uint8_t CHOICE_CONTAINER_DATA_PERCEPTION_REGION_CONTAINER =
    4u;
  static constexpr uint8_t CHOICE_CONTAINER_DATA_PERCEIVED_OBJECT_CONTAINER =
    5u;

  // pointer types
  using RawPtr =
    etsi_its_cpm_ts_msgs::msg::WrappedCpmContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cpm_ts_msgs::msg::WrappedCpmContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::WrappedCpmContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cpm_ts_msgs::msg::WrappedCpmContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__WrappedCpmContainer
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cpm_ts_msgs__msg__WrappedCpmContainer
    std::shared_ptr<etsi_its_cpm_ts_msgs::msg::WrappedCpmContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const WrappedCpmContainer_ & other) const
  {
    if (this->container_id != other.container_id) {
      return false;
    }
    if (this->container_data_originating_vehicle_container != other.container_data_originating_vehicle_container) {
      return false;
    }
    if (this->container_data_originating_rsu_container != other.container_data_originating_rsu_container) {
      return false;
    }
    if (this->container_data_sensor_information_container != other.container_data_sensor_information_container) {
      return false;
    }
    if (this->container_data_perception_region_container != other.container_data_perception_region_container) {
      return false;
    }
    if (this->container_data_perceived_object_container != other.container_data_perceived_object_container) {
      return false;
    }
    return true;
  }
  bool operator!=(const WrappedCpmContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct WrappedCpmContainer_

// alias to use template instance with default allocator
using WrappedCpmContainer =
  etsi_its_cpm_ts_msgs::msg::WrappedCpmContainer_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t WrappedCpmContainer_<ContainerAllocator>::CHOICE_CONTAINER_DATA_ORIGINATING_VEHICLE_CONTAINER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t WrappedCpmContainer_<ContainerAllocator>::CHOICE_CONTAINER_DATA_ORIGINATING_RSU_CONTAINER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t WrappedCpmContainer_<ContainerAllocator>::CHOICE_CONTAINER_DATA_SENSOR_INFORMATION_CONTAINER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t WrappedCpmContainer_<ContainerAllocator>::CHOICE_CONTAINER_DATA_PERCEPTION_REGION_CONTAINER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t WrappedCpmContainer_<ContainerAllocator>::CHOICE_CONTAINER_DATA_PERCEIVED_OBJECT_CONTAINER;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cpm_ts_msgs

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__WRAPPED_CPM_CONTAINER__STRUCT_HPP_
